package com.sos.jobnet;

import com.sos.dialog.swtdesigner.SWTResourceManager;
import com.sos.graphviz.RGBColor;
import com.sos.jobnetmodel.objects.NodeStatus;
import com.sos.jobnet.db.JobNetDBItem;
import com.sos.jobnet.db.JobNetHistoryDBItem;
import com.sos.jobnet.db.JobNetPlanDBItem;
import com.sos.jobnet.db.JobNetTreeDBItem;
import com.sos.joe.globals.misc.ResourceManager;

import org.apache.log4j.Logger;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.TreeItem;


/**
* \class SchedulerJobNetTreeItem 
* 
* \brief SchedulerJobNetTreeItem - 
* 
* \details
*
* \section SchedulerJobNetTreeItem.java_intro_sec Introduction
*
* \section SchedulerJobNetTreeItem.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author Uwe Risse
* \version 14.08.2013
* \see reference
*
* Created on 14.08.2013 13:51:13
 */

public class SchedulerJobNetTreeItem extends TreeItem {
    @SuppressWarnings("unused")
    private final String     conClassName              = "SchedulerJobNetTreeItem";

    private JobNetDBItem     jobNetDBItem     = null;
    private JobNetPlanDBItem jobPlanNetDBItem = null;
    private JobNetHistoryDBItem jobNetHistoryDBItem = null;
    private static Logger    logger                    = Logger.getLogger(SchedulerJobNetTreeItem.class);
    private boolean          isJobNetNode;
    private boolean          isHistoryNode;

    public SchedulerJobNetTreeItem(Tree arg0, int arg1) {
        super(arg0, arg1);
    }

    public SchedulerJobNetTreeItem(TreeItem arg0, int arg1) {
        super(arg0, arg1);
    }

    protected void checkSubclass() {
        // Disable the check that prevents subclassing of SWT components
    }

    public JobNetTreeDBItem getData() {
        return (JobNetTreeDBItem) super.getData();
    }

    public void setDBItem(JobNetTreeDBItem d) {
        if (d instanceof JobNetDBItem) {
            jobNetDBItem = (JobNetDBItem) d;
        }
        if (d instanceof JobNetPlanDBItem) {
            jobPlanNetDBItem = (JobNetPlanDBItem) d;
        }
        if (d instanceof JobNetHistoryDBItem) {
            jobNetHistoryDBItem = (JobNetHistoryDBItem) d;
        }
        this.setData(d);
    }

    public void setColor(NodeStatus nodeStatus) {
        org.eclipse.swt.graphics.Color white = Display.getDefault().getSystemColor(SWT.COLOR_WHITE);
        org.eclipse.swt.graphics.Color black = Display.getDefault().getSystemColor(SWT.COLOR_BLACK);

        this.setForeground(black);
        this.setBackground(white);

        if (jobPlanNetDBItem != null) {
            String s = NodeStatus.valueOf(nodeStatus.getIndex()).toString().toLowerCase();
            
            setImage( ResourceManager.getImageFromResource("/com/sos/jobnetmodel/icons/" + "jobnet_" +s + ".png"));
            
            RGBColor rgbColor = jobPlanNetDBItem.getRGBColor(nodeStatus);
            Color itemColor = new Color(Display.getDefault(),rgbColor.getRed(),rgbColor.getGreen(),rgbColor.getBlue());
            this.setForeground(itemColor);
         }

        
    }


    public void setText() {
        JobNetDBItem d = jobNetDBItem;

        logger.debug("...creating treeItem: " + d.getJobNet() + ":" + getParent().getItemCount());

 
        this.setText(d.getJobNet());
    }

    public String getText() {
        return super.getText();
    }

    public boolean isJobNetNode() {
        return isJobNetNode;
    }
    

    public void setJobNetNode(boolean isJobNetNode) {
        this.isJobNetNode = isJobNetNode;
    }

    public boolean isHistoryNode() {
        return isHistoryNode;
    }

    public void setHistoryNode(boolean isHistoryNode) {
        this.isHistoryNode = isHistoryNode;
    }

}
