package com.sos.jobnet.classes;

/**
 * Created with IntelliJ IDEA.
 *
 * @uthor schaedi
 * at 09.09.13 17:16
 */
public enum ConditionType {
    EVENT         (1),
    PREDECESSOR   (2),
    ON_DEMAND     (3);

    private int statusValue;
    private ConditionTypeText text;

    private ConditionType(int status) {
        this.statusValue = status;
        this.text = new ConditionTypeText(this);
    }

    public Integer getIndex() {
        return statusValue;
    }

    public String getMsg() {
        return text.getMsg();
    }

    public static ConditionType valueOf(int index) {
        for(ConditionType s : ConditionType.values()) {
            if(s.getIndex() == index)
                return s;
        }
        throw new JobNetDAOException("The index " + index + " does not point to a valid NodeStatus.");
    }

    public boolean isEvent() {
        return(this == ConditionType.EVENT);
    }

    public boolean isPredecessor() {
        return(this == ConditionType.PREDECESSOR);
    }

}
