package com.sos.jobnet.classes;

public enum InternalJobNetError {
    PRECONDITIONS_MISSING(900),
    WAITER_ERROR(901),
    JOBNET_ABORTED(999);

    private final int exitCode;
    private final InternalJobNetErrorText text;

    private InternalJobNetError(int exitCode) {
        this.exitCode = exitCode;
        this.text = new InternalJobNetErrorText(this);
    }

    public Integer getExitCode() {
        return exitCode;
    }

    public String getMsg() {
        return text.getMsg();
    }

}
