package com.sos.jobnet.classes;

import com.sos.i18n.I18NBase;
import com.sos.i18n.annotation.I18NResourceBundle;

/**
 * @author ss
 *         at 02.09.13 - 15:00
 */
@I18NResourceBundle(baseName = "com_sos_jobnet_messages", defaultLocale = "en")
public class InternalJobNetErrorText extends I18NBase {

    private static final String	I18NMsgPrefix		= "JNETERROR_";
    private final Integer index;

    public InternalJobNetErrorText(InternalJobNetError status) {
        super(JobNetDAOConstants.strBundleBaseName);
        this.index = status.getExitCode();
    }

    public String getMsg() {
        return Messages.getMsg( msgKey(index) );
    }

    private String msgKey(int index) {
        return I18NMsgPrefix + JobNetDAOConstants.msgFormat.format(index);
    }

}
