package com.sos.jobnet.classes;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.sos.jobnet.db.JobNetPlanDBItem;
import com.sos.jobnetmodel.objects.NodeStatus;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.ArrayList;
import java.util.List;

/**
* \class JobNetNodesCollection 
* 
* \brief JobNetNodesCollection - 
* 
* \details
*
* \section JobNetNodesCollection.java_intro_sec Introduction
*
* \section JobNetNodesCollection.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author oh
* @version $Id$
* \see reference
*
* Created on 24.02.2012 12:40:58
 */

/**
 * @author oh
 *
 */
@JsonIgnoreProperties(ignoreUnknown=true)
public class JobNetCollection {

	private final String	conClassName	= "JobNetNodesCollection";

    @JsonIgnore
    public final String		conSVNVersion	= "$Id$";

	@SuppressWarnings("unused")
	private static final Logger		logger			= LoggerFactory.getLogger(JobNetCollection.class);
	private List<JobNetPlanDBItem>	items		= new ArrayList<JobNetPlanDBItem>();

	public JobNetCollection() {
		//
	}

    @JsonProperty("planDBItems")
	public List<JobNetPlanDBItem> getItems() {
		return items;
	}


	@JsonIgnore
    public String getItemsAsText() {
		StringBuffer result = new StringBuffer();
		for(JobNetPlanDBItem item : items) {
			if(result.length() > 0)
				result.append(", ");
            NodeStatus status = NodeStatus.valueOf(item.getStatusNode());
			result.append(String.format("%s(%s)", item.getJobnetNodeItem().getNode(), status.getMsg()));
		}
		return result.toString();
	}
	
	/**
	 * \brief add
	 * 
	 * \details
	 *
	 * @param item
	 */
	public void add(JobNetPlanDBItem item) {
		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::add";
		getItems().add(item);
	} // public void add
	
	public int size() {
		return items.size();
	}

	public JobNetPlanDBItem get(int i) {
		return getItems().get(i);
	}

}
