package com.sos.jobnet.classes;

import com.sos.i18n.I18NBase;
import com.sos.i18n.annotation.I18NResourceBundle;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * @author ss
 *         at 02.09.13 - 15:00
 */
@I18NResourceBundle(baseName = "com_sos_jobnet_messages", defaultLocale = "en")
public class JobNetStatusText extends I18NBase {

    private static final Logger logger				= LoggerFactory.getLogger(JobNetStatusText.class);

    private static final String	I18NMsgPrefix		= "JNETSTAT_T_000";

    private final Integer index;

    public JobNetStatusText(JobNetStatus status) {
        super(JobNetDAOConstants.strBundleBaseName);
        this.index = status.getIndex();
    }

    public String getMsg() {
        return Messages.getMsg( msgKey(index) );
    }

    private String msgKey(int index) {
        return I18NMsgPrefix + index;
    }

}
