package com.sos.jobnet.classes;

import com.sos.dialog.classes.SOSTableItem;
import com.sos.dialog.swtdesigner.SWTResourceManager;
import com.sos.graphviz.RGBColor;
import com.sos.hibernate.classes.DbItem;
import com.sos.hibernate.interfaces.ISOSTableItem;
import com.sos.jobnet.db.JobNetPlanDBItem;
import com.sos.jobnetmodel.objects.NodeStatus;
import com.sos.joe.globals.misc.ResourceManager;

import org.apache.log4j.Logger;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Table;

 
/**
* \class JobNetTableItem 
* 
* \brief JobNetTableItem - 
* 
* \details
*
* \section JobNetTableItem.java_intro_sec Introduction
*
* \section JobNetTableItem.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author Uwe Risse
* \version 14.12.2011
* \see reference
*
* Created on 14.12.2011 13:51:13
 */

public class SosJobNetPlanTableItem extends SOSTableItem implements ISOSTableItem {
    private JobNetPlanDBItem jobNetPlanDBItem = null;
    private String[]         textBuffer       = null;
    private static Logger    logger           = Logger.getLogger(SosJobNetPlanTableItem.class);



    public SosJobNetPlanTableItem(Table arg0, int arg1) {
        super(arg0, arg1);
    }

    protected void checkSubclass() {}

    public DbItem getData() {
        return (JobNetPlanDBItem) super.getData();
    }

    public void setDBItem(DbItem d) {
        jobNetPlanDBItem = (JobNetPlanDBItem) d;
        this.setData(d);
    }

    private void setColor(NodeStatus nodeStatus) {
        org.eclipse.swt.graphics.Color red = Display.getDefault().getSystemColor(SWT.COLOR_RED);
        org.eclipse.swt.graphics.Color white = Display.getDefault().getSystemColor(SWT.COLOR_WHITE);
        org.eclipse.swt.graphics.Color black = Display.getDefault().getSystemColor(SWT.COLOR_BLACK);
        org.eclipse.swt.graphics.Color yellow = Display.getDefault().getSystemColor(SWT.COLOR_YELLOW);

 
        this.setBackground(white);

        this.setForeground(black);
        this.setBackground(white);

        if (jobNetPlanDBItem != null) {
            RGBColor rgbColor = jobNetPlanDBItem.getRGBColor(nodeStatus);
            Color itemColor = new Color(Display.getDefault(),rgbColor.getRed(),rgbColor.getGreen(),rgbColor.getBlue());
            this.setBackground(0,itemColor);
          }
        
        if (jobNetPlanDBItem.getIsRunnerOnDemand()) {
            this.setBackground(6, yellow);
        }

        if (jobNetPlanDBItem.getIsWaiterSkipped()) {
            this.setBackground(7, yellow);
        }

        if (jobNetPlanDBItem.getIsRunnerSkipped()) {
            this.setBackground(8, yellow);
        }
        if (jobNetPlanDBItem.getIsDispatcherSkipped()) {
            this.setBackground(9, yellow);
        }
        
      
        
        colorSave();
        
    }
    
    public void setColor(String nodeStatus){
        try {
            
            int s = Integer.parseInt(jobNetPlanDBItem.getStatusValue());
            setColor(NodeStatus.valueOf(s));
            
        }catch(Exception e) {
            
        }
    }
    
    public void setColor() {
        setColor(jobNetPlanDBItem.getStatusValue());
    }



    private void setImage(int column, Boolean checked) {
       
        
        Image checkedImage =  ResourceManager.getImageFromResource("/sos/scheduler/editor/icons/config.gif");
        Image uncheckedImage =  ResourceManager.getImageFromResource("/sos/scheduler/editor/icons/thin_close_view.gif");
        
        if (checked) {
            this.setImage(column, checkedImage);
        }else {
            this.setImage(column, uncheckedImage);
        }

    }
    public void setColumns() {
       
        JobNetPlanDBItem d = jobNetPlanDBItem;

        logger.debug("...creating tableItem: " + d.getPlanId() + ":" + getParent().getItemCount());

        textBuffer = new String[] { " ", 
                String.valueOf(d.getJobNetNodeDBItem().getNode()), 
                NodeStatus.valueOf(d.getStatusNode()).getMsg() ,
                String.valueOf(d.getStatusWaiter()), 
                String.valueOf(d.getStatusRunner()),
                String.valueOf(d.getStatusDispatcher()),
                "",
                "",
                "", 
                "",

                d.getPlannedStartTimeFormated(),
                d.getStartTimeFormated(), 
                d.getEndTimeFormated(), 
                d.getMessage(), 
                String.valueOf(d.getExitCode()), 
                d.getExitMessage() 
        
        
        
        };
        this.setText(textBuffer);
        
        setImage(6,d.getIsRunnerOnDemand());
        setImage(7,d.getIsWaiterSkipped());
        setImage(8,d.getIsRunnerSkipped());
        setImage(9,d.getIsDispatcherSkipped());
        

    }

    public String[] getTextBuffer() {
        return textBuffer;
    }

    @SuppressWarnings("unused")
    private final String conClassName = "JobNetTableItem";

    @Override
    public Color getBackground() {
        return null;
    }

    @Override
    public Color getForeground() {
        return null;
    }

    @Override
    public Color[] getBackgroundColumn() {
        return colorsBackground;
    }

    @Override
    public Color[] getForegroundColumn() {
        return colorsForeground;
    }

}
