package com.sos.jobnet.creator.jobs;

import com.sos.jobnet.classes.JobNetException;
import com.sos.jobnet.creator.JobNetPlanExecutor;
import com.sos.jobnet.db.JobNetPlanDBItem;
import com.sos.jobnet.interfaces.IJobSchedulerAdapter;
import com.sos.jobnet.options.JobNetCreatorOptions;
import com.sos.jobnet.options.StartBehaviour;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import sos.spooler.Spooler;

/**
 * Created with IntelliJ IDEA.
 *
 * @uthor schaedi
 * at 11.09.13 07:37
 */
public class JobNetJobAdapterClass extends JobNetJobAdapterLogBackClass implements IJobSchedulerAdapter {

    private static Logger logger = LoggerFactory.getLogger(JobNetJobAdapterClass.class);

    private JobNetCreatorOptions options = new JobNetCreatorOptions();
    private JobNetPlanExecutor executor;

    @Override
    public boolean spooler_init() {

        boolean result = super.spooler_init();

        try {
            options = new JobNetCreatorOptions();
            options.setAllOptions(getAllParametersAsProperties());
            options.CheckMandatory();
            logger.debug(options.toString());
        } catch(Exception e) {
            throw new JobNetException("Error retrieving JobNetCreatorOptions for job.",e);
        }

        try {
            this.executor = new JobNetPlanExecutor(options);
            executor.registerOrderStarter(this);
        } catch(Exception e) {
            throw new JobNetException("Error to create an instance of JobNetPlanExecutor.",e);
        }

        return result;
    }

    @Override
    public boolean spooler_process() throws Exception {
        super.spooler_process();
        return (spooler_task.job().order_queue() != null);

    }

    @Override
    public boolean spooler_task_before() throws Exception {
        return super.spooler_task_before();
    }

    @Override
    public void setOrderStateText(String text) {
        spooler_task.order().set_state_text( (text.length() > 100) ? text.substring(0,97) + "..." : text );
    }

    @Override
    public JobNetCreatorOptions getOptions() {
        return options;
    }

    @Override
    public Spooler getSpooler() {
        return spooler;
    }

    @Override
    public void startOrder(JobNetPlanDBItem bootDBItem, StartBehaviour startBehaviour) {
        executor.startOrderViaJobScheduler(bootDBItem, startBehaviour);
    }

    @Override
    public void resumeOrder() {
        //To change body of implemented methods use File | Settings | File Templates.
    }

}
