package com.sos.jobnet.creator.jobs;

import com.sos.jobnet.creator.JobNetPlanExecutor;
import com.sos.jobnet.options.JobNetCreatorOptions;
import com.sos.tools.logback.LogbackHelper;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import sos.scheduler.job.JobSchedulerJobAdapter;

/**
 * Created with IntelliJ IDEA.
 *
 * @uthor schaedi
 * at 11.09.13 07:37
 */
public class JobNetJobAdapterLogBackClass extends JobSchedulerJobAdapter {

    private static Logger logger = LoggerFactory.getLogger(JobNetJobAdapterLogBackClass.class);

    private JobNetCreatorOptions options = new JobNetCreatorOptions();
    private JobNetPlanExecutor executor;

    private static boolean logbackWarningPublished = false;

    @Override
    public boolean spooler_init() {
        initializeLogback();
        return super.spooler_init();
    }

    @Override
    public boolean spooler_process() throws Exception {
        initializeLogback();
        return super.spooler_process();
    }

    @Override
    public boolean spooler_task_before() throws Exception {
        initializeLogback();
        return super.spooler_task_before();
    }

    @Override
    public void spooler_task_after() throws Exception {
        initializeLogback();
        super.spooler_task_after();
    }

    @Override
    public boolean spooler_process_before() throws Exception {
        initializeLogback();
        return super.spooler_process_before();
    }

    @Override
    public boolean spooler_process_after(final boolean spooler_process_result) throws Exception {
        initializeLogback();
        return super.spooler_process_after(spooler_process_result);
    }

    private void initializeLogback() {
        try {
            if (LogbackHelper.isLogbackConfigured()) {
                LogbackHelper.prepareLogbackAppender( spooler_log );
            } else
            if (!logbackWarningPublished) {
                spooler_log.warn("JobScheduler is not configured with logback - maybe some logging features are not supported.");
                logbackWarningPublished = true;
            }
        } catch (Exception e) {
        }
    }

}
