package com.sos.jobnet.creator.jobs;

import com.sos.JSHelper.Exceptions.JobSchedulerException;
import com.sos.jobnet.creator.JobNetPlanCreator;
import com.sos.jobnet.options.JobNetCreatorOptions;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
 * \class 		JobNetPlanCreatorJSAdapterClass - JobScheduler Adapter for "creates the job net instance for a given bootstrap order"
 */
public class JobNetPlanCreatorJSAdapterClass extends JobNetJobAdapterClass {
	
	private final String conClassName = "JobNetCreatorJSAdapterClass";

	private static Logger logger = LoggerFactory.getLogger(JobNetPlanCreatorJSAdapterClass.class);
	private JobNetCreatorOptions options = null;;
	
	@SuppressWarnings("unused")
	private	final String conSVNVersion = "$Id: JobNetPlanCreatorJSAdapterClass.java 16850 2012-03-21 12:14:23Z ss $";
	
	private JobNetPlanCreator creator = null;

	@Override
	public boolean spooler_init() {
		return super.spooler_init();
	}

	@Override
	public boolean spooler_process() throws Exception {

		final String conMethodName = conClassName + "::spooler_process"; //$NON-NLS-1$

		try {
			super.spooler_process();
			logger.debug(String.format(Messages.getMsg("JSJ-I-110"), conMethodName ) );
			options = new JobNetCreatorOptions();
			options.setAllOptions(getAllParametersAsProperties());
			options.CheckMandatory();
			logger.info(options.toString());
			creator = new JobNetPlanCreator(options);
			creator.registerJSAdapter(this);
			creator.run();
			logger.debug(String.format(Messages.getMsg("JSJ-I-111"), conMethodName ) );
		} catch (Exception e) {
            spooler_task.set_error(e.getMessage());
            // spooler_task.order().set_state_text(e.getMessage());
			throw new JobSchedulerException(e.getMessage(),e);
		} finally {
            creator.closeSession();
        }
        return (spooler_task.job().order_queue() != null);

	}

	@Override
	public void spooler_exit() {
		@SuppressWarnings("unused") //$NON-NLS-1$
		final String conMethodName = conClassName + "::spooler_exit"; //$NON-NLS-1$
		super.spooler_exit();
	}
	
	public JobNetCreatorOptions getOptions() {
		return options;
	}

	@Override
	public void setCC(int arg0) {
		// TODO Auto-generated method stub
		
	}

    /*
	@Override
	public void startOrderImmediately(JobNetPlanDBItem item) {
		startOrderViaJobScheduler(spooler, item, true);
    }

	@Override
	public void startOrder(JobNetPlanDBItem item) {
		startOrderViaJobScheduler(spooler, item, false);
	}

	@Override
	public void startOrderViaJobScheduler(Spooler spooler, JobNetPlanDBItem bootDBItem, boolean startImmediately) {
		creator.startOrderViaJobScheduler(spooler,bootDBItem, startImmediately);
	}
	*/

}

