package com.sos.jobnet.creator.jobs;

import com.sos.JSHelper.Exceptions.JobSchedulerException;
import com.sos.jobnet.creator.JobNetPlanRestarter;
import com.sos.jobnet.options.JobNetCreatorOptions;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
 * This job is for restart a given jobnet instance identified by its uuid.
 * 
 * @author ss
 */
public class JobNetPlanRestarterJSAdapterClass extends JobNetJobAdapterClass {
	
	private static Logger logger = LoggerFactory.getLogger(JobNetPlanRestarterJSAdapterClass.class);
	
	private JobNetCreatorOptions options;
	
	@SuppressWarnings("unused")
	private	final String conSVNVersion = "$Id: JobNetPlanRestarterJSAdapterClass.java 16850 2012-03-21 12:14:23Z ss $";
	
	private JobNetPlanRestarter restarter = null;

	@Override
	public boolean spooler_init() {
		return super.spooler_init();
	}

	@Override
	public boolean spooler_process() throws Exception {

		final String conMethodName = this.getClass().getSimpleName() + "::spooler_process"; //$NON-NLS-1$

		try {
			super.spooler_process();

			options = new JobNetCreatorOptions();
			options.setAllOptions(getAllParametersAsProperties());
			options.CheckMandatory();
			logger.debug(options.toString());
			
			restarter = new JobNetPlanRestarter(options);
			restarter.registerOrderStarter(this);
			restarter.run();
			logger.debug(String.format(Messages.getMsg("JSJ-I-111"), conMethodName ) );
		}
		catch (Exception e) {
			String msgText = String.format(Messages.getMsg("JSJ-I-107"), conMethodName );
            spooler_task.set_error(e.getMessage());
            spooler_log.error(e.getMessage());
			throw new JobSchedulerException(msgText,e);
		} finally {
            restarter.closeSession();
        }
		return (spooler_task.job().order_queue() != null);

	}

	@Override
	public void spooler_exit() {
		super.spooler_exit();
	}
	
	public JobNetCreatorOptions getOptions() {
		return options;
	}

	@Override
	public void setCC(int arg0) {
		// TODO Auto-generated method stub
		
	}

    /*
	@Override
	public void startOrderImmediately(JobNetPlanDBItem item) {
		startOrderViaJobScheduler(spooler, item, true);
	}

	@Override
	public void startOrder(JobNetPlanDBItem item) {
		startOrderViaJobScheduler(spooler, item, true);
	}

	@Override
	public void startOrderViaJobScheduler(Spooler spooler, JobNetPlanDBItem bootDBItem, boolean startImmediately) {
		restarter.startOrderViaJobScheduler(spooler, bootDBItem, startImmediately);
	}
	*/

}

