package com.sos.jobnet.creator.jobs;

import com.sos.JSHelper.Exceptions.JobSchedulerException;
import com.sos.jobnet.creator.JobNetProcessor;
import com.sos.jobnet.options.JobNetCreatorOptions;

/**
 * JobScheduler Adapter for JobNetProcessor
 */
public class JobNetProcessorJSAdapterClass extends JobNetJobAdapterClass {

	@SuppressWarnings("unused")
	private	final String conSVNVersion = "$Id: JobNetProcessorJSAdapterClass.java 16850 2012-03-21 12:14:23Z ss $";
	
	private JobNetCreatorOptions options = new JobNetCreatorOptions();
    JobNetProcessor processor = null;

	@Override
	public boolean spooler_process() throws Exception {
		
		final String conMethodName = this.getClass().getSimpleName() + "::spooler_process"; //$NON-NLS-1$
		
		try {
			super.spooler_process();
			processor = new JobNetProcessor(getOptions());
            processor.registerJSAdapter(this);
            processor.createSchedulerInstance();
			processor.run();
		}
		catch (Exception e) {
			String msgText = String.format(Messages.getMsg("JSJ-I-107"), conMethodName );
            spooler_task.set_error(e.getMessage());
            setOrderStateText(e.getMessage());
            processor.setMessage(e.getMessage());
			throw new JobSchedulerException(msgText + ": " + e.getMessage(),e);
		}
        finally {
            processor.closeSession();
        }

		return (spooler_task.job().order_queue() != null);

	}

}

