package com.sos.jobnet.dataprovider;

import java.io.File;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.prefs.Preferences;

import org.apache.log4j.Logger;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.CCombo;
import org.eclipse.swt.widgets.Table;
import org.hibernate.Session;

import com.sos.hibernate.classes.DbItem;
import com.sos.hibernate.classes.SOSSearchFilterData;
import com.sos.hibernate.interfaces.ISOSDashboardDataProvider;
import com.sos.hibernate.interfaces.ISOSHibernateDataProvider;
import com.sos.jobnet.classes.SosJobNetCmdHistoryTableItem;
import com.sos.jobnet.classes.SosJobNetPlanTableItem;
import com.sos.jobnet.db.JobNetCmdHistoryDBItem;
import com.sos.jobnet.db.JobNetCmdHistoryDBLayer;
import com.sos.jobnet.db.JobNetCmdHistoryFilter;
import com.sos.jobnet.db.JobNetDBItem;
import com.sos.jobnet.db.JobNetDBLayer;
import com.sos.jobnet.db.JobNetPlanDBItem;
import com.sos.jobnet.db.JobNetPlanDBLayer;
import com.sos.jobnet.db.JobNetPlanFilter;


/**
 * \class JobNetCommandHistoryDataProvider
 * 
 * \brief JobNetCmdHistoryDataProvider -
 * 
 * \details
 * 
 * \section JobNetCommandHistoryDataProvider.java_intro_sec Introduction
 * 
 * \section JobNetCommandHistoryDataProvider.java_samples Some Samples
 * 
 * \code .... code goes here ... \endcode
 * 
 * <p style="text-align:center">
 * <br />
 * --------------------------------------------------------------------------- <br />
 * APL/Software GmbH - Berlin <br />
 * ##### generated by ClaviusXPress (http://www.sos-berlin.com) ######### <br />
 * ---------------------------------------------------------------------------
 * </p>
 * \author Uwe Risse \version 19.01.2012 \see reference
 * 
 * Created on 19.01.2012 09:31:01
 */

public class JobNetCmdHistoryDataProvider implements ISOSHibernateDataProvider, ISOSDashboardDataProvider {

    @SuppressWarnings("unused")
    private final String conClassName = "JobNetCommandHistoryDataProvider";

    private List<JobNetCmdHistoryDBItem> listOfJobNetCmdHistoryDBItems = null;
    private JobNetCmdHistoryDBLayer jobNetCmdHistoryDBLayer = null;
    private static Logger logger = Logger.getLogger(JobNetCmdHistoryDataProvider.class);
    private Table tableJobNetPlan = null;

    public JobNetCmdHistoryDataProvider(File configurationFile, String schedulerId) {
        this.jobNetCmdHistoryDBLayer = new JobNetCmdHistoryDBLayer(configurationFile, schedulerId);
    }

    public JobNetCmdHistoryDataProvider(File configurationFile) {
        this.jobNetCmdHistoryDBLayer = new JobNetCmdHistoryDBLayer(configurationFile);
    }
    
    public JobNetCmdHistoryFilter getFilter() {
        return jobNetCmdHistoryDBLayer.getFilter();
    }

    public void resetFilter() {
        jobNetCmdHistoryDBLayer.setFilter(new JobNetCmdHistoryFilter());
    }

    public void getData(int limit) {
        listOfJobNetCmdHistoryDBItems = jobNetCmdHistoryDBLayer.getJobNetCmdHistoryList(limit);
    }

    public void fillSchedulerIds(CCombo cbSchedulerId) {
        if (tableJobNetPlan != null) {
            Iterator jobNetPlanEntries = listOfJobNetCmdHistoryDBItems.iterator();
            while (jobNetPlanEntries.hasNext()) {
                JobNetPlanDBItem h = (JobNetPlanDBItem) jobNetPlanEntries.next();
                if (cbSchedulerId.indexOf(h.getJobnetNodeDBItem().getSchedulerId()) < 0) {
                    logger.debug("... cbSchedulerId --> : " + h.getJobnetNodeDBItem().getSchedulerId());
                    cbSchedulerId.add(h.getJobnetNodeDBItem().getSchedulerId());
                }
            }
        }
    }

   

    public void fillTable(Table table) {
        this.tableJobNetPlan = table;
        Iterator<JobNetCmdHistoryDBItem> jobnetCmdHistoryEntries = listOfJobNetCmdHistoryDBItems.iterator();
        while (jobnetCmdHistoryEntries.hasNext()) {
            DbItem h = jobnetCmdHistoryEntries.next();
            if (jobNetCmdHistoryDBLayer.getFilter().isFiltered(h)) {
            } else {

                final SosJobNetCmdHistoryTableItem newItemTableItem = new SosJobNetCmdHistoryTableItem(table, SWT.BORDER);
                newItemTableItem.setDBItem(h);
                newItemTableItem.setData(h);
                newItemTableItem.setColor();
                newItemTableItem.setColumns();
            }
        }
    }

    public File getConfigurationFile() {
        return jobNetCmdHistoryDBLayer.getConfigurationFile();

    }

    @Override
    public void beginTransaction() {
        jobNetCmdHistoryDBLayer.beginTransaction();
    }

    public void save(JobNetPlanDBItem dbItem) {
        jobNetCmdHistoryDBLayer.beginTransaction();
        jobNetCmdHistoryDBLayer.saveOrUpdate(dbItem);
        jobNetCmdHistoryDBLayer.commit();
    }

    @Override
    public void update(DbItem dbItem) {
        jobNetCmdHistoryDBLayer.update(dbItem);
    }

    public Session getSession() {
        return jobNetCmdHistoryDBLayer.getSession();
    }

    @Override
    public void commit() {
        jobNetCmdHistoryDBLayer.commit();
    }

    @Override
    public void setSchedulerId(String schedulerId) {
     }

    @Override
    public void setFrom(Date d) {
     }

    @Override
    public void setTo(Date d) {
     }

    @Override
    public void setSearchField(SOSSearchFilterData s) {
     }

    @Override
    public void setShowJobs(boolean b) {
     }

    @Override
    public void setShowJobChains(boolean b) {
     }

    @Override
    public void setIgnoreList(Preferences prefs) {
     }

    @Override
    public void addToIgnorelist(Preferences prefs, DbItem h) {
     }

    @Override
    public void disableIgnoreList(Preferences prefs) {
     }

    @Override
    public void resetIgnoreList(Preferences prefs) {
     }

    @Override
    public void setLate(boolean b) {
     }

    @Override
    public void setStatus(String status) {
     }

    @Override
    public void setShowWithError(boolean b) {
        // TODO Auto-generated method stub
        
    }

	@Override
	public void setShowRunning(boolean b) {
		// TODO Auto-generated method stub
		
	}

}
