package com.sos.jobnet.db;

import com.sos.hibernate.classes.DbItem;
import com.sos.jobnet.classes.ConditionState;
import com.sos.jobnet.classes.ConditionType;
import org.hibernate.annotations.Type;
import org.joda.time.DateTime;

import javax.persistence.*;

@Entity
@Table(name="SCHEDULER_JOB_NET_CONDITIONS")
public class ConditionsDBItem extends DbItem {

	private long conditionId;
	private long planId;
	private ConditionType conditionType;
	private String conditionName;
	private ConditionState conditionState;
    private String note;
    private String mailToOnApprove;
	private DateTime changedAt;
    private String changedBy;
    private DateTime missedFrom;
    private DateTime finishedAt;

	public ConditionsDBItem() {
		super();
	}

    @Id
    @GeneratedValue(strategy=GenerationType.AUTO)
    @Column(name="CONDITION_ID")
    public Long getId() {
		return conditionId;
	}

	@Column(name="CONDITION_ID")
    public void setId(Long conditionId) {
		this.conditionId = conditionId;
	}
      
    @Column(name="PLAN_ID")
	public void setPlanId(long nodeId) {
		this.planId = nodeId;
	}
    
    @Column(name="PLAN_ID")
	public long getPlanId() {
		return planId;
	}
    
    @Column(name="CONDITION_TYPE")
    @Type(type="com.sos.jobnet.db.types.CompositeConditionType")
	public void setConditionType(ConditionType conditionType) {
		this.conditionType = conditionType;
	}
 
    @Column(name="CONDITION_TYPE")
    @Type(type="com.sos.jobnet.db.types.CompositeConditionType")
	public ConditionType getConditionType() {
		return conditionType;
	} 
    
    @Column(name="CONDITION")
    public String getConditionName() {
		return conditionName;
	}

	@Column(name="CONDITION")
    public void setConditionName(String conditionName) {
		this.conditionName = conditionName;
	}

    @Column(name="NOTE")
    public String getNote() {
		return note;
	}

	@Column(name="NOTE")
    public void setNote(String note) {
		this.note = note;
	}

    @Column(name="MAIL_TO_ON_APPROVE")
    public String getMailToOnApprove() {
		return mailToOnApprove;
	}

	@Column(name="MAIL_TO_ON_APPROVE")
    public void setMailToOnApprove(String mailTo) {
		this.mailToOnApprove = mailTo;
	}

    @Column(name="CONDITION_STATE")
    @Type(type="com.sos.jobnet.db.types.CompositeConditionState")
    public void setConditionState(ConditionState conditionStatus) {
        this.conditionState = conditionStatus;
    }

    @Column(name="CONDITION_STATE")
    @Type(type="com.sos.jobnet.db.types.CompositeConditionState")
    public ConditionState getConditionState() {
        return conditionState;
    }

    @Column(name="CHANGED_AT",nullable=true)
    @Type(type="org.joda.time.contrib.hibernate.PersistentDateTime")
	public void setChangedAt(DateTime changed) {
		this.changedAt = changed;
	}
 
    @Column(name="CHANGED_AT",nullable=true)
    @Type(type="org.joda.time.contrib.hibernate.PersistentDateTime")
	public DateTime getChangedAt() {
		return changedAt;
	}

    @Column(name="MISSED_FROM",nullable=true)
    @Type(type="org.joda.time.contrib.hibernate.PersistentDateTime")
	public void setMissedFrom(DateTime missedFrom) {
		this.missedFrom = missedFrom;
	}

    @Column(name="MISSED_FROM",nullable=true)
    @Type(type="org.joda.time.contrib.hibernate.PersistentDateTime")
	public DateTime getMissedFrom() {
		return missedFrom;
	}

    @Column(name="FINISHED_AT",nullable=true)
    @Type(type="org.joda.time.contrib.hibernate.PersistentDateTime")
	public void setFinishedAt(DateTime finishedAt) {
		this.finishedAt = finishedAt;
	}

    @Column(name="FINISHED_AT",nullable=true)
    @Type(type="org.joda.time.contrib.hibernate.PersistentDateTime")
	public DateTime getFinishedAt() {
		return finishedAt;
	}

    @Column(name="CHANGED_BY", nullable = true)
    public String getChangedBy() {
        return changedBy;
    }

    @Column(name="CHANGED_BY", nullable = true)
    public void setChangedBy(String changedBy) {
        this.changedBy = changedBy;
    }

    @Transient
    public boolean isEventCondition() {
        return (getConditionType() == ConditionType.EVENT);
    }

    @Transient
    public boolean isPredecessorCondition() {
        return (getConditionType() == ConditionType.PREDECESSOR);
    }

    @Transient
    public boolean isConditionIgnored() {
        return (getConditionState() == ConditionState.IGNORED);
    }

    @Transient
    public boolean isConditionFulfilled() {
        return (getConditionState() == ConditionState.FULFILLED);
    }

    @Transient
    public boolean isConditionMissing() {
        return (getConditionState() == ConditionState.MISSING);
    }

}
