package com.sos.jobnet.db;

import com.sos.hibernate.classes.DbItem;
import com.sos.hibernate.classes.SOSHibernateFilter;
import org.joda.time.DateTime;
import org.joda.time.format.DateTimeFormat;
import org.joda.time.format.DateTimeFormatter;

import java.text.ParseException;


/**
* \class JobNetCmdHistoryFilter 
* 
* \brief JobNetCmdHistoryFilter - 
* 
* \details
*
* \section JobNetCmdHistoryFilter.java_intro_sec Introduction
*
* \section JobNetCmdHistoryFilter.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author Uwe Risse
* \version 13.08.2013
* \see reference
*
* Created on 13.08.2013 13:53:37
 */

public class JobNetCmdHistoryFilter extends SOSHibernateFilter implements com.sos.hibernate.interfaces.ISOSHibernateFilter {
 

	@SuppressWarnings("unused")
	private final String	conClassName	= "JobNetCmdHistoryFilter";
	public  final String	conSVNVersion	= "$Id: JobNetCmdHistoryFilter.java 20187 2013-05-17 14:48:22Z ss $";
	private static String dateFormat         = "yyyy-MM-dd HH:mm:ss";
    private static DateTimeFormatter formatter = DateTimeFormat.forPattern(dateFormat);

    private Long cmdHistoryId;
    private Long historyId;
    private String startOption="";
    private String uuid="";
 	private String nodeType="";
    private DateTime startTimeFrom;
    private DateTime startTimeTo;
	 
    private String searchField;

 
	public void setStartTimeFrom(DateTime startTimeFrom) {
		this.startTimeFrom = startTimeFrom;
	}

	public void setStartTimeFrom(String startTimeFrom) throws ParseException {
	    if (startTimeFrom.equals("")) {
            this.startTimeFrom = null;
        }
        else {
            DateTime d = formatter.parseDateTime(startTimeFrom);
            setStartTimeFrom(d);
        }
	}

	public void setStartTimeFrom(String startTimeFrom, String dateFormat) throws ParseException {
		this.dateFormat = dateFormat;
		setStartTimeFrom(startTimeFrom);
		}
		 
	public void setStartTimeTo(String startTimeTo, String dateFormat) throws ParseException {
		this.dateFormat = dateFormat;
		setStartTimeTo(startTimeTo);
		}


	public void setStartTimeTo(DateTime startTimeTo) {
		this.startTimeTo  = startTimeTo;
	}

	public void setStartTimeTo(String startTimeTo) throws ParseException {
        if (startTimeTo.equals("")) {
            this.startTimeTo = null;
        }
        else {
            DateTime d = formatter.parseDateTime(startTimeTo);
            setStartTimeTo(d);
        }
		}

	   public DateTime getStartTimeFrom() {
	        return startTimeFrom;
	    }

	    public DateTime getStartTimeTo() {
	        return startTimeTo;
	    }
 
	@Override
	public String getTitle() {
 		return "";
	}

	@Override
	public boolean isFiltered(DbItem h) {
		return false;
 	}

    public String getDateFormat() {
        return dateFormat;
    }

    public void setDateFormat(String dateFormat) {
        this.dateFormat = dateFormat;
    }

    public Long getHistoryId() {
        return historyId;
    }

    public void setHistoryId(Long historyId) {
        this.historyId = historyId;
    }

    public Long getCmdHistoryId() {
        return cmdHistoryId;
    }

    public void setCmdHistoryId(Long cmdHistoryId) {
        this.cmdHistoryId = cmdHistoryId;
    }
      
    
    
    public String getSearchField() {
        return searchField;
    }

    public void setSearchField(String searchField) {
        this.searchField = searchField;
    }

    public String getStartOption() {
        return startOption;
    }

    public void setStartOption(String startOption) {
        this.startOption = startOption;
    }

    public String getNodeType() {
        return nodeType;
    }

    public void setNodeType(String nodeType) {
        this.nodeType = nodeType;
    }

    public String getUuid() {
        return uuid;
    }

    public void setUuid(String uuid) {
        this.uuid = uuid;
    }


 
	 
	
	
}
