package com.sos.jobnet.db;

import com.sos.hibernate.layer.SOSHibernateDBLayer;
import org.hibernate.Query;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.File;
import java.util.List;

// import org.slf4j.Logger;

/**
 * \class SchedulerJobNetDBLayer \brief SchedulerJobNetDBLayer -
 * <p/>
 * \details
 * <p/>
 * \section SchedulerJobNetDBLayer.java_intro_sec Introduction
 * <p/>
 * \section SchedulerJobNetDBLayer.java_samples Some Samples
 * <p/>
 * \code .... code goes here ... \endcode
 * <p/>
 * <p style="text-align:center">
 * <br />
 * --------------------------------------------------------------------------- <br />
 * APL/Software GmbH - Berlin <br />
 * ##### generated by ClaviusXPress (http://www.sos-berlin.com) ######### <br />
 * ---------------------------------------------------------------------------
 * </p>
 * \author Uwe Risse \version 13.08.2013 \see reference
 * <p/>
 * Created on 13.08.2013 14:40:18
 */

public class JobNetDBLayer extends SOSHibernateDBLayer {

    private static final String DATE_FORMAT = "yyyy-MM-dd HH:mm:ss";

    private static final String NET_ID = "netId";
    private static final String JOBNET = "jobNet";
    private static final String SCHEDULER_ID = "schedulerId";

    private final static Logger logger = LoggerFactory.getLogger(JobNetDBLayer.class);

    @SuppressWarnings("unused")
    private final String conClassName = "SchedulerJobNetDBLayer";
    public final String conSVNVersion = "$Id: SchedulerJobNetDBLayer.java 20037 2013-05-03 04:55:36Z ss $";


    private JobNetFilter filter = null;

    public JobNetDBLayer(File configurationFile_, String schedulerId_) {
        super();

        this.filter = new JobNetFilter();

        this.filter.setSchedulerId(schedulerId_);

        this.setConfigurationFile(configurationFile_);
        this.filter = new JobNetFilter();
        this.filter.setDateFormat(DATE_FORMAT);
        this.filter.setOrderCriteria(JOBNET);
        this.filter.setSchedulerId(schedulerId_);
    }

    public JobNetDBLayer(File configurationFile_) {
        super();
        this.filter = new JobNetFilter();

        this.setConfigurationFile(configurationFile_);
        this.filter = new JobNetFilter();
        this.filter.setDateFormat(DATE_FORMAT);
        this.filter.setOrderCriteria(JOBNET);
    }

    private Query setQueryParams(String hql) {
        Query query = session.createQuery(hql);


        if (filter.getSchedulerId() != null && !filter.getSchedulerId().equals("")) {
            query.setParameter(SCHEDULER_ID, filter.getSchedulerId());
        }


        if (filter.getNetId() != null) {
            query.setParameter(NET_ID, filter.getNetId());
        }

        if (filter.getJobnet() != null) {
            query.setParameter(JOBNET, filter.getJobnet());
        }
/*
        if (filter.getStatus() != null && !filter.getStatus().equals("")) {
            query.setInteger(STATUS, filter.getStatus());
        }

        if (filter.getStatusWaiter() != null && !filter.getStatusWaiter().equals("")) {
            query.setInteger(STATUS_WAITER, filter.getStatusWaiter());
        }

        if (filter.getStatusRunner() != null && !filter.getStatusRunner().equals("")) {
            query.setInteger(STATUS_RUNNER, filter.getStatusRunner());
        }

        if (filter.getStatusDispatcher() != null && !filter.getStatusDispatcher().equals("")) {
            query.setInteger(STATUS_DISPATCHER, filter.getStatusDispatcher());
        }

        if (filter.getIsWaiterSkipped() != null) {
            query.setBoolean(IS_WAITER_SKIPPED, filter.getIsWaiterSkipped());
        }

        if (filter.getIsRunnerOnDemand() != null) {
            query.setBoolean(IS_RUNNER_ON_DEMAND, filter.getIsRunnerOnDemand());
        }
        
        if (filter.getIsRunnerSkipped() != null) {
            query.setBoolean(IS_RUNNER_SKIPPED, filter.getIsRunnerSkipped());
        }

      
        
        if (filter.getBootstrap() != null) {
            query.setBoolean(BOOTSTRAP, filter.getBootstrap());
        }

        if (filter.getIsDispatcherSkipped() != null) {
            query.setBoolean(IS_DISPATCHER_SKIPPED, filter.getIsDispatcherSkipped());
        }
*/
        return query;
    }

    public int delete() {

        String hql = "delete from JobNetDBItem " + getWhere();

        Query query = setQueryParams(hql);
        int row = query.executeUpdate();

        return row;
    }

    private String getWhere() {
        String where = "";
        String and = "";


        if (!filter.getSchedulerId().equals("")) {
            where += and + " schedulerId = :schedulerId";
            and = " and ";
        }


        if (filter.getNetId() != null) {
            where += and + " netId = :netId";
            and = " and ";
        }

        if (filter.getJobnet() != null && !filter.getJobnet().equals("")) {
            where += and + " jobNet = :jobNet";
            and = " and ";
        }

/*        if (filter.getStatus() != null) {
            where += and + " status  = :status";
            and = " and ";
        }

        if (filter.getStatusDispatcher() != null) {
            where += and + " statusDispatcher = :statusDispatcher";
            and = " and ";
        }

        if (filter.getStatusRunner() != null) {
            where += and + " statusRunner = :statusRunner";
            and = " and ";
        }

        if (filter.getStatusWaiter() != null) {
            where += and + " statusWaiter = :statusWaiter";
            and = " and ";
        }

        if (filter.getIsWaiterSkipped() != null) {
            where += and + " isWaiterSkipped = :isWaiterSkipped";
            and = " and ";
        }

        if (filter.getIsRunnerSkipped() != null) {
            where += and + " isRunnerSkipped = :isRunnerSkipped";
            and = " and ";
        }


        if (filter.getIsRunnerOnDemand() != null) {
            where += and + " isRunnerOnDemand= :isRunnerOnDemand";
            and = " and ";
        }

        if (filter.getIsDispatcherSkipped() != null) {
            where += and + " isDispatcherSkipped = :isDispatcherSkipped";
            and = " and ";
        }

        
        if (filter.getBootstrap() != null) {
            where += and + " bootstrap = :bootstrap";
            and = " and ";
        }
*/
        if (where.trim().equals("")) {

        } else {
            where = "where " + where;
        }
        return where;

    }

    public List<JobNetDBItem> getJobNetList(int limit) {
        initSession();


        Query query = setQueryParams("from JobNetDBItem jobnet " + getWhere() + this.filter.getOrderCriteria() + this.filter.getSortMode());

        if (limit > 0) {
            query.setMaxResults(limit);
        }

        @SuppressWarnings("unchecked")
        List<JobNetDBItem> jobnetPlanList = query.list();
        return jobnetPlanList;

    }

    public JobNetDBItem getJobNetOrNull(String schedulerId, String jobNetName) {
        resetFilter();
        filter.setSchedulerId(schedulerId);
        filter.setJobnet(jobNetName);
        List<JobNetDBItem> records = getJobNetList(0);
        return (records == null || records.size() == 0) ? null : records.get(0);
    }

    public JobNetFilter getFilter() {
        return filter;
    }

    public void resetFilter() {
        filter = new JobNetFilter();
    }

    public void setFilter(JobNetFilter filter) {
        this.filter = filter;
    }


}
