package com.sos.jobnet.db;

import com.sos.hibernate.classes.DbItem;
import com.sos.hibernate.classes.SOSHibernateFilter;
import com.sos.jobnet.classes.JobNetStatus;
import org.joda.time.DateTime;
import org.joda.time.format.DateTimeFormat;
import org.joda.time.format.DateTimeFormatter;

import java.text.ParseException;


/**
* \class SchedulerJobNetFilter 
* 
* \brief SchedulerJobNetFilter - 
* 
* \details
*
* \section SchedulerJobNetFilter.java_intro_sec Introduction
*
* \section SchedulerJobNetFilter.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author Uwe Risse
* \version 13.08.2013
* \see reference
*
* Created on 13.08.2013 13:53:37
 */

public class JobNetHistoryFilter extends SOSHibernateFilter implements com.sos.hibernate.interfaces.ISOSHibernateFilter {
//public class SchedulerJobNetFilter extends SOSHibernateFilter implements com.sos.hibernate.interfaces.ISOSHibernateFilter {


	@SuppressWarnings("unused")
	private final String	conClassName	= "SchedulerJobNetFilter";
	public  final String	conSVNVersion	= "$Id: SchedulerJobNetFilter.java 20187 2013-05-17 14:48:22Z ss $";

	private Long historyId;
    private String schedulerId="";
    private Long netId;
	private String uuid;
	private DateTime startTime;
	private DateTime endTime;
	private DateTime startTimeFrom;
	private DateTime startTimeTo;
    private JobNetStatus status;
    private Integer exitCode;
    private String jobnetId;
    private String searchField;
    private boolean finishedStatus;

    private String dateFormat = "yyyy-MM-dd HH:mm:ss";
    private DateTimeFormatter formatter = DateTimeFormat.forPattern(dateFormat);

	public void setStartTimeFrom(DateTime dateTime) {
		this.startTimeFrom = dateTime;
	}

	public void setStartTimeFrom(String startTimeFrom) throws ParseException {
	    if (startTimeFrom.equals("")) {
            this.startTimeFrom = null;
        }
        else {
            setStartTimeFrom(formatter.parseDateTime(startTimeFrom));
        }
	}

	public void setStartTimeTo(DateTime startTimeTo) {
		this.startTimeTo  = startTimeTo;
	}

	public void setStartTimeTo(String startTimeTo) throws ParseException {
        if (startTimeTo.equals("")) {
            this.startTimeTo = null;
        }
        else {
            setStartTimeTo(formatter.parseDateTime(startTimeTo));
        }
		}

 
	@Override
	public String getTitle() {
 		return "";
	}

	@Override
	public boolean isFiltered(DbItem h) {
		return false;
 	}

    public String getDateFormat() {
        return dateFormat;
    }

    public void setDateFormat(String dateFormat) {
        this.dateFormat = dateFormat;
        formatter = DateTimeFormat.forPattern(dateFormat);
    }

    public Long getHistoryId() {
        return historyId;
    }

    public void setHistoryId(Long historyId) {
        this.historyId = historyId;
    }

    public String getSchedulerId() {
        return schedulerId;
    }

    public void setSchedulerId(String schedulerId) {
        this.schedulerId = schedulerId;
    }

    public Long getNetId() {
        return netId;
    }

    public void setNetId(long netId) {
        this.netId = netId;
    }

    public String getUuid() {
        return uuid;
    }

    public void setUuid(String uuid) {
        this.uuid = uuid;
    }

    public DateTime getStartTime() {
        return startTime;
    }

    public void setStartTime(DateTime startTime) {
        this.startTime = startTime;
    }

    public DateTime getEndTime() {
        return endTime;
    }

    public void setEndTime(DateTime endTime) {
        this.endTime = endTime;
    }

    public JobNetStatus getStatus() {
        return status;
    }

    public void setStatus(JobNetStatus status) {
        this.status = status;
    }

    public void setFinishedStatus(boolean status) {
        this.finishedStatus = status;
    }
    
    public boolean getFinishedStatus() {
        return finishedStatus;
    }

    public Integer getExitCode() {
        return exitCode;
    }

    public void setExitCode(Integer exitCode) {
        this.exitCode = exitCode;
    }

    public String getJobnetId() {
        return jobnetId;
    }

    public void setJobnetId(String jobnetId) {
        this.jobnetId = jobnetId;
    }

    public DateTime getStartTimeFrom() {
        return startTimeFrom;
    }

    public DateTime getStartTimeTo() {
        return startTimeTo;
    }

    public String getSearchField() {
        return searchField;
    }

    public void setSearchField(String searchField) {
        this.searchField = searchField;
    }


 
	 
	
	
}
