package com.sos.jobnet.dialog.classes;

/**
* \class SosTabJOC 
* 
* \brief SosTabJOC - 
* 
* \details
*
* \section SosTabJOC.java_intro_sec Introduction
*
* \section SosTabJOC.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author Uwe Risse
* \version 25.01.2012
* \see reference
*
* Created on 25.01.2012 11:47:41
 */
import org.apache.log4j.Logger;
import org.eclipse.swt.SWT;

import org.eclipse.swt.custom.CTabFolder;
import org.eclipse.swt.custom.CTabItem;

import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Table;

import com.sos.JSHelper.Exceptions.JSExceptionMandatoryOptionMissing;
import com.sos.dashboard.globals.SOSDashboardOptions;
import com.sos.dialog.interfaces.ITableView;

import com.sos.jobnet.db.JobNetHistoryDBItem;
import com.sos.jobnet.db.JobNetPlanDBItem;
import com.sos.jobnet.db.JobNetTreeDBItem;
import com.sos.jobnet.dialog.SchedulerJobNetDataProvider;
import com.sos.jobnet.frontend.JobnetMonitor;
import com.sos.jobnet.frontend.JobnetShowGraph;

public class SOSTabJobnetMonitor extends CTabItem {

    private static Logger       logger     = Logger.getLogger(SOSTabJobnetMonitor.class);

    private Composite           parentComposite;
    private GridLayout          layout;
    private Table               table;
    private JobnetMonitor       showMonitor;
    private boolean             changed    = true;
    private JobNetTreeDBItem    jobNetTreeDBItem;
    private SOSDashboardOptions objOptions = null;

    public SOSTabJobnetMonitor(String caption, CTabFolder parentTabfolder, SOSDashboardOptions objOptions_) {
        super(parentTabfolder, SWT.NONE);
        objOptions = objOptions_;
        setText(caption);

        parentComposite = new Composite(parentTabfolder, SWT.NONE);
        layout = new GridLayout(1, false);
        parentComposite.setLayout(layout);
        createContent();

        parentComposite.layout();
        this.setControl(parentComposite);
    }

    private void createContent() {
        try {
            showMonitor = new JobnetMonitor(parentComposite, objOptions);
         }
        catch (Exception e) {
            e.printStackTrace();
        }

    }

    public void setJobNetTreeDBItem(JobNetTreeDBItem jobNetTreeDBItem_) throws JSExceptionMandatoryOptionMissing, Exception {
      if (jobNetTreeDBItem_!= null){

        changed = ( jobNetTreeDBItem == null || !jobNetTreeDBItem.getIdentifier().equals(jobNetTreeDBItem_.getIdentifier()));
        
        jobNetTreeDBItem = jobNetTreeDBItem_;
        showMonitor.getJobNetPlanDataProvider().resetFilter();

        showMonitor.getJobNetPlanDataProvider().getFilter().setUuid(jobNetTreeDBItem.getUuid());
        if (jobNetTreeDBItem.isJobNetPlanNode()) {
            showMonitor.getJobNetPlanDataProvider().getFilter().setJobNetPlanDBItem((JobNetPlanDBItem) jobNetTreeDBItem);
        }

        if (changed) {
            showMonitor.getTableData();
        }
        }

    }

    public void resetRefresh() {
        changed = true;
    }

    public void actualize() {
        if (changed) {
            showMonitor.actualizeList();
            changed = false;
        }
    }

    public void setSchedulerJobNetDataProvider(SchedulerJobNetDataProvider schedulerJobNetDataProvider) {
        showMonitor.setSchedulerJobNetDataProvider(schedulerJobNetDataProvider);
    }

    
    public Composite getParentComposite() {
        return parentComposite;
    }

    public Table getTable() {
        return table;
    }

    public void disableRefresh() {
        showMonitor.disableRefresh();

    }

    public void enableRefresh() {
        showMonitor.resetRefreshTimer();
    }
    
    public ITableView getTableViewJobNet() {
       return showMonitor.getTableViewJobNet();
    }
}
