package com.sos.jobnet.frontend;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.SWT;

import com.sos.jobnet.db.JobNetHistoryDBItem;
import com.sos.jobnet.db.JobNetTreeDBItem;

import org.eclipse.swt.layout.GridData;
import org.eclipse.wb.swt.SWTResourceManager;

public class JobNetInfo extends Composite {

    private Label lbSchedulerId;
    private Label lbNetId;
    private Label lbUUID;
    private Label lbStart;
    private Label lbEnd;
    private Label lbStatus;
    private Label lbRuntime;
    private Label lbExitCode;
    private Label lbExitMessage;
    private Label lbNumberOfNodes;
    private Label lbNumberOfFinished;
    private Label lblMsg;

    /**
     * Create the composite.
     * @param parent
     * @param style
     */
    public JobNetInfo(Composite parent, int style) {
        super(parent, style);
        setLayout(new GridLayout(3, false));
        createContent();

    }

    private void createContent() {
        
        lblMsg = new Label(this, SWT.NONE);
        lblMsg.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 3, 1));
        lblMsg.setFont(SWTResourceManager.getFont("Segoe UI", 12, SWT.BOLD));
        Label lblSchedulerId = new Label(this, SWT.NONE);
        lblSchedulerId.setText("Scheduler ID");
        
                lbSchedulerId = new Label(this, SWT.NONE);
                GridData gd_lbSchedulerId = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
                gd_lbSchedulerId.widthHint = 303;
                lbSchedulerId.setLayoutData(gd_lbSchedulerId);
                lbSchedulerId.setText(" ");
        new Label(this, SWT.NONE);

        Label lblNetId = new Label(this, SWT.NONE);
        lblNetId.setText("Net ID");

        lbNetId = new Label(this, SWT.NONE);
        lbNetId.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 2, 1));
        lbNetId.setText(" ");

        Label lblUuid = new Label(this, SWT.NONE);
        lblUuid.setText("UUID");

        lbUUID = new Label(this, SWT.NONE);
        lbUUID.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
        lbUUID.setText(" ");
        new Label(this, SWT.NONE);

        Label lblStart = new Label(this, SWT.NONE);
        lblStart.setText("Start");

        lbStart = new Label(this, SWT.NONE);
        lbStart.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
        lbStart.setText(" ");
        new Label(this, SWT.NONE);

        Label lblEnd = new Label(this, SWT.NONE);
        lblEnd.setText("End");

        lbEnd = new Label(this, SWT.NONE);
        lbEnd.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
        lbEnd.setText(" ");
        new Label(this, SWT.NONE);

        Label lblRun = new Label(this, SWT.NONE);
        lblRun.setText("Runtime");

        lbRuntime = new Label(this, SWT.NONE);
        lbRuntime.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
        lbRuntime.setText(" ");
        new Label(this, SWT.NONE);

        Label lblStat = new Label(this, SWT.NONE);
        lblStat.setText("Status");

        lbStatus = new Label(this, SWT.NONE);
        lbStatus.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
        lbStatus.setText("-");
        new Label(this, SWT.NONE);
        
        Label lblNumberOfNodes = new Label(this, SWT.NONE);
        lblNumberOfNodes.setText("Number of nodes");
        
        lbNumberOfNodes = new Label(this, SWT.NONE);
        lbNumberOfNodes.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
        lbNumberOfNodes.setText("0");
        new Label(this, SWT.NONE);
        
        Label lblNumberOfFinished = new Label(this, SWT.NONE);
        lblNumberOfFinished.setText("Number of finished nodes");
        
        lbNumberOfFinished = new Label(this, SWT.NONE);
        lbNumberOfFinished.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
        lbNumberOfFinished.setText("0");
        new Label(this, SWT.NONE);

        Label lblExitCode = new Label(this, SWT.NONE);
        lblExitCode.setText("Exit Code");

        lbExitCode = new Label(this, SWT.NONE);
        lbExitCode.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
        lbExitCode.setText("-");
        new Label(this, SWT.NONE);

        Label lblExitMessage = new Label(this, SWT.NONE);
        lblExitMessage.setText("Exit Message");

        lbExitMessage = new Label(this, SWT.NONE);
        lbExitMessage.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
        lbExitMessage.setText(" ");
        new Label(this, SWT.NONE);
    }

    public void setJobNetHistoryDBItem(JobNetTreeDBItem jobNetTreeDBItem) {
        lbSchedulerId.setText(jobNetTreeDBItem.getSchedulerId());
        lbNetId.setText(jobNetTreeDBItem.getNetIdValue());
        lbUUID.setText(jobNetTreeDBItem.getUuid());
        lbStart.setText(jobNetTreeDBItem.getStartTimeFormated());
        lbEnd.setText(jobNetTreeDBItem.getEndTimeFormated());
        lbStatus.setText(jobNetTreeDBItem.getStatusValue());
        lbRuntime.setText(jobNetTreeDBItem.getRunTimeFormatted());
        lbExitCode.setText(jobNetTreeDBItem.getExitCodeValue());
        lbExitMessage.setText(jobNetTreeDBItem.getValueOrBlank(jobNetTreeDBItem.getExitMessage()));
        
        if (jobNetTreeDBItem.isJobNetHistoryNode()) {
            
            JobNetHistoryDBItem j = (JobNetHistoryDBItem)jobNetTreeDBItem;
            lbNumberOfFinished.setText(j.getNumberOfFinishedNodesValue());
            lbNumberOfNodes.setText(j.getNumberOfNodesValue());
            
        }

    }

    public void setMsg(String msg) {
        lblMsg.setText(msg);
    }
    @Override
    protected void checkSubclass() {
        // Disable the check that prevents subclassing of SWT components
    }

}
