package com.sos.jobnet.frontend;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.layout.FillLayout;

import com.sos.dialog.interfaces.ITableView;
import com.sos.hibernate.interfaces.ISOSDashboardDataProvider;
import com.sos.jobnet.dataprovider.JobNetPlanDataProvider;
import com.sos.jobnet.db.JobNetPlanDBItem;
import com.sos.jobnet.db.JobNetPlanDBLayer;
import com.sos.jobnet.db.JobNetPlanFilter;

public class JobNetNodeCommandDialog extends Dialog {

    protected Object               result;
    protected Shell                shell;
    private JobNetNodeCommand      jobNetNodeCommand;
    private JobNetPlanDBItem       jobNetPlanDBItem;
    private JobNetPlanDataProvider jobNetPlanDateProvider;
    private ITableView                     iTableView;

    /**
     * 
     * Create the dialog.
     * @param parent
     * @param style
     */
    public JobNetNodeCommandDialog(ITableView iTableView_, Shell parent, int style, JobNetPlanDBItem jobNetPlanDBItem, ISOSDashboardDataProvider jobNetPlanDateProvider_) {
        super(parent, style);
        jobNetPlanDateProvider = (JobNetPlanDataProvider) jobNetPlanDateProvider_;
        this.jobNetPlanDBItem = jobNetPlanDBItem;
        this.iTableView = iTableView_;
    }

    /**
     * Open the dialog.
     * @return the result
     */
    public Object open() {
        createContents();
        setJobNetPlanDBItem();
        shell.open();
        shell.layout();
        Display display = getParent().getDisplay();
        while (!shell.isDisposed()) {
            if (!display.readAndDispatch()) {
                display.sleep();
            }
        }
        return result;
    }

    /**
     * Create contents of the dialog.
     */
    private void createContents() {
        shell = new Shell(getParent(), getStyle());
        shell.setSize(600, 150);
        shell.setText(getText());
        shell.setLayout(new FillLayout(SWT.HORIZONTAL));

        jobNetNodeCommand = new JobNetNodeCommand(shell, SWT.NONE);
        jobNetNodeCommand.getBtnOk().addSelectionListener(new SelectionAdapter() {
            @Override
            public void widgetSelected(SelectionEvent e) {
                jobNetNodeCommand.updateDBItem();
                jobNetPlanDateProvider.save(jobNetNodeCommand.getJobNetPlanDBItem());
                iTableView.buildTable();
                shell.close();

            }
        });

        jobNetNodeCommand.getBtnCancel().addSelectionListener(new SelectionAdapter() {
            @Override
            public void widgetSelected(SelectionEvent e) {
                shell.close();
            }
        });
    }

    private void setJobNetPlanDBItem() {
        if (!shell.isDisposed() && jobNetPlanDBItem != null) {
            shell.setText(jobNetPlanDBItem.getTitle());
            jobNetNodeCommand.setJobNetPlanDBItem(jobNetPlanDBItem);
        }
    }
}
