package com.sos.jobnet.frontend;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;

import com.sos.jobnet.db.JobNetPlanDBItem;
import com.sos.jobnet.options.JobNetCreatorOptions;
import com.sos.jobnet.options.StartModes;

import org.eclipse.swt.widgets.Label;
import org.eclipse.wb.swt.SWTResourceManager;

public class JobNetStartOrder extends Composite {

    /**
     * Create the composite.
     * @param parent
     * @param style
     */
    private Button           btnOk;
    private Button           btnCancel;

    private JobNetPlanDBItem jobNetPlanDBItem;
    private Label lblStarting;
    private Label lbCommand;
    private Label lbContext;
    private Label lbJobChain;
    private JobNetCreatorOptions jobNetCreatorOptions;

    public JobNetStartOrder(Composite parent, int style,JobNetCreatorOptions jobNetCreatorOptions_) {
        super(parent, style);
        jobNetCreatorOptions = jobNetCreatorOptions_;
        setLayout(new GridLayout(3, false));

        createContent();

    }

    private void createContent() {
        
        lblStarting = new Label(this, SWT.NONE);
        lblStarting.setFont(SWTResourceManager.getFont("Segoe UI", 9, SWT.BOLD));
        lblStarting.setText("Starting ");
        new Label(this, SWT.NONE);
        new Label(this, SWT.NONE);
        
        lbCommand = new Label(this, SWT.NONE);
        lbCommand.setText(jobNetCreatorOptions.StartOption.Value());
        
        lbJobChain = new Label(this, SWT.NONE);
        lbJobChain.setLayoutData(new GridData(SWT.LEFT, SWT.BOTTOM, false, false, 1, 1));
        lbJobChain.setText(jobNetCreatorOptions.JobChainName.Value());
        
        lbContext = new Label(this, SWT.NONE);
        lbContext.setText(jobNetCreatorOptions.OrderId.Value());

        btnOk = new Button(this, SWT.NONE);

        GridData gd_btnOk = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
        gd_btnOk.widthHint = 91;
        gd_btnOk.minimumWidth = 100;
        btnOk.setLayoutData(gd_btnOk);
        btnOk.setText("Ok");

        btnCancel = new Button(this, SWT.NONE);
        GridData gd_btnCancel = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
        gd_btnCancel.minimumWidth = 100;
        gd_btnCancel.widthHint = 101;
        btnCancel.setLayoutData(gd_btnCancel);
        btnCancel.setText("Cancel");
        new Label(this, SWT.NONE);
    }

    @Override
    protected void checkSubclass() {
        // Disable the check that prevents subclassing of SWT components
    }

    public Button getBtnOk() {
        return btnOk;
    }


    public Button getBtnCancel() {
        return btnCancel;
    }


    public JobNetPlanDBItem getJobNetPlanDBItem() {
        return jobNetPlanDBItem;
    }

}
