package com.sos.jobnet.frontend;

import java.io.File;
import java.util.Date;
import java.util.Timer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.CTabFolder;
import org.eclipse.swt.custom.SashForm;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Shell;

import com.sos.jobnet.dialog.SchedulerJobNetDataProvider;
import com.sos.jobnet.dialog.classes.SOSDashboardTableViewJobNetPlan;
import com.sos.jid.dialog.classes.SOSDashboardMainView;
import com.sos.jid.dialog.classes.SOSDashboardTableView;
import com.sos.jid.dialog.classes.SosDashboardHeader;
import com.sos.jid.dialog.classes.SosTabLogItem;
import com.sos.dashboard.globals.DashBoardConstants;
import com.sos.dashboard.globals.SOSDashboardOptions;
import com.sos.dialog.interfaces.ITableView;
import com.sos.jobnet.dataprovider.JobNetPlanDataProvider;
import com.sos.jobnet.db.JobNetHistoryDBItem;
import com.sos.jobnet.db.JobNetPlanFilter;
import com.sos.scheduler.history.SchedulerHistoryDataProvider;

/*
 * Created on 23.06.2008
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */

public class JobnetMonitor extends SOSDashboardTableView implements ITableView {

    private static final String             conTabLOG                 = "Log";

    protected Composite                     composite                 = null;

    private Timer                           timer;

    private SashForm                        nodesSashForm;
    private SashForm                        mainSashForm;

    private Group                           top                       = null;

    private Group                           bottom                    = null;

    private static final int                NUMBER_OF_COLUMNS_IN_GRID = 9;

    private SOSDashboardTableViewJobNetPlan tableViewJobNet;

    private File                            configurationFile;
    private JobNetPlanDataProvider          jobNetPlanDataProvider    = null;
    private SchedulerHistoryDataProvider    detailHistoryDataProvider;

    private Composite                       parent                    = null;
    private Shell                           netmonitorShell           = null;
    private boolean                         isActive                  = false;
     
    public JobnetMonitor(final Composite composite_,SOSDashboardOptions objOptions_) {
        super(composite_);
        composite = composite_;
        objOptions = objOptions_;
        configurationFile = new File (objOptions.hibernateConfigurationFile.Value());
        createFormParts();
        createContent();
        timer = new Timer();
    }

    private void createContent() {
        netmonitorShell = new Shell();
        createBottom();
        createTop();
    }

    private void createTop() {
        parent = top;
        final GridLayout gridLayout = new GridLayout();
        gridLayout.numColumns = 9;
        parent.setLayout(gridLayout);
        //netmonitorShell.setText(conJOB_SCHEDULER_DASHBOARD + " (" + VersionInfo.VERSION_STRING + ")");
        netmonitorShell.setSize(1000, 550);
        createTableJobNetPlan();
    }

    private void createTableJobNetPlan() {
        jobNetPlanDataProvider = new JobNetPlanDataProvider(configurationFile, "");
        detailHistoryDataProvider = new SchedulerHistoryDataProvider(configurationFile);

        tableViewJobNet = new SOSDashboardTableViewJobNetPlan(top, objOptions);
         tableViewJobNet.mainViewComposite = top;
        tableViewJobNet.setLeftTabFolder(null);
        //tableViewJobNet.setPrefs(prefs); 
        tableViewJobNet.setRight(null);
        tableViewJobNet.setLeft(top);
        tableViewJobNet.setLogTabFolder(logTabFolder);
        tableViewJobNet.setTableDataProvider(jobNetPlanDataProvider);
        tableViewJobNet.setDetailHistoryDataProvider(detailHistoryDataProvider);
        jobNetPlanDataProvider.getFilter().setUuid("***");
        tableViewJobNet.createTable();
        tableViewJobNet.createMenue();

    }

    private void createBottom() {
        logTabFolder = new CTabFolder(bottom, SWT.NONE);
        createContextMenuLogTabfolder();
        logTabFolder.addSelectionListener(new SelectionAdapter() {
            @Override
            public void widgetSelected(final SelectionEvent e) {
                SosTabLogItem tItem = (SosTabLogItem) logTabFolder.getSelection();
                tItem.setSelection();
            }
        });
        logTabFolder.setSelectionBackground(Display.getCurrent().getSystemColor(SWT.COLOR_TITLE_INACTIVE_BACKGROUND_GRADIENT));
        SosTabLogItem tbtmLog = new SosTabLogItem(conTabLOG, logTabFolder, Messages);
    }

    private void createContextMenuLogTabfolder() {
        Menu contentMenu = new Menu(logTabFolder);
        logTabFolder.setMenu(contentMenu);
        MenuItem addItem = new MenuItem(contentMenu, SWT.PUSH);
        addItem.setText(Messages.getLabel(DashBoardConstants.conSOSDashB_new_log));
        addItem.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
            @Override
            public void widgetSelected(final org.eclipse.swt.events.SelectionEvent e) {
                SosTabLogItem tbtmLog = new SosTabLogItem(conTabLOG, logTabFolder, Messages);
                logTabFolder.setSelection(tbtmLog);
            }

            @Override
            public void widgetDefaultSelected(final org.eclipse.swt.events.SelectionEvent e) {
            }
        });
        // =============================================================================================
        MenuItem closeItem = new MenuItem(contentMenu, SWT.PUSH);
        closeItem.setText(Messages.getLabel(DashBoardConstants.conSOSDashB_close));
        closeItem.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
            @Override
            public void widgetSelected(final org.eclipse.swt.events.SelectionEvent e) {
                SosTabLogItem tbtmLog = (SosTabLogItem) logTabFolder.getSelection();
                if (tbtmLog != null) {
                    if (logTabFolder.getItemCount() > 1) {
                        tbtmLog.dispose();
                    }
                    else {
                        tbtmLog.clearLog();
                    }
                }
            }

            @Override
            public void widgetDefaultSelected(final org.eclipse.swt.events.SelectionEvent e) {
            }
        });
        // =============================================================================================
    }

    private void createFormParts() {

        mainSashForm = new SashForm(composite, SWT.SMOOTH | SWT.VERTICAL);
        GridData gd_sashForm = new GridData(GridData.FILL_BOTH);
        gd_sashForm.heightHint = 600;
        mainSashForm.setLayoutData(gd_sashForm);

        nodesSashForm = new SashForm(mainSashForm, SWT.HORIZONTAL);
        top = new Group(nodesSashForm, SWT.NONE);

        bottom = new Group(mainSashForm, SWT.NONE);
        final FillLayout fl_bottom = new FillLayout();
        bottom.setLayout(fl_bottom);
        final FillLayout fl_top = new FillLayout();
        top.setLayout(fl_top);
        mainSashForm.setWeights(new int[] { 730, 210 });
        composite.layout();

    }

    public Timer getTimer() {
        return timer;
    }

    public void resetRefreshTimer() {
        timer.cancel();
        timer = new Timer();
        isActive = true;
    }

    public void disableRefresh() {
        timer.cancel();
        isActive = false;
    }

    
    public void setSchedulerJobNetDataProvider(SchedulerJobNetDataProvider schedulerJobNetDataProvider) {
        tableViewJobNet.setSchedulerJobNetDataProvider(schedulerJobNetDataProvider);
    }

    @Override
    public void getTableData() {
        if (isActive) {
            tableViewJobNet.getTableData();
 
        }
    }

    @Override
    public void buildTable() {
        tableViewJobNet.buildTable();
    }

    @Override
    public void createMenue() {
        tableViewJobNet.createMenue();
    }

    @Override
    public void getList() {
        tableViewJobNet.getList();
    }

    @Override
    public void actualizeList() {
        tableViewJobNet.getList();
    }

  
    @Override
    public void createTable() {

    }

    public JobNetPlanDataProvider getJobNetPlanDataProvider() {
        return jobNetPlanDataProvider;
    }

    public SOSDashboardTableViewJobNetPlan getTableViewJobNet() {
        return tableViewJobNet;
    }

}
