package com.sos.jobnet.interfaces;

import com.sos.jobnet.classes.JobNetCollection;
import com.sos.jobnet.db.JobNetCmdHistoryDBItem;
import com.sos.jobnet.db.JobNetPlanDBItem;
import com.sos.jobnet.options.StartModes;
import com.sos.scheduler.model.objects.Params;

import java.util.List;

/**
* @author Uwe Risse
* @version $Id: IDispatchHandler.java 23331 2014-03-25 09:48:33Z sos $
* Created on 24.02.2012 14:20:29
 */
public interface IDispatchHandler extends IJobNetHandler {
	public abstract void setDispatcherStatusToRunning();
	public abstract void setRunnerStatusToFinished();
	public abstract void setRunnerStatusToError();
	public abstract boolean isRunnerSkipped();
	public abstract boolean isRunnerInError();
	public abstract boolean isDispatcherSkipped();
	public abstract void setNodeStatusToDispatching();
	public abstract void setNodeStatusToFinished();
	public abstract void setDispatcherStatusToFinished();
	public abstract void setDispatcherStatusToError();
	public abstract void setNodeStatusToError(long exitCode);
	// public abstract void setNodeStatusToError();
	// public abstract void setNodeStatusToStarting(JobNetPlanDBItem planItem);
	public abstract void setNodeStatusToStarted(JobNetPlanDBItem planItem);
	public abstract int getNumberOfDispatchingNodes();
	public abstract JobNetCollection getDispatchingNodes();
	public abstract JobNetCollection getConnectorNodes();
    public abstract void updateHistoryTimeStamp();
    public abstract Boolean updateHistoryNodeEnds();
    public abstract JobNetCmdHistoryDBItem getCmdHistory();
    public abstract Boolean workWithEvents();
    public abstract StartModes getStartMode();
    public abstract JobNetPlanDBItem getCurrentRecord();
    public abstract List<JobNetPlanDBItem> getChildNodes();
    public abstract void update(JobNetPlanDBItem item);
    public abstract void updateParams(JobNetPlanDBItem item, Params param);
    public abstract void setPredecessorConditionFulfilled();
}