package com.sos.jobnet.interfaces;

import com.sos.jobnet.db.EventsDBItem;
import com.sos.jobnet.db.JobNetPlanDBItem;
import com.sos.jobnet.jobs.dispatcher.JobNetDispatcher;
import com.sos.jobnet.jobs.waiter.JobNetWaiter;
import com.sos.jobnet.logging.Level;
import com.sos.jobnet.options.JobNetOptions;
import com.sos.jobnetmodel.objects.NodeStatus;
import com.sos.scheduler.model.SchedulerObjectFactory;
import com.sos.scheduler.model.objects.JSObjParams;

/**
* \class IJobNetCallback 
* 
* \brief IJobNetCallback - 
* 
* \details
*
* \section IJobNetCallback.java_intro_sec Introduction
*
* \section IJobNetCallback.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author oh
* @version $Id: IJobNetCallback.java 21727 2014-01-02 12:40:13Z ss $
* \see reference
*
* Created on 27.02.2012 15:22:24
 */
public interface IJobNetCallback {
	public abstract int getExitCode();
	public abstract void setNextState();
	public abstract void log(Level level, String stateText, Throwable error);
	public abstract void log(Level level, String stateText);
	public abstract void logStatus(JobNetPlanDBItem record, NodeStatus oldStatus);
	public abstract void logContextStatus(String context, NodeStatus fromStatus, NodeStatus toStatus);
	public abstract void setStateText(String stateText);
 	public abstract void startNode(JobNetPlanDBItem planItem, JobNetOptions options);
 	public abstract void skipRunner();
	public abstract EventsDBItem createEventRecord(String forEventClass, String forEventId);
	public abstract void createJobNetEndedEvent(JobNetDispatcher dispatcher);
    public abstract void createJobNetStartedEvent(JobNetWaiter waiter);
    public abstract JSObjParams getOrderParameterToProvide();
    public abstract SchedulerObjectFactory getFactory();

}
