package com.sos.jobnet.interfaces;

import com.sos.jobnet.classes.EventsCollection;
import com.sos.jobnet.classes.InternalJobNetError;
import com.sos.jobnet.classes.JobNetCollection;
import com.sos.jobnet.db.ConditionsDBItem;
import com.sos.jobnet.db.EventsDBItem;
import com.sos.jobnet.db.JobNetCmdHistoryDBItem;
import com.sos.jobnet.db.JobNetPlanDBItem;
import com.sos.jobnet.options.StartModes;

import java.util.List;

/**
* \class IWaitHandler 
* 
* \brief IWaitHandler - 
* 
* \details
*
* \section IWaitHandler.java_intro_sec Introduction
*
* \section IWaitHandler.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author oh
* @version $Id: IWaitHandler.java 23331 2014-03-25 09:48:33Z sos $
* \see reference
*
* Created on 24.02.2012 14:20:29
 */
public interface IWaitHandler extends IJobNetHandler{
	public abstract boolean isBootstrap();
	public abstract void setWaiterStatusToRunning();
	public abstract void setNodeStatusToRunning();
	public abstract boolean isNodeNotProcessed();
	public abstract boolean isNodeStarted();
	public abstract boolean isNodePreparedForRestart();
	public abstract boolean isNodeFinished();
	public abstract boolean isNodeInError();
	public abstract boolean isWaiterSkipped();
	public abstract boolean isRunnerSkipped();
	public abstract boolean isRunnerOnDemand();
	public abstract boolean isRunnerRunning();
	public abstract void setNodeStatusToWaiting(Integer taskId, String jobName);
	public abstract void setRunnerStatusToRunning();
	public abstract void setWaiterStatusToFinish();
	public abstract void setWaiterStatusToError();
	public abstract void setNodeStatusToError();
	public abstract void setStartTime();
	public abstract boolean isReadyForProcessing();
	public abstract void checkJobnetStart();
	public abstract boolean isJobnetStart();
    public abstract void startHistory();
    public abstract void updateHistory();
    public abstract void updateHistoryWithError(InternalJobNetError error, String... messageParameter);
    public abstract JobNetCmdHistoryDBItem getCmdHistory();
    public abstract Boolean workWithEvents();
    public abstract StartModes getStartMode();
    public abstract void readCurrentRecordAgain();
    public abstract void activateConditions();
    public abstract void skipConditions();

	public abstract JobNetCollection getWaitingNodes();
	public abstract EventsCollection getMissingEvents();
    public List<ConditionsDBItem> getMissingConditions();
	public abstract List<EventsDBItem> getFulfilledEvents();
	public abstract void setEventsFulfilled(List<EventsDBItem> eventsToSet);
	public abstract JobNetPlanDBItem getCurrentNode();
}