package com.sos.jobnet.logging;

import org.slf4j.Logger;

/**
 * An internal representation of log Level, because the Level object is not supported in log4j2 resp. slf4j.
 * @uthor ss
 * at 23.09.13 16:44
 */
public enum Level {
    TRACE,
    DEBUG,
    INFO,
    WARN,
    ERROR;

    public static void log(Logger logger, Level level, String format) {
        switch (level) {
            case TRACE:
                logger.trace(format);
                break;
            case DEBUG:
                logger.debug(format);
                break;
            case INFO:
                logger.info(format);
                break;
            case WARN:
                logger.warn(format);
                break;
            case ERROR:
                logger.error(format);
                break;
        }
    }

    public static void log(Logger logger, org.apache.log4j.Level apacheLevel, String format) {
        Level level = Level.fromLog4j(apacheLevel);
        log(logger,level,format);
    }

    public static void log(Logger logger, Level level, String format, Throwable error) {
        switch (level) {
            case TRACE:
                logger.trace(format, error);
                break;
            case DEBUG:
                logger.debug(format, error);
                break;
            case INFO:
                logger.info(format, error);
                break;
            case WARN:
                logger.warn(format, error);
                break;
            case ERROR:
                logger.error(format, error);
                break;
        }
    }

    public static void log(Logger logger, org.apache.log4j.Level apacheLevel, String format, Throwable error) {
        Level level = Level.fromLog4j(apacheLevel);
        log(logger,level,format,error);
    }

    private static Level fromLog4j(org.apache.log4j.Level level) {
        if(level == org.apache.log4j.Level.TRACE) return Level.TRACE;
        if(level == org.apache.log4j.Level.DEBUG) return Level.DEBUG;
        if(level == org.apache.log4j.Level.INFO) return Level.INFO;
        if(level == org.apache.log4j.Level.WARN) return Level.WARN;
        return Level.ERROR;
    }

}
