package com.sos.jobnet.options;

import java.util.HashMap;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.sos.JSHelper.Annotations.JSOptionClass;
import com.sos.JSHelper.Exceptions.JSExceptionMandatoryOptionMissing;
import com.sos.JSHelper.Listener.JSListener;

/**
 * \class 		ListFilesWebServiceOptions - Returns folder content
 *
 * \brief
 * An Options as a container for the Options super class.
 * The Option class will hold all the things, which would be otherwise overwritten at a re-creation
 * of the super-class.
 *
 *

 *
 * see \see C:\Users\oh\AppData\Local\Temp\scheduler_editor-7579366387269665015.html for (more) details.
 *
 * \verbatim ;
 * mechanicaly created by JobDocu2OptionsClass.xslt from http://www.sos-berlin.com at 20130710012632
 * \endverbatim
 */
@JSOptionClass(name = "ListFilesWebServiceOptions", description = "Returns folder content")
public class ListFilesWebServiceOptions extends ListFilesWebServiceOptionsSuperClass {
	@SuppressWarnings("unused")
	private final String					conClassName						= "ListFilesWebServiceOptions";
	@SuppressWarnings("unused")
	private static Logger		logger			= LoggerFactory.getLogger(ListFilesWebServiceOptions.class);

    /**
    * constructors
    */

	public ListFilesWebServiceOptions() {
	} // public ListFilesWebServiceOptions

	public ListFilesWebServiceOptions(final JSListener pobjListener) {
		this();
		this.registerMessageListener(pobjListener);
	} // public ListFilesWebServiceOptions

		//

	public ListFilesWebServiceOptions (final HashMap <String, String> JSSettings) throws Exception {
		super(JSSettings);
	} // public ListFilesWebServiceOptions (HashMap JSSettings)
/**
 * \brief CheckMandatory - prüft alle Muss-Optionen auf Werte
 *
 * \details
 * @throws Exception
 *
 * @throws Exception
 * - wird ausgelöst, wenn eine mandatory-Option keinen Wert hat
 */
		@Override  // ListFilesWebServiceOptionsSuperClass
	public void CheckMandatory() {
		try {
			super.CheckMandatory();
		}
		catch (Exception e) {
			throw new JSExceptionMandatoryOptionMissing(e.toString());
		}
	} // public void CheckMandatory ()
}

