package com.sos.jobnet.options;

public enum StartModes {
	start                   (checkUUID(true),  newInstance(true),  checkContext(true), needCreator(true)  ),
	start_again             (checkUUID(true),  newInstance(true),  checkContext(true), needCreator(true)  ),
	start_independent       (checkUUID(false), newInstance(true),  checkContext(true), needCreator(true)  ),
	repeat                  (checkUUID(true),  newInstance(false), checkContext(false), needCreator(true) ),
	restart_error           (checkUUID(true),  newInstance(false), checkContext(true), needCreator(true)  ),
    restart_ignore_error    (checkUUID(true),  newInstance(false), checkContext(true), needCreator(true)  ),
	kill                    (checkUUID(true),  newInstance(false), checkContext(true), needCreator(false)  ),
	abort                   (checkUUID(true),  newInstance(false), checkContext(true), needCreator(false)  );

	private final boolean checkUUID;
	private final boolean newInstance;
	private final boolean checkContext;
	private final boolean needCreator;
	private final StartModesText text;

	private StartModes(boolean checkUUID, boolean newInstance, boolean checkContext, boolean needCreator) {
        this.checkUUID = checkUUID;
        this.newInstance = newInstance;
		this.checkContext = checkContext;
		this.needCreator = needCreator;
        this.text = new StartModesText(this);
	}

    private static boolean checkUUID(boolean flag) {
        return flag;
    }

    /**
     * Need a new instance of the jobnet.
     * @param flag
     * @return
     */
    private static boolean newInstance(boolean flag) {
        return flag;
    }

    private static boolean checkContext(boolean flag) {
        return flag;
    }

    /**
     * Needs the execution of JobNetPlanCreator.
     * @param flag
     * @return
     */
    private static boolean needCreator(boolean flag) {
        return flag;
    }

    public String getMsg() {
        return text.getMsg();
    }

    /**
     * Indicates whether it is checked if a jobnet instance with <jobchain>.<jobnetid> is present in the database.
     * This instance is always created with StartOption = 'start'
     *
     * @return
     */
    public boolean checkUUID() {
        return checkUUID;
    }

    public boolean newInstance() {
        return newInstance;
    }

	public boolean checkContext() {
		return checkContext;
	}

	public boolean needCreator() {
		return needCreator;
	}

    public static String asString() {
        StringBuffer result = new StringBuffer();
        result.append("[");
        for(StartModes t : values()) {
            if(result.length() > 1) result.append(", ");
            result.append(t.name());
        }
        result.append("]");
        return result.toString();
    }

}