package com.sos.jobnetmodel.objects;

import java.util.List;
import java.util.Map;

/**
 * Created with IntelliJ IDEA.
 *
 * @uthor schaedi
 * at 15.03.13 08:41
 */
public interface ImmutableJobnetNode {

    String getInternalId();
    String getName();
    JobnetNodeType getType();
    boolean hasSuccessorNodes();
    boolean hasPredecessorNodes();
    ExternalJobnetNodeObject getExternalNodeObject();

    String getUniqueName();
    JobnetContainer getContainer();
    JobnetNode getConnector();
    JobnetNode getSubnet();

    Map<String, ImmutableJobnetNode> getChildNodes();            // for tree representation
    Map<String, ImmutableJobnetNode> getSuccessorNodes();        // for graph representation
    Map<String, ImmutableJobnetNode> getPredeceessorNodes();
    boolean isBootstrapNode();
    boolean isOnDemandNode();
    List<String> getWaitForEvents();
    String getEventOnSuccess();
    String getEventOnError();
    String getProcessClass();
    List<Integer> getValidErrors();
    NodeStatus getStatus();
    String getTitle();
    String toString();
}
