package com.sos.jobnetmodel.objects;

import java.util.HashMap;
import java.util.Map;

public class JobnetContainer {

    private final String id;
    private final String name;
    private final JobnetContainer parentContainer;
    private final Map<String,JobnetContainer> successors = new HashMap<String,JobnetContainer>();
    private final Map<String,ImmutableJobnetNode> nodes = new HashMap<String,ImmutableJobnetNode>();

    public JobnetContainer(JobnetContainer parentContainer, String name, String id) {
        this.parentContainer = parentContainer;
        this.name = name;
        this.id = id;
    }

    public Map<String,JobnetContainer> getSuccessors() {
        return successors;
    }

    public void addSuccessor(JobnetContainer container) {
        successors.put(container.getId(),container);
    }

    public String getId() {
        return id;
    }

    public String getName() {
        return name;
    }

    public Map<String,ImmutableJobnetNode> getNodes() {
        return nodes;
    }

    public void addNode(ImmutableJobnetNode node) {
        nodes.put(node.getInternalId(),node);
    }

    public JobnetContainer getParent() {
        return parentContainer;
    }
}