package com.sos.jobnetmodel.objects;

import com.sos.JSHelper.Exceptions.JobSchedulerException;
import com.sos.JSHelper.Options.JSOptionsClass;
import com.sos.JSHelper.Options.SOSOptionString;

public class SOSOptionJobnetContext extends SOSOptionString {

	public SOSOptionJobnetContext(JSOptionsClass pPobjParent, String pPstrKey, String pPstrDescription, String pPstrValue, String pPstrDefaultValue, boolean pPflgIsMandatory) {
		super(pPobjParent, pPstrKey, pPstrDescription, pPstrValue, pPstrDefaultValue, pPflgIsMandatory);
	}

	public boolean isSubnet() {
		return (this.Value().equalsIgnoreCase(JobnetNodeType.SUBNET.name()));
	}

	public boolean isConnector() {
		return (this.Value().equalsIgnoreCase(JobnetNodeType.CONNECTOR.name()));
	}

	public boolean isJob() {
		return (this.Value().equalsIgnoreCase(JobnetNodeType.JOB.name()));
	}

    public JobnetNodeType asEnum() {
    	return JobnetNodeType.valueOf(Value());
    }

    public void Value(String value) {
        String testValue = value.toUpperCase();
        try {
            JobnetNodeType t = JobnetNodeType.valueOf(testValue);
        } catch (Exception e) {
            throw new JobSchedulerException("Value " + testValue + " is not valid for " + strKey + " - valid values are " + JobnetNodeType.asString() + ".");
        }
        super.Value(testValue);
    }

}
