package sos.ftphistory;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

import com.sos.hibernate.classes.DbItem;
import com.sos.hibernate.classes.SOSHibernateIntervalFilter;
import com.sos.hibernate.interfaces.ISOSHibernateFilter;

/**
 * \class SchedulerHistoryFilter
 *
 * \brief SchedulerHistoryFilter -
 *
 * \details
 *
 * \section SchedulerHistoryFilter.java_intro_sec Introduction
 *
 * \section SchedulerHistoryFilter.java_samples Some Samples
 *
 * \code .... code goes here ... \endcode
 *
 * <p style="text-align:center">
 * <br />
 * --------------------------------------------------------------------------- <br />
 * APL/Software GmbH - Berlin <br />
 * ##### generated by ClaviusXPress (http://www.sos-berlin.com) ######### <br />
 * ---------------------------------------------------------------------------
 * </p>
 * \author Uwe Risse \version 14.12.2011 \see reference
 *
 * Created on 14.12.2011 13:53:37
 */

public class JadeFilesFilter extends SOSHibernateIntervalFilter implements ISOSHibernateFilter {
	@SuppressWarnings("unused")
	private final String	conClassName	= "JadeFilesFilter";
	private String			dateFormat1		= "yyyy-MM-dd HH:mm:ss";
	public final String			conSVNVersion					= "$Id: SOSDataExchangeEngine.java 19091 2013-02-08 12:49:32Z kb $";

	private String			sourceHost;
	private String			sourceHostIp;
	private String			sourceUser;
	private String			sourceDir;
	private String			sourceFilename;

	private Date			createdFrom;
	private Date			createdTo;

	private String			createdFromIso;
	private String			createdToIso;

	private Date			modifiedFrom;
	private Date			modifiedTo;

	private String			createdBy;

	private String			modifiedBy;
	
	private String			mandator;
	
	private Integer			fileSize;
	
	public String getCreatedFromIso() {
		return createdFromIso;
	}

	public String getCreatedToIso() {
		return createdToIso;
	}

	public JadeFilesFilter() {
	}

	@Override
	public String getDateFormat() {
		return dateFormat1;
	}

	@Override
	public void setDateFormat(final String dateFormat) {
		dateFormat1 = dateFormat;
	}

	public String getSourceHost() {
		return sourceHost;
	}

	public void setSourceHost(final String sourceHost) {
		this.sourceHost = sourceHost;
	}

	public String getSourceHostIp() {
		return sourceHostIp;
	}

	public void setSourceHostIp(final String sourceHostIp) {
		this.sourceHostIp = sourceHostIp;
	}

	public String getSourceUser() {
		return sourceUser;
	}

	public void setSourceUser(final String sourceUser) {
		this.sourceUser = sourceUser;
	}

	public String getSourceDir() {
		return sourceDir;
	}

	public void setSourceDir(final String sourceDir) {
		this.sourceDir = sourceDir;
	}

	public String getSourceFilename() {
		return sourceFilename;
	}

	public void setSourceFilename(final String sourceFilename) {
		this.sourceFilename = sourceFilename;
	}

	public Date getCreatedFrom() {
		return createdFrom;
	}

	public void setCreatedFrom(final String createdFrom) throws ParseException {
		if (createdFrom.equals("")) {
			this.createdFrom = null;
		}
		else {
			SimpleDateFormat formatter = new SimpleDateFormat(dateFormat1);
			Date d = formatter.parse(createdFrom);
			setCreatedFrom(d);
		}
	}

	public Date getCreatedTo() {
		return createdTo;
	}

	public void setCreatedTo(final String createdTo) throws ParseException {
		if (createdTo.equals("")) {
			this.createdTo = null;
		}
		else {
			SimpleDateFormat formatter = new SimpleDateFormat(dateFormat1);
			Date d = formatter.parse(createdTo);
			setCreatedTo(d);
		}
	}

	public void setCreatedFrom(final Date from) {
		if (from != null) {
			SimpleDateFormat formatter = new SimpleDateFormat(
					"yyyy-MM-dd 00:00:00");
			String d = formatter.format(from);
			try {
				formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
				createdFrom = formatter.parse(d);
			} catch (ParseException e) {
				e.printStackTrace();
			}
			formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
			createdFromIso = formatter.format(from);
		}
	}

	public void setCreatedTo(final Date to) {
		if (to != null) {
			SimpleDateFormat formatter = new SimpleDateFormat(
					"yyyy-MM-dd 23:59:59");
			String d = formatter.format(to);
			try {
				formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
				createdTo = formatter.parse(d);
			} catch (ParseException e) {
				e.printStackTrace();
			}
			formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
			createdToIso = formatter.format(to);
		}
	}

	@Override
	public String getTitle() {
		String s = "";

		if (createdFrom != null) {
			s += String.format("From: %s ", date2Iso(createdFrom));
		}
		if (createdTo != null) {
			s += String.format("To: %s ", date2Iso(createdTo));
		}

		String title = String.format("%1s ", s);
		return title;
	}

	@Override
	public boolean isFiltered(final DbItem h) {
		return false;
	}

	@Override
	public void setIntervalFromDate(final Date d) {
		createdFrom = d;
	}

	@Override
	public void setIntervalToDate(final Date d) {
		createdTo = d;
	}

	@Override
	public void setIntervalFromDateIso(final String s) {
		createdFromIso = s;
	}

	@Override
	public void setIntervalToDateIso(final String s) {
		createdToIso = s;
	}

	public Date getModifiedFrom() {
		return modifiedFrom;
	}

	public void setModifiedFrom(final String modifiedFrom) throws ParseException {
		if (modifiedFrom.equals("")) {
			this.modifiedFrom = null;
		}
		else {
			SimpleDateFormat formatter = new SimpleDateFormat(dateFormat1);
			Date d = formatter.parse(modifiedFrom);
			setModifiedFrom(d);
		}
	}

	public Date getModifiedTo() {
		return modifiedTo;
	}

	public void setModifiedTo(final String modifiedTo) throws ParseException {
		if (modifiedTo.equals("")) {
			this.modifiedTo = null;
		}
		else {
			SimpleDateFormat formatter = new SimpleDateFormat(dateFormat1);
			Date d = formatter.parse(modifiedTo);
			setModifiedTo(d);
		}
	}

	public void setModifiedFrom(final Date from) {
		if (from != null) {
			SimpleDateFormat formatter = new SimpleDateFormat(
					"yyyy-MM-dd 00:00:00");
			String d = formatter.format(from);
			try {
				formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
				modifiedFrom = formatter.parse(d);
			} catch (ParseException e) {
				e.printStackTrace();
			}
		}

	}

	public void setModifiedTo(final Date to) {
		if (to != null) {
			SimpleDateFormat formatter = new SimpleDateFormat(
					"yyyy-MM-dd 23:59:59");
			String d = formatter.format(to);
			try {
				formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
				modifiedTo = formatter.parse(d);
			} catch (ParseException e) {
				e.printStackTrace();
			}
		}

	}

	public String getCreatedBy() {
		return createdBy;
	}

	public void setCreatedBy(String createdBy) {
		this.createdBy = createdBy;
	}

	public String getMandator() {
		return mandator;
	}

	public void setMandator(String mandator) {
		this.mandator = mandator;
	}

	public String getModifiedBy() {
		return modifiedBy;
	}

	public void setModifiedBy(String modifiedBy) {
		this.modifiedBy = modifiedBy;
	}

	public Integer getFileSize() {
		return fileSize;
	}

	public void setFileSize(Integer fileSize) {
		this.fileSize = fileSize;
	}
	
}
