package com.sos.jid.dialog.classes;
/**
* \class TabLogItem 
* 
* \brief TabLogItem - 
* 
* \details
*
* \section TabLogItem.java_intro_sec Introduction
*
* \section TabLogItem.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author Uwe Risse
* \version 25.01.2012
* \see reference
*
* Created on 25.01.2012 11:47:41
 */
import java.io.File;
import java.io.IOException;
import java.util.Iterator;
import java.util.Timer;
import java.util.TimerTask;
import java.util.Vector;
import java.util.prefs.Preferences;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.CTabFolder;
import org.eclipse.swt.custom.CTabItem;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseMoveListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.TreeItem;

import org.w3c.dom.DOMException;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

import com.sos.dialog.components.SOSTableColumn;
import com.sos.eventing.eventhandler.SOSActions;
import com.sos.eventing.eventhandler.SOSEvaluateEvents;
import com.sos.eventing.eventhandler.SOSEventCommand;
import com.sos.eventing.eventhandler.SOSEventCommandElement;
import com.sos.eventing.eventhandler.SOSEventGroups;
import com.sos.eventing.eventhandler.SchedulerEvent;
import com.swtdesigner.SWTResourceManager;

import sos.ftp.profiles.FTPProfile;
import sos.ftp.profiles.FTPProfilePicker;
 
import sos.util.SOSFile;
import sos.util.SOSLogger;

public class SosTabEventhandlerViewItem extends CTabItem {
	private Display				parentDisplay;
	private Composite			composite;
	private GridLayout			layout;
	private GridData			data;
	private Tree				actionTree			= null;
	private Combo				listOfFiles			= null;
	private Table				tableEvents			= null;
	private Label				logic				= null;
	private Label				lbJob				= null;
	private Label				lbJobChain			= null;
	private Label				lbOrderId			= null;
	private Label				lbExitCode			= null;
	private Label				lbHostPort			= null;
	private Label				lbSchedulerId		= null;
	private Timer				timer;
	private FTPProfilePicker	ftpProfilePicker	= null;
	private SOSLogger			sosLogger			= null;
	private SOSEvaluateEvents	evaluateEvents		= null;
	private File				configurationDirectory;
	private Preferences			prefs;
	private File				configuration_file	= null;
	private int					refresh;
	private Label				msg;
	
	
	private class RefreshTask extends TimerTask {
		public void run() {
			if (parentDisplay == null) {
				parentDisplay = Display.getDefault();
			}
			parentDisplay.syncExec(new Runnable() {
				public void run() {
					try {
						refresh();
					}
					catch (DOMException e) {
						e.printStackTrace();
					}
					catch (Exception e) {
						e.printStackTrace();
					}
				};
			});
		}
	}
	public class Xml_parser_handler extends org.xml.sax.helpers.DefaultHandler {
		public void warning(SAXParseException e) throws SAXException {
			throw e;
		}

		public void error(SAXParseException e) throws SAXException {
			throw e;
		}

		public void fatalError(SAXParseException e) throws SAXException {
			throw e;
		}
	}

	private int getIntValue(String s, int d) {
		try {
			return Integer.parseInt(s);
		}
		catch (NumberFormatException n) {
			return d;
		}
	}

	public SosTabEventhandlerViewItem(String caption, CTabFolder parent, File configurationDirectory_, String schedulerHost, int schedulerPort) {
		super(parent, SWT.NONE);
		this.evaluateEvents = new SOSEvaluateEvents(schedulerHost, schedulerPort);
		this.configurationDirectory = configurationDirectory_;
		setText(caption);
		parentDisplay = parent.getDisplay();
		composite = new Composite(parent, SWT.NONE);
		layout = new GridLayout(2, false);
		composite.setLayout(layout);
		data = new GridData(GridData.FILL_BOTH);
		data.horizontalSpan = 2;
		this.setControl(composite);
		try {
			createContents();
		}
		catch (DOMException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private void setBackgroundChild(TreeItem item, int a, int b, int c) {
		TreeItem[] t = item.getItems();
		for (int i = 0; i < t.length; i++) {
			TreeItem child = t[i];
			if (a >= 0) {
				child.setBackground(SWTResourceManager.getColor(a, b, c));
			}
			else {
				child.setBackground(null);
			}
		}
	}

	private void refreshItem(TreeItem actItem) {
		TreeItem[] t = actItem.getItems();
		for (int i = 0; i < t.length; i++) {
			TreeItem item = t[i];
			SOSActions a = (SOSActions) item.getData();
			if (a.isActive(evaluateEvents.getListOfActiveEvents())) {
				item.setBackground(SWTResourceManager.getColor(255, 0, 0));
				setBackgroundChild(item, 255, 0, 0);
			}
			else {
				item.setBackground(null);
				setBackgroundChild(item, -1, -1, -1);
			}
		}
	}

	protected void refresh() throws DOMException, Exception {
		try {
			evaluateEvents.buildEventsFromXMl();
			TreeItem[] t = actionTree.getItems();
			if (actionTree.getSelectionCount() > 0) {
				SOSActions a = (SOSActions) actionTree.getSelection()[0].getData();
				fillEventTables(a);
			}
			for (int i = 0; i < t.length; i++) {
				TreeItem item = t[i];
				SOSActions a = (SOSActions) item.getData();
				// Tree aktualisieren
				if (a.isActive(evaluateEvents.getListOfActiveEvents())) {
					item.setBackground(SWTResourceManager.getColor(255, 0, 0));
				}
				else {
					item.setBackground(null);
				}
				refreshItem(item);
			}
		}
		catch (SAXException e1) {
			;
		}
		catch (IOException e1) {
			e1.printStackTrace();
		}
	}

	private void fillTreeItem(SOSActions a, TreeItem item) {
		Iterator iCommands = a.getListOfCommands().iterator();
		while (iCommands.hasNext()) {
			SOSEventCommand ec = (SOSEventCommand) iCommands.next();
			TreeItem command_item = new TreeItem(item, SWT.NONE);
			if (ec.getAttribute("name").equals("")) {
				command_item.setFont(SWTResourceManager.getFont("", 8, SWT.NORMAL));
				command_item.setText(ec.getCommand().getNodeName());
			}
			else {
				command_item.setFont(SWTResourceManager.getFont("", 8, SWT.ITALIC));
				command_item.setText(ec.getAttribute("name"));
			}
			command_item.setData(a);
			Iterator iCommandElements = ec.getListOfCommandElements().iterator();
			while (iCommandElements.hasNext()) {
				SOSEventCommandElement ece = (SOSEventCommandElement) iCommandElements.next();
				TreeItem command_item_action = new TreeItem(command_item, SWT.NONE);
				command_item_action.setText(ece.node2String());
				command_item_action.setData(a);
			}
		}
	}

	private void getConfigurationFiles() throws Exception {
		String fileSpec = "(\\..*)?\\.actions\\.xml$";
		this.listOfFiles.removeAll();
		Vector specialFiles = SOSFile.getFilelist(this.configurationDirectory.getAbsolutePath(), fileSpec, 0, false);
		Iterator iter = specialFiles.iterator();
		while (iter.hasNext()) {
			File actionEventHandler = (File) iter.next();
			if (actionEventHandler.exists() && actionEventHandler.canRead()) {
				this.listOfFiles.add(actionEventHandler.getName());
			}
		}
		// this.listOfFiles.setVisible(this.listOfFiles.getItemCount() > 0);
	}

	private void fillTree() throws DOMException, Exception {
		actionTree.removeAll();
		tableEvents.removeAll();
		// File f = new File(configuration_filename);
		if (configuration_file != null) {
			evaluateEvents.readConfigurationFile(configuration_file);
			Iterator iActions = evaluateEvents.getListOfActions().iterator();
			while (iActions.hasNext()) {
				SOSActions a = (SOSActions) iActions.next();
				TreeItem item = new TreeItem(actionTree, SWT.NONE);
				item.setFont(SWTResourceManager.getFont("", 8, SWT.BOLD));
				item.setText(a.getName());
				fillTreeItem(a, item);
				item.setData(a);
			}
		}
	}

	private void fillEventTables(SOSActions a) {
		if (a != null) {
			tableEvents.clearAll();
			int l = tableEvents.getItemCount();
			for (int i = 0; i < l; i++) {
				TableItem t = tableEvents.getItem(tableEvents.getItemCount() - 1);
				t.dispose();
			}
			logic.setText(a.getCondition());
			Iterator i = a.getListOfEventGroups().iterator();
			while (i.hasNext()) {
				SOSEventGroups evg = (SOSEventGroups) i.next();
				String group = evg.getGroup();
				Iterator iEvents = evg.getListOfEvents().iterator();
				while (iEvents.hasNext()) {
					final TableItem newItemTableItem = new TableItem(tableEvents, SWT.BORDER);
					if (evg.getCondition().equals("and")) {
						newItemTableItem.setBackground(SWTResourceManager.getColor(255, 255, 128));
					}
					if (evg.getCondition().equals("or")) {
						newItemTableItem.setBackground(SWTResourceManager.getColor(206, 231, 255));
					}
					newItemTableItem.setText(group);
					newItemTableItem.setFont(0, SWTResourceManager.getFont("", 8, SWT.BOLD));
					SchedulerEvent event = (SchedulerEvent) iEvents.next();
					event.setCondition(evg.getCondition());
					newItemTableItem.setData(event);
					newItemTableItem.setText(1, event.getEvent_title());
					newItemTableItem.setText(2, event.getEvent_name());
					newItemTableItem.setText(3, event.getEvent_id());
					newItemTableItem.setText(4, event.getEvent_class());
					if (!event.getJob_name().equals("")) {
						newItemTableItem.setText(5, event.getJob_name());
					}
					else {
						newItemTableItem.setText(5, event.getJob_chain());
					}
					newItemTableItem.setText(6, evaluateEvents.getEventStatus(event));
					newItemTableItem.setText(7, event.getCreated());
					newItemTableItem.setText(8, event.getExpires());
					newItemTableItem.setText(9, event.getComment());
					if (newItemTableItem.getText(6).equalsIgnoreCase("active")) {
						newItemTableItem.setFont(6, SWTResourceManager.getFont("", 8, SWT.BOLD));
						if (evg.isActiv(evaluateEvents.getListOfActiveEvents())) {
							newItemTableItem.setBackground(0, SWTResourceManager.getColor(0, 255, 64));
						}
					}
					else {
						newItemTableItem.setFont(6, SWTResourceManager.getFont("", 8, SWT.ITALIC));
					}
					group = "";
				}
			}
		}
	}

	/**
	 * Create contents of the window
	 * @throws Exception 
	 * @throws DOMException 
	 */
	protected void createContents() throws DOMException, Exception {
		prefs = Preferences.userNodeForPackage(this.getClass());
		Composite parent = composite;
		final GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 6;
		parent.setLayout(gridLayout);
		// Next 3 lines to comment
		parent.setLayout(gridLayout);
		parent.setSize(782, 478);
		parent.addMouseMoveListener(new MouseMoveListener() {
			public void mouseMove(final MouseEvent arg0) {
				timer.cancel();
				timer = new Timer();
				timer.schedule(new RefreshTask(), refresh * 1000, refresh * 1000);
			}
		});
		timer = new Timer();
		timer.schedule(new RefreshTask(), 1000, 5000);
		final Button refreshButton = new Button(parent, SWT.NONE);
		refreshButton.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(final SelectionEvent e) {
				try {
					refresh();
				}
				catch (DOMException e1) {
					e1.printStackTrace();
				}
				catch (Exception e1) {
					e1.printStackTrace();
				}
			}
		});
		refreshButton.setLayoutData(new GridData(91, SWT.DEFAULT));
		refreshButton.setText("Refresh");
		final Text refreshInterval = new Text(parent, SWT.RIGHT | SWT.BORDER);
		refreshInterval.setText("30");
		refresh = getIntValue(refreshInterval.getText(), 10);
		refreshInterval.addModifyListener(new ModifyListener() {
			public void modifyText(final ModifyEvent arg0) {
				refresh = getIntValue(refreshInterval.getText(), 10);
				timer.cancel();
				timer = new Timer();
				timer.schedule(new RefreshTask(), refresh * 1000, refresh * 1000);
				prefs.put("refresh", refreshInterval.getText());
			}
		});
		final GridData gd_refreshInterval = new GridData(SWT.LEFT, SWT.CENTER, true, false);
		gd_refreshInterval.minimumWidth = 50;
		refreshInterval.setLayoutData(gd_refreshInterval);
		logic = new Label(parent, SWT.NONE);
		logic.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false));
		logic.setFont(SWTResourceManager.getFont("", 12, SWT.BOLD));
		logic.setText("                                ");
		listOfFiles = new Combo(parent, SWT.READ_ONLY);
		listOfFiles.addModifyListener(new ModifyListener() {
			public void modifyText(final ModifyEvent arg0) {
			}
		});
		listOfFiles.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(final SelectionEvent e) {
				try {
					if (listOfFiles.getText().startsWith("ftp:")) {
						FTPProfile profile = ftpProfilePicker.getSelectedFTPProfile();
						profile.connect();
						configuration_file = File.createTempFile("JobScheduler", ".xml");
						String filename1 = listOfFiles.getText().substring(4);
						String filename2 = configuration_file.getCanonicalPath();
						filename2 = configuration_file.getAbsolutePath();
						profile.getFile(filename1, filename2);
						fillTree();
						configuration_file.delete();
					}
					else {
						configuration_file = new File(configurationDirectory, listOfFiles.getText());
						fillTree();
					}
				}
				catch (DOMException e1) {
					e1.printStackTrace();
				}
				catch (Exception e1) {
					e1.printStackTrace();
				}
			}

			public void widgetDefaultSelected(final SelectionEvent e) {
			}
		});
		final GridData gd_listOfFiles = new GridData(SWT.FILL, SWT.CENTER, true, false);
		gd_listOfFiles.widthHint = 105;
		listOfFiles.setLayoutData(gd_listOfFiles);
		getConfigurationFiles();
		final Label ftpLabel = new Label(parent, SWT.NONE);
		ftpLabel.setAlignment(SWT.RIGHT);
		ftpLabel.setText("FTP");
		File f = new File(configurationDirectory, "ftp_profiles.ini");
		ftpProfilePicker = new FTPProfilePicker(parent, SWT.NONE, f);
		ftpProfilePicker.addEmptyItem();
		ftpProfilePicker.addModifyListener(new ModifyListener() {
			public void modifyText(final ModifyEvent arg0) {
			}
		});
		ftpProfilePicker.setLogger(sosLogger);
		ftpProfilePicker.setButtonText("Profile");
		ftpProfilePicker.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(final SelectionEvent e) {
				msg.setText("try to connect..");
				try {
					FTPProfile profile = ftpProfilePicker.getSelectedFTPProfile();
					if (profile != null) {
						sosLogger.info("user: " + profile.getUser());
						sosLogger.info("root: " + profile.getRoot());
						sosLogger.info("... connecting");
						profile.connect();
						sosLogger.info("... connected");
						msg.setText("successfully connected..");
						Iterator iter = null;
						sosLogger.debug6("get list of files");
						Vector v = profile.getList();
						iter = v.iterator();
						listOfFiles.removeAll();
						sosLogger.debug6("reading files");
						while (iter != null && iter.hasNext()) {
							String filename = (String) iter.next();
							sosLogger.debug6("... reading " + filename);
							if (filename.toLowerCase().endsWith(".actions.xml")) {
								String entry = "ftp:" + filename;
								if (listOfFiles.indexOf(entry) < 0)
									listOfFiles.add(entry);
							}
						}
					}
					else {
						getConfigurationFiles();
					}
				}
				catch (Exception ex) {
					try {
						sosLogger.warn("Error while connectin " + ex.getMessage());
					}
					catch (Exception e1) {
						e1.printStackTrace();
					}
				}
			}
		});
		final GridData gd_ftpProfile = new GridData(SWT.FILL, SWT.CENTER, true, false);
		gd_ftpProfile.minimumWidth = 100;
		ftpProfilePicker.setLayoutData(gd_ftpProfile);
		ftpProfilePicker.setBounds(0, 0, 242, 24);
		actionTree = new Tree(parent, SWT.FULL_SELECTION | SWT.BORDER);
		actionTree.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(final SelectionEvent e) {
				if (actionTree.getSelectionCount() > 0) {
					SOSActions a = (SOSActions) actionTree.getSelection()[0].getData();
					logic.setText(a.getCondition());
					fillEventTables(a);
				}
			}
		});
		actionTree.setLinesVisible(true);
		final GridData gd_actionTree = new GridData(SWT.FILL, SWT.FILL, true, true, 2, 1);
		gd_actionTree.widthHint = 191;
		actionTree.setLayoutData(gd_actionTree);
		tableEvents = new Table(parent, SWT.BORDER);
		tableEvents.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(final SelectionEvent e) {
				SchedulerEvent event = (SchedulerEvent) e.item.getData();
				logic.setText(event.getCondition());
				lbJob.setText(event.getJob_name());
				lbJobChain.setText(event.getJob_chain());
				lbExitCode.setText(event.getExit_code());
				lbOrderId.setText(event.getOrder_id());
				lbHostPort.setText(event.getRemote_scheduler_host() + ":" + event.getRemote_scheduler_port());
				lbSchedulerId.setText(event.getScheduler_id());
			}
		});
		tableEvents.setLinesVisible(true);
		tableEvents.setHeaderVisible(true);
		final GridData gd_tableEvents = new GridData(SWT.FILL, SWT.FILL, true, true, 4, 1);
		gd_tableEvents.verticalIndent = -1;
		gd_tableEvents.heightHint = 395;
		gd_tableEvents.widthHint = 539;
		tableEvents.setLayoutData(gd_tableEvents);
		final TableColumn tbColumnGroup = new SOSTableColumn(tableEvents, SWT.NONE, "Event Group", 100);
		final TableColumn tbColumnTitle = new SOSTableColumn(tableEvents, SWT.NONE, "Title", 100);
		final TableColumn tbColumnName = new SOSTableColumn(tableEvents, SWT.NONE, "Name", 100);
		final TableColumn tbColumnEventId = new SOSTableColumn(tableEvents, SWT.NONE, "Event", 100);
		final TableColumn tbColumnClass = new SOSTableColumn(tableEvents, SWT.NONE, "Class", 80);
		final TableColumn tbColumnJob = new SOSTableColumn(tableEvents, SWT.NONE, "Job / Job Chain", 80);
		final TableColumn tbColumnStatus = new SOSTableColumn(tableEvents, SWT.NONE, "Event Status", 170);
		final TableColumn tbColumnCreated = new SOSTableColumn(tableEvents, SWT.NONE, "Created", 100);
		final TableColumn tbColumnExpires = new SOSTableColumn(tableEvents, SWT.NONE, "Expires", 80);
		final TableColumn tbColumnComment = new SOSTableColumn(tableEvents, SWT.NONE, "Comment", 100);
		new Label(parent, SWT.NONE);
		msg = new Label(parent, SWT.NONE);
		msg.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, false, false, 3, 1));
		msg.setText("");
		final Label schedulerIdLabel = new Label(parent, SWT.NONE);
		schedulerIdLabel.setText("Scheduler Id");
		lbSchedulerId = new Label(parent, SWT.NONE);
		lbSchedulerId.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false));
		lbSchedulerId.setFont(SWTResourceManager.getFont("", 8, SWT.BOLD));
		lbSchedulerId.setText("_____");
		final Label jobLabel = new Label(parent, SWT.NONE);
		jobLabel.setText("Job");
		new Label(parent, SWT.NONE);
		lbJob = new Label(parent, SWT.NONE);
		lbJob.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false));
		lbJob.setFont(SWTResourceManager.getFont("", 8, SWT.BOLD));
		lbJob.setText("_____");
		new Label(parent, SWT.NONE);
		final Label hostportLabel = new Label(parent, SWT.NONE);
		hostportLabel.setText("Host:Port");
		lbHostPort = new Label(parent, SWT.NONE);		
		lbHostPort.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false));
		lbHostPort.setFont(SWTResourceManager.getFont("", 8, SWT.BOLD));
		lbHostPort.setText("_____");
		final Label jobChainLabel = new Label(parent, SWT.NONE);
		jobChainLabel.setText("Job Chain");
		new Label(parent, SWT.NONE);
		lbJobChain = new Label(parent, SWT.NONE);
		lbJobChain.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false));
		lbJobChain.setFont(SWTResourceManager.getFont("", 8, SWT.BOLD));
		lbJobChain.setText("_____");
		new Label(parent, SWT.NONE);
		final Label exitCodeLabel = new Label(parent, SWT.NONE);
		exitCodeLabel.setText("Exit Code");
		lbExitCode = new Label(parent, SWT.NONE);
		lbExitCode.setFont(SWTResourceManager.getFont("", 8, SWT.BOLD));
		lbExitCode.setText("_____");
		final Label orderIdLabel = new Label(parent, SWT.NONE);
		orderIdLabel.setText("Order Id");
		new Label(parent, SWT.NONE);
		new Label(parent, SWT.NONE);
		new Label(parent, SWT.NONE);
		lbOrderId = new Label(parent, SWT.NONE);
		lbOrderId.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false));
		lbOrderId.setFont(SWTResourceManager.getFont("", 8, SWT.BOLD));
		lbOrderId.setText("_____");
		new Label(parent, SWT.NONE);
		fillTree();
	}
}