package com.sos.jobnet.classes;

/**
 * A class to substitute the given properties in a String,
 */
public class ParameterSubstitution {

    private final static String DELIMITER = "%";

    private final static String JOBNET_ID = "JobNetId";
    private final static String JOBNET = "JobNet";
    private final static String JOBCHAIN_NAME = "JobChainName";
    private final static String UUID = "uuid_jobnet_identifier";

    private final String uuid;
    private final String jobnetChain;
    private final String jobnetId;
    private final String jobnet;
    private final String jobnetIdParameterName;

    public ParameterSubstitution(String uuid, String jobChain, String jobnetIdParameterName) {
        this.uuid = uuid;
        this.jobnetChain = jobChain;
        this.jobnetIdParameterName = jobnetIdParameterName;
        this.jobnetId = getJobnetId();
        this.jobnet = getJobnet();
    }

    private String getJobnetId() {
        int d = uuid.lastIndexOf(".");
        return (d == -1) ? this.uuid : uuid.substring(d+1);
    }

    private String getJobnet() {
        int d = uuid.lastIndexOf(".");
        return (d == -1) ? "" : uuid.substring(0,d);
    }

    private String getPlaceholder(String varName) {
        return DELIMITER + varName + DELIMITER;
    }

    public String replace(String replaceIn) {
        String result = replaceIn.replaceAll(getPlaceholder(jobnetIdParameterName),jobnetId);
        result = result.replaceAll(getPlaceholder(JOBNET_ID),jobnetId);
        result = result.replaceAll(getPlaceholder(JOBNET),jobnet);
        result = result.replaceAll(getPlaceholder(JOBCHAIN_NAME),jobnetChain);
        result = result.replaceAll(getPlaceholder(UUID),uuid);
        return result;
    }
}
