package com.sos.jobnet.context;

import com.sos.jobnetmodel.objects.JobnetNodeType;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * @uthor ss
 * at 04.09.13 13:26
 */
public class ContextChecker {

    private final static Logger logger = LoggerFactory.getLogger(ContextChecker.class);

    private final Context initialContext;
    private final JobnetNodeType initialType;

    public ContextChecker(Context context, JobnetNodeType type) {
        this.initialContext = context;
        this.initialType = type;
    }

    public boolean isInContext(Context context) {

        boolean result = true;
        String jobName = context.getJob();
        String connectorName = context.getConnector();
        String subnetName = context.getSubnet();

        logger.debug("Check context for context type '" + initialType.name() + "'.");
        logger.info("Check context for order '" + jobName + "' (subnet=" + subnetName + ", connector=" + connectorName + ").");
        if (initialType == JobnetNodeType.SUBNET && !subnetName.equals(initialContext.getSubnet()))
            result = false;
        if (initialType == JobnetNodeType.CONNECTOR && !connectorName.equals(initialContext.getConnector()))
            result = false;
        if (initialType == JobnetNodeType.JOB && !jobName.equals(initialContext.getJob()))
            result = false;

        if(!result)
            logger.info("The order is not in the same context like order '" + initialContext.getJob() + "' (subnet=" + initialContext.getSubnet() + ", connector=" + initialContext.getConnector() + ")");
        else
            logger.debug("ContextBuilder successfully checked.");

        return result;
    }

}
