package com.sos.jobnet.creator;

import com.sos.JSHelper.Basics.JSToolBox;
import com.sos.jobnet.classes.JobNetConstants;
import com.sos.jobnet.classes.JobNetException;
import com.sos.localization.Messages;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.HashMap;

public class JobNetNodeList extends HashMap<String,JobNetOrder> {

	@SuppressWarnings("unused")
	private static final String conSVNVersion = "$Id: JobNetNodeList.java 16852 2012-03-22 04:59:03Z ss $";

	private static final long serialVersionUID = -3056305420256851206L;

	private final static Logger logger = LoggerFactory.getLogger(JobNetNodeList.class);

	private static final Messages msg = new JSToolBox(JobNetConstants.strBundleBaseName).getMessageObject();
	private final static String JOBNETC_I_0013 = "JOBNETC_I_0013"; // node %1$s (of max. %2$s) added to internal collection: %3$s. 
	private final static String JOBNETC_E_0017 = "JOBNETC_E_0017"; // the jobnet contains mor than %1$s  nodes (maybe a recursion?). Set Parameter MaxJobNetNodes if you need larger jobnets. 

	private final int maxNodes;
	
	public JobNetNodeList(int maxNodes) {
		this.maxNodes = maxNodes;
	}

	public void addOrderToNodesCollection(JobNetOrder order) {
		if (size() == maxNodes) {
			String msgText = msg.getMsg(JOBNETC_E_0017,maxNodes);
			logger.error(msgText);
			throw new JobNetException(msgText);
		}
		String key = order.getJobNetNodeName();
		if (!containsKey(key)) {
			put(key,order);
			logger.debug(msg.getMsg(JOBNETC_I_0013,size(),maxNodes,key));
		}
	}

}
