package com.sos.jobnet.creator.jobs;

import com.sos.JSHelper.Exceptions.JobSchedulerException;
import com.sos.jobnet.creator.JobNetIdCalculator;
import com.sos.jobnet.options.JobNetIdCalculatorOptions;
import sos.scheduler.job.JobSchedulerJobAdapter;
import sos.spooler.Variable_set;

import java.util.List;

public class JobNetIdCalculatorJSAdapterClass extends JobSchedulerJobAdapter  {

    private final JobNetIdCalculatorOptions options = new JobNetIdCalculatorOptions();

    @Override
    public boolean spooler_process_before() {

        try {
            super.spooler_process_before();
            logJobInfo();
        } catch (Exception e) {
            throw new JobSchedulerException(e);
        }

        return true;
    }

    @Override
    public boolean spooler_process_after(boolean processResult) {

        try {
            processResult = super.spooler_process_after(processResult);
            logJobInfo();
        } catch (Exception e) {
            throw new JobSchedulerException(e);
        }

        return processResult;
    }

    @Override
    public boolean spooler_process() {

		final String conMethodName = this.getClass().getSimpleName() + "::spooler_process"; //$NON-NLS-1$

		try {

            // prepareDatabase the class
            super.spooler_process();
            options.setAllOptions(getAllParametersAsProperties());
            options.CheckMandatory();
            JobNetIdCalculator c = new JobNetIdCalculator(options, isOrderJob() );

            List<String> targetNames = c.getTargetField();
            String targetValue = c.execute();
            Variable_set p =(isOrderJob()) ? spooler_task.order().params() : spooler_task.params();
            
            for(String targetName : targetNames) {
            	spooler_log.info("Set parameter .........: " + targetName + "=" + targetValue);
            	p.set_value(targetName,targetValue);
            }

        } catch (Exception e) {
			String msgText = String.format(Messages.getMsg("JSJ-I-107"), conMethodName );
            spooler_task.set_error(e.getMessage());
            // spooler_task.order().set_state_text(e.getMessage());
			throw new JobSchedulerException(msgText,e);
        }

        return isOrderJob();
    }

    public JobNetIdCalculatorOptions getOptions() {
        return options;
    }
    
    private void logJobInfo() {
        if (isOrderJob()) 
        	spooler_log.info("order id is " + spooler_task.order().id());
        else
        	spooler_log.info("job name is " + spooler_task.job().name() + " (id: " + spooler_task.id() + ")");
    }

}
