package com.sos.jobnet.creator.jobs;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import com.sos.JSHelper.Basics.JSToolBox;
import com.sos.JSHelper.Logging.Log4JHelper;
import com.sos.jobnet.creator.JobNetIdCalculator;
import com.sos.jobnet.options.JobNetIdCalculatorOptions;


public class JobNetIdCalculatorMain extends JSToolBox {
	private final static String					conClassName						= "LoadIdCalculatorMain"; //$NON-NLS-1$
	private static Logger		logger			= LoggerFactory.getLogger(JobNetIdCalculatorMain.class);
	@SuppressWarnings("unused")	
	private static Log4JHelper	objLogger		= null;

	protected JobNetIdCalculatorOptions	objOptions			= null;

	/**
	 * 
	 * \brief main
	 * 
	 * \details
	 *
	 * \return void
	 *
	 * @param pstrArgs
	 * @throws Exception
	 */
	public final static void main(String[] pstrArgs) {

		final String conMethodName = conClassName + "::Main"; //$NON-NLS-1$

		logger.info("LoadIdCalculator - Main"); //$NON-NLS-1$

		try {
			JobNetIdCalculatorOptions objO = new JobNetIdCalculatorOptions();
			objO.CommandLineArgs(pstrArgs);
			JobNetIdCalculator calculator = new JobNetIdCalculator(objO,false);
			System.out.println(calculator.execute());
		}
		
		catch (Exception e) {
			System.err.println(conMethodName + ": " + "Error occured ..." + e.getMessage()); 
			e.printStackTrace(System.err);
			int intExitCode = 99;
			logger.error(String.format("JSJ-E-105: %1$s - terminated with exit-code %2$d", conMethodName, intExitCode), e);		
			System.exit(intExitCode);
		}
		
		logger.info(String.format("JSJ-I-106: %1$s - ended without errors", conMethodName));		
	}

}
