package com.sos.jobnet.db;

import com.sos.hibernate.classes.DbItem;
import org.hibernate.annotations.Type;
import org.joda.time.DateTime;
import org.joda.time.DateTimeZone;

import javax.persistence.*;

@Entity
@Table(name="SCHEDULER_EVENTS")
public class EventsDBItem extends DbItem {
	
	private long id;
	private String schedulerId;
	private String host;
	private long port;
	private String jobChain;
	private String orderId;
	private String jobName;
	private String eventClass;
	private String eventId;
	private String exitCode;
	private String parameters;
	private DateTime created;
	private DateTime expires;
	
	public EventsDBItem() {
		super();
	}

    @Id
    @GeneratedValue(strategy=GenerationType.AUTO)
    @Column(name="ID")
    public Long getId() {
		return id;
	}

	@Column(name="ID")
    public void setId(Long id) {
		this.id = id;
	}
      
    @Column(name="SPOOLER_ID",nullable=false)
	public void setSchedulerId(String schedulerId) {
		this.schedulerId = schedulerId;
	}
    
    @Column(name="SPOOLER_ID",nullable=false)
	public String getSchedulerId() {
		return schedulerId;
	}
    
    @Column(name="REMOTE_SCHEDULER_HOST",nullable=true)
	public void setHost(String host) {
		this.host = host;
	}
 
    @Column(name="REMOTE_SCHEDULER_HOST",nullable=true)
	public String getHost() {
		return host;
	} 
    
    @Column(name="REMOTE_SCHEDULER_PORT")
    public Long getPort() {
		return port;
	}

	@Column(name="REMOTE_SCHEDULER_PORT")
    public void setPort(Long port) {
		this.port = port;
	}
    
    @Column(name="JOB_CHAIN",nullable=true)
	public void setJobChain(String chain) {
		this.jobChain = chain;
	}
 
    @Column(name="JOB_CHAIN",nullable=true)
	public String getJobChain() {
		return jobChain;
	} 
    
    @Column(name="ORDER_ID",nullable=true)
	public void setOrderId(String orderId) {
		this.orderId = orderId;
	}
 
    @Column(name="ORDER_ID",nullable=true)
	public String getOrderId() {
		return orderId;
	} 
    
    @Column(name="JOB_NAME",nullable=true)
	public void setJobName(String jobName) {
		this.jobName = jobName;
	}
 
    @Column(name="JOB_NAME",nullable=true)
	public String getJobName() {
		return jobName;
	} 
    
    @Column(name="EVENT_CLASS",nullable=true)
	public void setEventClass(String eventClass) {
		this.eventClass = eventClass;
	}
 
    @Column(name="EVENT_CLASS",nullable=true)
	public String getEventClass() {
		return eventClass;
	} 
    
    @Column(name="EVENT_ID",nullable=true)
	public void setEventId(String eventId) {
		this.eventId = eventId;
	}
 
    @Column(name="EVENT_ID",nullable=true)
	public String getEventId() {
		return eventId;
	} 
    
    @Column(name="EXIT_CODE",nullable=true)
	public void setExitCode(String exitCode) {
		this.exitCode = exitCode;
	}
 
    @Column(name="EXIT_CODE",nullable=true)
	public String getExitCode() {
		return exitCode;
	} 
    
    @Column(name="PARAMETERS",nullable=true)
	public void setParameters(String parameters) {
		this.parameters = parameters;
	}
 
    @Column(name="PARAMETERS",nullable=true)
	public String getParameters() {
		return parameters;
	} 
    
    @Column(name="CREATED",nullable=false)
    @Type(type="org.joda.time.contrib.hibernate.PersistentDateTime")
	public void setCreated(DateTime created) {
		this.created = (created != null) ? created.toDateTime(DateTimeZone.UTC) : null;
	}
 
    @Column(name="CREATED",nullable=false)
    @Type(type="org.joda.time.contrib.hibernate.PersistentDateTime")
	public DateTime getCreated() {
		return (created != null) ? created.toDateTime(getDateTimeZone4Getters()) : null;
	} 
    
    @Column(name="EXPIRES",nullable=true)
    @Type(type="org.joda.time.contrib.hibernate.PersistentDateTime")
	public void setExpires(DateTime expires) {
		this.expires = (expires != null) ? expires.toDateTime(DateTimeZone.UTC) : null;
	}
 
    @Column(name="EXPIRES",nullable=true)
    @Type(type="org.joda.time.contrib.hibernate.PersistentDateTime")
	public DateTime getExpires() {
		return (expires != null) ? expires.toDateTime(getDateTimeZone4Getters()) : null;
	}

    @Transient
    public boolean isEqual(String eventString) {
        return eventString.equals(getEventId()) || eventString.equals(getEventAsString());
    }

    @Transient
    public String getEventAsString() {
        return getEventClass() + "/" + getEventId();
    }

}
