package com.sos.jobnet.db;

/**
 * \class JobnetNodesDBItem
 *
 * \brief JobnetNodesDBItem -
 *
 * \details
 *
 * \section JobnetNodesDBItem.java_intro_sec Introduction
 *
 * \section JobnetNodesDBItem.java_samples Some Samples
 *
 * \code
 *   .... code goes here ...
 * \endcode
 *
 * <p style="text-align:center">
 * <br />---------------------------------------------------------------------------
 * <br /> APL/Software GmbH - Berlin
 * <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
 * <br />---------------------------------------------------------------------------
 * </p>
 * \author Uwe Risse
 * \version 23.09.2011
 * \see reference
 *
 * Created on 23.09.2011 15:08:05
 */


import com.sos.hibernate.classes.DbItem;
import org.joda.time.format.DateTimeFormat;
import org.joda.time.format.DateTimeFormatter;

import javax.persistence.*;
import java.util.ArrayList;
import java.util.List;


@Entity
@Table(name = "SCHEDULER_JOB_NET_NODES", uniqueConstraints = {@UniqueConstraint(columnNames = {"SCHEDULER_ID", "NODE", "JOB_NET"})})
public class JobNetNodeDBItem extends DbItem {

    @SuppressWarnings("unused")

    private final String conClassName = "JobNetNodeDBItem";
    private final static String NOW = "now";

    private String jobnet;
    private Long nodeId;
    private String node;
    private String schedulerId;
    /*
    private Long subnetId;
    private Long connectorId;
    private Long parentId;
    private JobNetNodeDBItem subnetNodeDBItem;
    private JobNetNodeDBItem connectorNodeDBItem;
    private String jobName;
    private String nodeType;
    private String scriptToExecute;
    private Boolean useErrorHandler;
    private DateTime plannedStartTime;
    private Boolean bootstrap;
    */

    private List<JobNetEdgesDBItem> listOfJobnetEdgesDBItems = new ArrayList<JobNetEdgesDBItem>();

    private static String dateFormat="yyyy-MM-dd HH:mm";
    private static DateTimeFormatter formatter = DateTimeFormat.forPattern(dateFormat);

    public JobNetNodeDBItem() {
        super();
    }

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name = "NODE_ID")
    public Long getNodeId() {
        return nodeId;
    }

    @Column(name = "NODE_ID")
    public void setNodeId(Long nodeId) {
        this.nodeId = nodeId;
    }

    @OneToMany(mappedBy = "parentNodeId", cascade = CascadeType.ALL, orphanRemoval = true)
    public List<JobNetEdgesDBItem> getListOfJobnetEdgesDBItems() {
        return listOfJobnetEdgesDBItems;
    }

    public void setListOfJobnetEdgesDBItems(List<JobNetEdgesDBItem> listOfJobnetEdgesDBItems) {
        this.listOfJobnetEdgesDBItems = listOfJobnetEdgesDBItems;
    }

    @Column(name = "SCHEDULER_ID", nullable = false)
    public void setSchedulerId(String schedulerId) {
        this.schedulerId = schedulerId;
    }

    @Column(name = "SCHEDULER_ID", nullable = false)
    public String getSchedulerId() {
        return schedulerId;
    }


    @Column(name = "NODE", nullable = false)
    public void setNode(String node) {
        this.node = node;
    }

    @Column(name = "NODE", nullable = false)
    public String getNode() {
        return node;
    }


    @Column(name = "JOB_NET", nullable = true)
    public void setJobnet(String jobnet) {
        this.jobnet = jobnet;
    }

    @Column(name = "JOB_NET", nullable = true)
    public String getJobnet() {
        return jobnet;
    }

    /*
    @Column(name="SUBNET_ID", nullable = true)
    public Long getSubnetId() {
        return subnetId;
    }


    @Column(name="SUBNET_ID", nullable = true)
    public void setSubnetId(Long subnetId) {
        this.subnetId = subnetId;
    }

    @ManyToOne (optional=true)
    @NotFound( action = NotFoundAction.IGNORE )
    @JoinColumn (name="SUBNET_ID", referencedColumnName="NODE_ID", insertable = false, updatable = false)
    public JobNetNodeDBItem getSubNetNodeDBItem() {
        return subnetNodeDBItem;
    }
    public void setSubNetNodeDBItem(JobNetNodeDBItem subnetNodeDBItem)  {
        this.subnetNodeDBItem = subnetNodeDBItem;
    }

    @Column(name="CONNECTOR_ID", nullable = true)
    public Long getConnectorId() {
        return connectorId;
    }

    @Column(name="CONNECTOR_ID", nullable = true)
    public void setConnectorId(Long connectorId) {
        this.connectorId = connectorId;
    }

    @Column(name="PARENT_ID", nullable = true)
    public Long getParentId() {
        return parentId;
    }

    @Column(name="PARENT_ID", nullable = true)
    public void setParentId(Long parentId) {
        this.parentId = parentId;
    }

    @ManyToOne (optional=true)
    @NotFound( action = NotFoundAction.IGNORE )
    @JoinColumn (name="CONNECTOR_ID", referencedColumnName="NODE_ID", insertable = false, updatable = false)
    public JobNetNodeDBItem getConnectorNodeDBItem() {
        return connectorNodeDBItem;
    }
    public void setConnectorNodeDBItem(JobNetNodeDBItem connectorNodeDBItem)  {
        this.connectorNodeDBItem = subnetNodeDBItem;
    }

    @Column(name="SCRIPT_TO_EXECUTE",nullable=true)
    public void setScriptToExecute(String scriptToExecute) {
        this.scriptToExecute = scriptToExecute;
    }

    @Column(name="SCRIPT_TO_EXECUTE",nullable=true)
    public String getScriptToExecute() {
        return scriptToExecute;
    }

    @Column(name="JOB_NAME",nullable=true)
    public void setJobName(String jobName) {
        this.jobName = jobName;
    }

    @Column(name="JOB_NAME",nullable=true)
    public String getJobName() {
        return jobName;
    }

    @Column(name="NODE_TYPE",nullable=true)
    public void setNodeType(String nodeType) {
        this.nodeType = nodeType;
    }

    @Column(name="NODE_TYPE",nullable=true)
    public String getNodeType() {
        return nodeType;
    }

    @Column(name="USE_ERROR_HANDLER",nullable=true)
    public void setUseErrorHandler(Boolean useErrorHandler) {
        this.useErrorHandler = useErrorHandler;
    }

    @Column(name="USE_ERROR_HANDLER",nullable=true)
    public Boolean getUseErrorHandler() {
        return useErrorHandler;
    }

    @Column(name="PLANNED_START_TIME",nullable=true)
    @Type(type="org.joda.time.contrib.hibernate.PersistentDateTime")
    public void setPlannedStartTime(DateTime plannedStartTime) {
        this.plannedStartTime = plannedStartTime;
    }

    @Column(name = "PLANNED_START_TIME", nullable = true)
    @Type(type="org.joda.time.contrib.hibernate.PersistentDateTime")
    public DateTime getPlannedStartTime() {
        return plannedStartTime;
    }

    @Column(name="BOOTSTRAP",nullable=true)
    public void setBootstrap(Boolean bootstrap) {
        this.bootstrap = bootstrap;
    }

    @Column(name="BOOTSTRAP",nullable=true)
    public Boolean getBootstrap() {
        return bootstrap;
    }

    @Transient
    public void setPlannedStartime(String plannedStartTime) throws ParseException {
        if (plannedStartTime.equals(NOW)){
            this.plannedStartTime = new DateTime();
        }else {
            this.plannedStartTime = formatter.parseDateTime(plannedStartTime);
        }
    }
    */

    @Transient
    public void addJobNetEdge(JobNetEdgesDBItem jobNetEdgesDBItem) {
        this.getListOfJobnetEdgesDBItems().add(jobNetEdgesDBItem);
        jobNetEdgesDBItem.setJobnetNodeDBItem(this);
    }

    @Transient
    public void removeJobNetEdge(JobNetEdgesDBItem jobNetEdgesDBItem) {
        this.getListOfJobnetEdgesDBItems().remove(jobNetEdgesDBItem);
        jobNetEdgesDBItem.setJobnetNodeDBItem(null);
    }

    @Transient
    public void removeJobAllNetEdges() {
        this.getListOfJobnetEdgesDBItems().clear();
    }

    @Transient
    public List<JobNetEdgesDBItem> getListOfJobnetEdgesItems() {
        List<JobNetEdgesDBItem> listOfJobnetEdgesItems = new ArrayList<JobNetEdgesDBItem>();
        listOfJobnetEdgesItems.addAll(listOfJobnetEdgesDBItems);
        return listOfJobnetEdgesItems;
    }

}
