package com.sos.jobnet.db;

import com.sos.hibernate.layer.SOSHibernateDBLayer;
import org.hibernate.Query;

import java.io.File;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * 
 * \class JobNetNodeDBLayer \brief JobNetNodeDBLayer -
 * 
 * \details
 * 
 * \section JobNetNodeDBLayer.java_intro_sec Introduction
 * 
 * \section JobNetNodeDBLayer.java_samples Some Samples
 * 
 * \code .... code goes here ... \endcode
 * 
 * <p style="text-align:center">
 * <br />
 * --------------------------------------------------------------------------- <br />
 * APL/Software GmbH - Berlin <br />
 * ##### generated by ClaviusXPress (http://www.sos-berlin.com) ######### <br />
 * ---------------------------------------------------------------------------
 * </p>
 * \author Uwe Risse \version 13.09.2011 \see reference
 * 
 * Created on 13.09.2011 14:40:18
 */

public class JobNetNodeDBLayer extends SOSHibernateDBLayer {

	@SuppressWarnings("unused")
	private final String conClassName = "JobNetNodeDBLayer";
	public final String conSVNVersion = "$Id$";

	private static final String NODE_ID = "nodeId";

	private static final String ORDER_CRITERIA = "NODE_ID";

	private static final String JOB_NET = "jobnet";

	private static final String NODE = "node";

	private static final String SCHEDULER_ID = "schedulerId";


	private JobNetNodeFilter filter = null;

	public JobNetNodeDBLayer(File configurationFile_, String schedulerId_) {
		super();
		this.filter = new JobNetNodeFilter();

		this.filter.setSchedulerId(schedulerId_);
		this.setConfigurationFile(configurationFile_);
		this.filter = new JobNetNodeFilter();
		this.filter.setOrderCriteria(ORDER_CRITERIA);
        initSession();
	}

	public JobNetNodeDBLayer(File configurationFile_) {
        super();
        initSession();
        this.filter = new JobNetNodeFilter();

        this.setConfigurationFile(configurationFile_);
        this.filter = new JobNetNodeFilter();
        this.filter.setOrderCriteria(ORDER_CRITERIA);
        initSession();
    }
	
	private Query setQueryParams(String hql) {
		Query query = session.createQuery(hql);


		if (filter.getSchedulerId() != null && !filter.getSchedulerId().equals("")) {
	        query.setParameter(SCHEDULER_ID, filter.getSchedulerId());
	    }
		  
		if (filter.getNode() != null && !filter.getNode().equals("")) {
			query.setParameter(NODE, filter.getNode());
		}

		if (filter.getJobnet() != null && !filter.getJobnet().equals("")) {
			query.setParameter(JOB_NET, filter.getJobnet());
		}

		if (filter.getNodeId() != null) {
			query.setLong(NODE_ID, filter.getNodeId());
		}

		return query;

	}

	public int delete() {

		String hql = "delete from JobNetNodeDBItem " + getWhere();

		Query query = setQueryParams(hql);
		int row = query.executeUpdate();

		return row;
	}

	private String getWhere() {
		String where = "";
		String and = "";

		

        if (filter.getSchedulerId() != null && !filter.getSchedulerId().equals("")) {
            where += and + " schedulerId = :schedulerId";
            and = " and ";
        }
        

		if (filter.getNode() != null && !filter.getNode().equals("")) {
			where += and + " node = :node";
			and = " and ";
		}

		if (filter.getJobnet() != null && !filter.getJobnet().equals("")) {
			where += and + " jobnet = :jobnet";
			and = " and ";
		}

		if (filter.getNodeId() != null) {
			where += and + " nodeId = :nodeId";
			and = " and ";
		}

		if (where.trim().equals("")) {

		} else {
			where = "where " + where;
		}
		return where;

	}

	public List<JobNetNodeDBItem> getJobnetNodeList(int limit) {
		initSession();
		Query query = setQueryParams("from JobNetNodeDBItem table_nodes "
				+ getWhere() + this.filter.getOrderCriteria()
				+ this.filter.getSortMode());

		if (limit > 0) {
			query.setMaxResults(limit);
		}

		@SuppressWarnings("unchecked")
		List<JobNetNodeDBItem> jobnetNodeList = query.list();

		return jobnetNodeList;
	}

	public List<JobNetNodeDBItem> getJobnetNodeListForUpdate(int limit) {
		initSession();
		Query query = setQueryParams("select for update from JobNetNodeDBItem table_nodes "
				+ getWhere() + this.filter.getOrderCriteria()
				+ this.filter.getSortMode());

		if (limit > 0) {
			query.setMaxResults(limit);
		}

		@SuppressWarnings("unchecked")
		List<JobNetNodeDBItem> jobnetNodeList = query.list();

		return jobnetNodeList;
	}

	public List<JobNetNodeDBItem> getJobnetList(int limit) {
        initSession();

        Query query = setQueryParams(" from JobNetNodeDBItem table_nodes "
                + getWhere()  + this.filter.getOrderCriteria()
                + this.filter.getSortMode());
        
      
        if (limit > 0) {
            query.setMaxResults(limit);
        }

        @SuppressWarnings("unchecked")
		List<JobNetNodeDBItem> jobnetNodeList = query.list();
        
        List<String> jobnetNodeListKeys = new ArrayList<String>();
        List<JobNetNodeDBItem> jobnetNodeListDistinct = new ArrayList<JobNetNodeDBItem>();

        Iterator <JobNetNodeDBItem> jobNetEntries = jobnetNodeList.iterator();
        while (jobNetEntries.hasNext()) {
            JobNetNodeDBItem h = (JobNetNodeDBItem) jobNetEntries.next();
            if (jobnetNodeListKeys.indexOf(h.getSchedulerId() + ":" + h.getJobnet()) < 0 ) {
                jobnetNodeListKeys.add(h.getSchedulerId() + ":" + h.getJobnet());
                jobnetNodeListDistinct.add(h);
            }
        }
        
        return jobnetNodeListDistinct;
    }
	
	public JobNetNodeDBItem getNode(Long id) {
		filter.setNodeId(id);
		List<JobNetNodeDBItem> l = getJobnetNodeList(1);
		JobNetNodeDBItem item = l.get(0);
		return item;
	}

	public void addJobNetEdge(JobNetNodeDBItem jobNetNodeDBItem,
			JobNetEdgesDBItem jobNetEdgesDBItem) {
		jobNetNodeDBItem.addJobNetEdge(jobNetEdgesDBItem);
	}

	public void removeJobNetEdge(JobNetNodeDBItem jobNetNodeDBItem,
			JobNetEdgesDBItem jobNetEdgesDBItem) {
		jobNetNodeDBItem.removeJobNetEdge(jobNetEdgesDBItem);
	}

	public JobNetNodeFilter getFilter() {
		return filter;
	}

	public void setFilter(JobNetNodeFilter filter) {
		this.filter = filter;
	}


}
