package com.sos.jobnet.db;

/**
* \class JobnetPlanDBItem 
* 
* \brief JobnetPlanDBItem - 
* 
* \details
*
* \section JobnetPlanDBItem.java_intro_sec Introduction
*
* \section JobnetPlanDBItem.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author Uwe Risse
* \version 23.09.2011
* \see reference
*
* Created on 23.09.2011 15:08:05
 */

import com.sos.graphviz.RGBColor;
import com.sos.jobnet.classes.JobNetDAOConstants;
import com.sos.jobnetmodel.graph.PropertyName;
import com.sos.jobnetmodel.objects.JobnetNodeType;
import com.sos.jobnetmodel.objects.NodeStatus;
import org.apache.log4j.Logger;
import org.hibernate.annotations.NotFound;
import org.hibernate.annotations.NotFoundAction;
import org.hibernate.annotations.Type;
import org.joda.time.DateTime;
import org.joda.time.format.DateTimeFormat;
import org.joda.time.format.DateTimeFormatter;

import javax.persistence.*;
import java.text.ParseException;


@Entity
@Table(name="SCHEDULER_JOB_NET_PLAN", uniqueConstraints = {@UniqueConstraint(columnNames={"UUID", "NODE_ID"})})

public class JobNetPlanDBItem extends JobNetTreeDBItem {

	private static Logger logger = Logger.getLogger(JobNetPlanDBItem.class);
	
	@SuppressWarnings("unused")
	 private final String	conClassName	= "JobNetPlanDBItem";
	 public  final String	conSVNVersion	= "$Id$";

	 private static final String NOW = "now";
	 private JobNetPlanDBItem connectorNodeDBItem = null;
	 private JobNetPlanDBItem subnetNodeDBItem = null;
	 private JobNetNodeDBItem jobnetNodeDBItem = null;
     private Long planId;
     private Long historyId; 
	 private String uuid;
     private Long nodeId;
     private Long subnetId;
     private Long connectorId;
     private Long parentId;
     private Long taskId;
     private String jobName;
	 private Long exitCode;
     private String exitMessage;
     private String nodeType;
     private String scriptToExecute;
     private Boolean useErrorHandler;
	 private Integer statusWaiter;
	 private Integer statusRunner;
	 private Integer statusDispatcher;
	 private Boolean isWaiterSkipped;
	 private Boolean isRunnerSkipped;
     private Boolean isDispatcherSkipped;
     private Boolean isRunnerOnDemand;
	 private Integer status;
	 private DateTime plannedStartTime;
	 private DateTime startTime;
	 private DateTime endTime;
	 private Boolean bootstrap;
	 private Boolean frequencyOverwrite;
	 private String message;
	 private String paramXml;
	 private String nodeName;
	 private String orderXml;
	 private DateTime created;
	 private String createdBy;
	 private DateTime modified;
	 private String modifiedBy;
  	 
  	 private static String dateFormat="yyyy-MM-dd HH:mm";
     private static DateTimeFormatter formatter = DateTimeFormat.forPattern(dateFormat);

    private JobNetHistoryDBItem jobNetHistoryDBItem;
     private JobNetNodeDBItem jobNetNodeDBItem;


 	public JobNetPlanDBItem(String dateFormat_) {
		this.dateFormat = dateFormat_;
	}
	
 	public JobNetPlanDBItem() {
 	   super();
 	}
	
 	
    @Id
    @GeneratedValue(strategy=GenerationType.AUTO)
    @Column(name="PLAN_ID")
    public Long getPlanId() {
		return planId;
	}

    @Column(name="PLAN_ID")
	public void setPlanId(Long planId) {
		this.planId = planId;
	}
    
    
    @Override
    @ManyToOne (optional=true)
    @NotFound( action = NotFoundAction.IGNORE )
    @JoinColumn (name="`NODE_ID`", insertable = false, updatable = false)
    public JobNetNodeDBItem getJobNetNodeDBItem() {
        return jobNetNodeDBItem;
    }
    
    public void setJobNetNodeDBItem(JobNetNodeDBItem jobNetNodeDBItem)  {
       this.jobNetNodeDBItem = jobNetNodeDBItem; 
    }
    
    @Column(name="NODE_ID", updatable = false, insertable = false) 
    public Long getNodeId() {
        return nodeId;
    }

      
    @Column(name="NODE_ID", updatable = false, insertable = false) 
    public void setNodeId(Long nodeId) {
        this.nodeId = nodeId;
    }

    @Column(name="SUBNET_ID", nullable = false)
    public Long getSubnetId() {
        return subnetId;
    }


    @Column(name="SUBNET_ID", nullable = false)
    public void setSubnetId(Long subnetId) {
        this.subnetId = subnetId;
    }

    @ManyToOne (optional=true)
    @NotFound( action = NotFoundAction.IGNORE )
    @JoinColumn (name="SUBNET_ID", referencedColumnName="PLAN_ID", insertable = false, updatable = false)
    public JobNetPlanDBItem getSubNetNodeDBItem() {
        return subnetNodeDBItem;
    }
    public void setSubNetNodeDBItem(JobNetPlanDBItem subnetNodeDBItem)  {
        this.subnetNodeDBItem = subnetNodeDBItem;
    }

    @Column(name="CONNECTOR_ID", nullable = false)
    public Long getConnectorId() {
        return connectorId;
    }

    @Column(name="CONNECTOR_ID", nullable = false)
    public void setConnectorId(Long connectorId) {
        this.connectorId = connectorId;
    }

    @Column(name="PARENT_ID", nullable = false)
    public Long getParentId() {
        return parentId;
    }

    @Column(name="PARENT_ID", nullable = false)
    public void setParentId(Long parentId) {
        this.parentId = parentId;
    }

    @ManyToOne (optional=true)
    @NotFound( action = NotFoundAction.IGNORE )
    @JoinColumn (name="CONNECTOR_ID", referencedColumnName="PLAN_ID", insertable = false, updatable = false)
    public JobNetPlanDBItem getConnectorNodeDBItem() {
        return connectorNodeDBItem;
    }
    public void setConnectorNodeDBItem(JobNetPlanDBItem connectorNodeDBItem)  {
        this.connectorNodeDBItem = subnetNodeDBItem;
    }

    @Column(name="USE_ERROR_HANDLER",nullable=false)
    public void setUseErrorHandler(Boolean useErrorHandler) {
        this.useErrorHandler = useErrorHandler;
    }

    @Column(name="USE_ERROR_HANDLER",nullable=false)
    public Boolean getUseErrorHandler() {
        return useErrorHandler;
    }

    @Column(name="HISTORY_ID",nullable=true)
    public void setHistoryId(long historyId) {
        this.historyId = historyId;
    }
 
    @Column(name="HISTORY_ID",nullable=true)  
    public Long getHistoryId() {
        return historyId;
    }

    @ManyToOne (optional=true)
    @NotFound( action = NotFoundAction.IGNORE )
    @JoinColumn (name="`HISTORY_ID`", referencedColumnName="HISTORY_ID", insertable = false, updatable = false)
    public JobNetHistoryDBItem getJobNetHistoryDBItem() {
        return jobNetHistoryDBItem;
    }

    public void setJobNetHistoryDBItem(JobNetHistoryDBItem jobNetHistoryDBItem)  {
        this.jobNetHistoryDBItem = jobNetHistoryDBItem;
    }

    @ManyToOne (optional=false)
    @JoinColumn(name="NODE_ID")
    public   JobNetNodeDBItem getJobnetNodeDBItem() {
    	return jobnetNodeDBItem;
    }
    public void setJobnetNodeDBItem(JobNetNodeDBItem  jobnetNodeDBItem) {
    	this.jobnetNodeDBItem = jobnetNodeDBItem;
    }
    
   
    
    @Column(name="UUID",nullable=false)
	public void setUuidId(String uuid) {
		this.uuid = uuid;
	}
    
    @Column(name="UUID",nullable=true)
	public String getUuid() {
		return uuid;
	}
    
 
    @Column(name="EXIT_CODE",nullable=false)
	public void setExitCode(Long exitCode) {
		this.exitCode = exitCode;
	}
 
    @Column(name="EXIT_CODE",nullable=false)
	public Long getExitCode() {
		return exitCode;
	}

    
    @Column(name="EXIT_MESSAGE",nullable=true)
	public void setExitMessage(String exitMessage) {
		this.exitMessage = exitMessage;
	}
 
    @Column(name="EXIT_MESSAGE",nullable=true)
	public String getExitMessage() {
		return exitMessage;
	}

    @Column(name="STATUS_WAITER",nullable=false)
	public void setStatusWaiter(Integer statusWaiter) {
		this.statusWaiter = statusWaiter;
	}
 
    @Column(name="STATUS_WAITER",nullable=false)
	public Integer getStatusWaiter() {
		return statusWaiter;
	}

    @Column(name="STATUS_RUNNER",nullable=false)
	public void setStatusRunner(Integer statusRunner) {
		this.statusRunner = statusRunner;
	}
 
    @Column(name="STATUS_RUNNER",nullable=false)
	public Integer getStatusRunner() {
		return statusRunner;
	}
    
    @Column(name="STATUS",nullable=false)
	public void setStatusNode(Integer statusNode) {
		this.status = statusNode;
	}
 
    @Column(name="STATUS",nullable=false)
	public Integer getStatusNode() {
		return status;
	}
    
    @Column(name="STATUS_DISPATCHER",nullable=false)
	public void setStatusDispatcher(Integer statusDispatcher) {
		this.statusDispatcher = statusDispatcher;
	}
 
    @Column(name="STATUS_DISPATCHER",nullable=false)
	public Integer getStatusDispatcher() {
		return statusDispatcher;
	}

    @Column(name="BOOTSTRAP",nullable=false)
	public void setBootstrap(Boolean bootstrap) {
		this.bootstrap = bootstrap;
	}
 
    @Column(name="BOOTSTRAP",nullable=false)
	public Boolean getBootstrap() {
		return bootstrap;
	}
    
   
    
    @Column(name="FREQUENCE_OVERWRITE",nullable=false)
	public void setFrequencyOverwrite(Boolean frequencyOverwrite) {
		this.frequencyOverwrite = frequencyOverwrite;
	}
 
    @Column(name="FREQUENCE_OVERWRITE",nullable=false)
	public Boolean getFrequencyOverwrite() {
		return frequencyOverwrite;
	}
    
    @Column(name="MESSAGE",nullable=true)
	public void setMessage(String message) {
		this.message = message;
	}
 
    @Column(name="MESSAGE",nullable=true)
	public String getMessage() {
		return message;
	}

    @Column(name="NODE_NAME",nullable=true)
	public void setNodeName(String nodeName) {
		this.nodeName = nodeName;
	}

    @Column(name="NODE_NAME",nullable=true)
	public String getNodeName() {
		return nodeName;
	}

    @Column(name="IS_WAITER_SKIPPED",nullable=true)
	public void setIsWaiterSkipped(Boolean isWaiterSkipped) {
		this.isWaiterSkipped = isWaiterSkipped;
	}
 
    @Column(name="IS_WAITER_SKIPPED",nullable=true)
	public Boolean getIsWaiterSkipped() {
		return isWaiterSkipped;
	}
    
    @Column(name="IS_RUNNER_SKIPPED",nullable=true)
	public void setIsRunnerSkipped(Boolean isRunnerSkipped) {
		this.isRunnerSkipped = isRunnerSkipped;
	}
 
    @Column(name="IS_RUNNER_SKIPPED",nullable=true)
	public Boolean getIsRunnerSkipped() {
		return isRunnerSkipped;
	}
    
    @Column(name="IS_DISPATCHER_SKIPPED",nullable=true)
    public void setIsDispatcherSkipped(Boolean isDispatcherSkipped) {
        this.isDispatcherSkipped = isDispatcherSkipped;
    }
 
    @Column(name="IS_DISPATCHER_SKIPPED",nullable=true)
    public Boolean getIsDispatcherSkipped() {
        return isDispatcherSkipped;
    }
        
    @Column(name="IS_RUNNER_ON_DEMAND",nullable=true)
    public void setIsRunnerOnDemand(Boolean isRunnerOnDemand) {
        this.isRunnerOnDemand = isRunnerOnDemand;
    }
 
    @Column(name="IS_RUNNER_ON_DEMAND",nullable=true)
    public Boolean getIsRunnerOnDemand() {
        return isRunnerOnDemand;
    }
        
    @Column(name="NODE_TYPE",nullable=true)
    public void setNodeType(String nodeType) {
        this.nodeType = nodeType;
    }
 
    @Column(name="NODE_TYPE",nullable=true)
    public String getNodeType() {
        return nodeType;
    }
    
    
    @Column(name="TASK_ID",nullable=true)
    public void setTaskId(Long taskId) {
        this.taskId = taskId;
    }

    @Column(name="TASK_ID",nullable=true)
    public Long getTaskId() {
        return taskId;
    }
  
    @Lob
    @Column(name="PARAM_XML", nullable=true)
  	public String getParamXml() {
  		return paramXml;
  	}
    
    @Lob
    @Column(name="PARAM_XML", nullable=true)
  	public void setParamXml(String paramXml) {
  		this.paramXml = paramXml;
  	}

    @Lob
    @Column(name="ORDER_XML", nullable=true)
  	public String getOrderXml() {
  		return orderXml;
  	}

    @Lob
    @Column(name="ORDER_XML", nullable=true)
  	public void setOrderXml(String orderXml) {
  		this.orderXml = orderXml;
  	}

    @Column(name="CREATED",nullable=true)
    @Type(type="org.joda.time.contrib.hibernate.PersistentDateTime")
    public void setCreated(DateTime created) {
		this.created = created;
	}
    
	@Column(name = "CREATED", nullable = true)
    @Type(type="org.joda.time.contrib.hibernate.PersistentDateTime")
	public DateTime getCreated() {
		return created;
	}
    
    @Column(name="MODIFIED",nullable=true)
    @Type(type="org.joda.time.contrib.hibernate.PersistentDateTime")
	public void setModified(DateTime modified) {
		this.modified = modified;
	}

    @Column(name = "MODIFIED", nullable = true)
    @Type(type="org.joda.time.contrib.hibernate.PersistentDateTime")
    public DateTime getModified() {
        return modified;
    }

    @Column(name="CREATED_BY",nullable=true)
	public void setCreatedBy(String createdBy) {
		this.createdBy = createdBy;
	}
 
    @Column(name="CREATED_BY",nullable=true)
	public String getCreatedBy() {
		return createdBy;
	}
    
    @Column(name="MODIFIED_BY",nullable=true)
	public void setModifiedBy(String modifiedBy) {
		this.modifiedBy = modifiedBy;
	}
 
    @Column(name="MODIFIED_BY",nullable=true)
	public String getModifiedBy() {
		return modifiedBy;
	}

    @Column(name="PLANNED_START_TIME",nullable=true)
    @Type(type="org.joda.time.contrib.hibernate.PersistentDateTime")
	public void setPlannedStartTime(DateTime plannedStartTime) {
		this.plannedStartTime = plannedStartTime;
	}
    
	@Column(name = "PLANNED_START_TIME", nullable = true)
    @Type(type="org.joda.time.contrib.hibernate.PersistentDateTime")
	public DateTime getPlannedStartTime() {
		return plannedStartTime;
	}
    
   
    
    @Column(name="END_TIME",nullable=true)
    @Type(type="org.joda.time.contrib.hibernate.PersistentDateTime")
	public void setEndOfNode(DateTime endTime) {
		this.endTime = endTime;
	}
    
	@Column(name = "END_TIME", nullable = true)
    @Type(type="org.joda.time.contrib.hibernate.PersistentDateTime")
	public DateTime getEndOfNode() {
		return endTime;
	} 
    
	@Column(name = "START_TIME", nullable = true)
    @Type(type="org.joda.time.contrib.hibernate.PersistentDateTime")
    public DateTime getStartOfNode() {
		return startTime;
	}

	@Column(name = "START_TIME", nullable = true)
    @Type(type="org.joda.time.contrib.hibernate.PersistentDateTime")
    public void setStartOfNode(DateTime startTime) {
		this.startTime = startTime;
	}

	@Column(name = "UUID", nullable = false)
    public void setUuid(String uuid) {
		this.uuid = uuid;
	}

    @Column(name="SCRIPT_TO_EXECUTE",nullable=true)
    public void setScriptToExecute(String scriptToExecute) {
        this.scriptToExecute = scriptToExecute;
    }

    @Column(name="SCRIPT_TO_EXECUTE",nullable=true)
    public String getScriptToExecute() {
        return scriptToExecute;
    }

    @Column(name="JOB_NAME",nullable=true)
    public void setJobName(String jobName) {
        this.jobName = jobName;
    }

    @Column(name="JOB_NAME",nullable=true)
    public String getJobName() {
        return jobName;
    }

	@Transient
    public void setPlannedStartime(String plannedStartTime) throws ParseException {
		if (plannedStartTime.equals(NOW)){
            this.plannedStartTime = new DateTime();
		}else {
				this.plannedStartTime = formatter.parseDateTime(plannedStartTime);
		}
     }

    @Transient
    public void setStartime(String startTime) throws ParseException {
		if (startTime.equals(NOW)) {
				this.startTime = new DateTime();
		} else {
				this.startTime = formatter.parseDateTime(startTime);
		}
     }
        
    @Transient
    public void setEndTime(String endTime) throws ParseException {
		if (endTime.equals(NOW)){
				this.endTime = new DateTime();
		}else {
				this.endTime = formatter.parseDateTime(endTime);
		}
     }
        
    
    
	@Transient
	public String getTitle() {
		return  this.jobnetNodeDBItem.getNode(); 
	}
	
	@Transient
	public String getIdentifier() {
        return  this.uuid  + "/" + this.jobnetNodeDBItem.getSchedulerId() + ":" + this.jobnetNodeDBItem.getJobnet() + ":" + this.jobnetNodeDBItem.getNode() +":" + this.nodeId; 
	}

    @Transient 
    public String getPlannedStartTimeFormated(){
        return (this.plannedStartTime == null) ? "" : this.plannedStartTime.toString(formatter);
    }
    
    @Transient 
    public String getStartTimeFormated(){
        return (this.startTime == null) ? "" : this.startTime.toString(formatter);
    }
    
    @Transient 
    public String getEndTimeFormated(){
        return (this.endTime == null) ? "" : this.endTime.toString(formatter);
    }
    
    
   @Transient
   public JobNetNodeDBItem getJobnetNodeItem() {
       return getJobnetNodeDBItem();
   }
   
  @Transient
  @Override
  public Long getLogId() {
      return taskId;
  }

    
    @Transient
    public boolean isJob() {
        return this.nodeType.equalsIgnoreCase("JOB");
    }
    
    @Transient
    public boolean isConnector() {
        return this.nodeType.equalsIgnoreCase("CONNECTOR");
    }

    @Transient
    public boolean isSubnet() {
        return this.nodeType.equalsIgnoreCase("SUBNET");
    }

    
    @Transient
    @Override
    public boolean isJobNetPlanNode() {
        return true;
    }
    
    @Transient
    @Override
    public boolean haveError() {
        return this.exitCode != 0;
    }

    
    
    @Transient
    @Override
    public String getStatusValue() {
        return String.valueOf(this.status);
    }
    
    @Transient
    @Override
    public boolean isStandalone() {
        return true;
    }
    
    @Transient
    public boolean isWaiting() {
        return NodeStatus.valueOf(this.status ).isWaiting();
    }
    @Transient
    public boolean isRunning() {
        return NodeStatus.valueOf(this.status ).isRunning();
    }   
    
    
    @Transient
    public boolean isNotProcessed() {
        return NodeStatus.valueOf(this.status).isNotProcessed();
    }

    
    @Transient
    public boolean isRestartPrepared() {
        return NodeStatus.valueOf(this.status ).isRestartPrepared();
    }

    @Transient
    public boolean isFinished() {
        return NodeStatus.valueOf(this.status ).isFinished();
    }

    @Transient
    public boolean isStarted() {
        return NodeStatus.valueOf(this.status ).isStarted();
    }

    @Transient
    public boolean isError() {
        return NodeStatus.valueOf(this.status ).isError();
    }
    
    @Transient
    public boolean isIgnored() {
        return NodeStatus.valueOf(this.status ).isIgnored();
    }

    @Transient
    public boolean isDispatching() {
        return NodeStatus.valueOf(this.status ).isNotProcessed();
    }

    @Transient
    public RGBColor getRGBColor(NodeStatus nodeStatus) {
    	NodeStatus s = null;
    	JobnetNodeType t = null;
    	try {
	        s = NodeStatus.valueOf(nodeStatus.getIndex());
	        t = JobnetNodeType.valueOf(this.nodeType);
    	} catch(NullPointerException e) {
    		logger.warn("NodeStatus " + nodeStatus.name() + " not defined in com.sos.jobnetmodel.objects.NodeStatus.");
    		s = NodeStatus.NOT_PROCESSED;
    	}
        return s.color(t, PropertyName.fillcolor).getRGB();
    }

    @Transient
    @Override
    public String getOrderId() {
        return getJobnetNodeItem().getNode() + JobNetDAOConstants.JOBNET_ID_DELIMITER + getUuid().substring(getUuid().indexOf(JobNetDAOConstants.JOBNET_ID_DELIMITER)+1);
    }

    @Transient
    @Override
    public String getJobChain() {
        return getJobnetNodeItem().getJobnet();
    }

    @Transient
    public static DateTimeFormatter getDateFormatter() {
        return formatter;
    }

    @Transient
    public static String getDateFormat() {
        return dateFormat;
    }

    @Transient
    public static void setDateFormat(String dateFormat) {
        dateFormat = dateFormat;
        formatter = DateTimeFormat.forPattern(dateFormat);
    }

    @Transient
    public String getConditionName() {
        return getJobnetNodeDBItem().getNode() + JobNetDAOConstants.JOBNET_ID_DELIMITER + getUuid();
    }

}
