package com.sos.jobnet.db;

import com.sos.hibernate.classes.DbItem;
import com.sos.hibernate.classes.SOSHibernateFilter;
import org.joda.time.DateTime;
import org.joda.time.format.DateTimeFormat;
import org.joda.time.format.DateTimeFormatter;

import java.text.ParseException;

/**
 * \class JobnetPlanFilter
 * <p/>
 * \brief JobnetPlanFilter -
 * <p/>
 * \details
 * <p/>
 * \section JobnetPlanFilter.java_intro_sec Introduction
 * <p/>
 * \section JobnetPlanFilter.java_samples Some Samples
 * <p/>
 * \code
 * .... code goes here ...
 * \endcode
 * <p/>
 * <p style="text-align:center">
 * <br />---------------------------------------------------------------------------
 * <br /> APL/Software GmbH - Berlin
 * <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
 * <br />---------------------------------------------------------------------------
 * </p>
 * \author Uwe Risse
 * \version 14.12.2011
 * \see reference
 * <p/>
 * Created on 14.12.2011 13:53:37
 */

public class JobNetPlanFilter extends SOSHibernateFilter implements com.sos.hibernate.interfaces.ISOSHibernateFilter {
//public class JobNetPlanFilter extends SOSHibernateFilter implements com.sos.hibernate.interfaces.ISOSHibernateFilter {

    @SuppressWarnings("unused")
    private final String conClassName = "JobnetPlanFilter";
    public final String conSVNVersion = "$Id$";
    private String uuid;
    private Long planId;
    private Long nodeId;
    private Long subnetId;
    private Long connectorId;
    private DateTime plannedStartTimeFrom;
    private DateTime plannedStartTimeTo;
    private DateTime startTimeFrom;
    private DateTime startTimeTo;
    private String node;
    private String nodeType;
    private Long taskId;
    private String jobnet;
    private Integer status;
    private Integer statusWaiter;
    private Integer statusRunner;
    private Integer statusDispatcher;
    private Boolean isWaiterSkipped;
    private Boolean isRunnerSkipped;
    private Boolean isDispatcherSkipped;
    private Boolean isRunnerOnDemand;

    private Boolean bootstrap;
    private String schedulerId = "";
    private String searchField;
    private JobNetPlanDBItem jobNetPlanDBItem;

    private String dateFormat = "yyyy-MM-dd HH:mm:ss";
    private DateTimeFormatter formatter = DateTimeFormat.forPattern(dateFormat);

    public Long getPlanId() {
        return planId;
    }

    public void setPlanId(Long planId) {
        this.planId = planId;
    }

    public String getNode() {
        return node;
    }


    public Long getNodeId() {
        return nodeId;
    }


    public void setNodeId(Long nodeId) {
        this.nodeId = nodeId;
    }

    public Long getSubnetId() {
        return subnetId;
    }


    public void setSubnetId(Long subnetId) {
        this.subnetId = subnetId;
    }

    public Long getConnectorId() {
        return connectorId;
    }


    public void setConnectorId(Long connectorId) {
        this.connectorId = connectorId;
    }


    public Boolean getIsWaiterSkipped() {
        return isWaiterSkipped;
    }


    public void setIsWaiterSkipped(Boolean isWaiterSkipped) {
        this.isWaiterSkipped = isWaiterSkipped;
    }


    public Boolean getIsRunnerSkipped() {
        return isRunnerSkipped;
    }


    public void setIsRunnerSkipped(Boolean isRunnerSkipped) {
        this.isRunnerSkipped = isRunnerSkipped;
    }


    public Boolean getIsDispatcherSkipped() {
        return isDispatcherSkipped;
    }

    public void setIsDispatcherSkipped(Boolean isDispatcherSkipped) {
        this.isDispatcherSkipped = isDispatcherSkipped;
    }

    public Boolean getIsRunnerOnDemand() {
        return isRunnerOnDemand;
    }

    public void setIsRunnerOnDemand(Boolean isRunnerOnDemand) {
        this.isRunnerOnDemand = isRunnerOnDemand;
    }

    public void setNode(String node) {
        this.node = node;
    }

    public String getJobnet() {
        return jobnet;
    }

    public void setJobnet(String jobnet) {
        this.jobnet = jobnet;
    }

    public Integer getStatusWaiter() {
        return statusWaiter;
    }

    public void setStatusWaiter(Integer statusWaiter) {
        this.statusWaiter = statusWaiter;
    }

    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    public Integer getStatusRunner() {
        return statusRunner;
    }

    public void setStatusRunner(Integer statusRunner) {
        this.statusRunner = statusRunner;
    }

    public Integer getStatusDispatcher() {
        return statusDispatcher;
    }

    public void setStatusDispatcher(Integer statusDispatcher) {
        this.statusDispatcher = statusDispatcher;
    }

    public Boolean getBootstrap() {
        return bootstrap;
    }

    public void setBootstrap(Boolean bootstrap) {
        this.bootstrap = bootstrap;
    }

    public void setUuid(String uuid) {
        this.uuid = uuid;
    }


    public String getUuid() {
        return uuid;
    }


    public String getSchedulerId() {
        return schedulerId;
    }

    public void setSchedulerId(String schedulerId) {
        this.schedulerId = schedulerId;
    }

    public void setSearchField(String searchField) {
        this.searchField = searchField;
    }

    public DateTime getPlannedStartTimeFrom() {
        return plannedStartTimeFrom;
    }

    public DateTime getPlannedStartTimeTo() {
        return plannedStartTimeTo;
    }

    public DateTime getStartTimeFrom() {
        return startTimeFrom;
    }

    public DateTime getStartTimeTo() {
        return startTimeTo;
    }

    public void setPlannedStartTimeFrom(DateTime plannedStartTimeFrom) {
        this.plannedStartTimeFrom = plannedStartTimeFrom;
    }

    public void setPlannedStartTimeFrom(String plannedStartTimeFrom) throws ParseException {
        if (plannedStartTimeFrom.equals("")) {
            this.plannedStartTimeFrom = null;
        } else {
            setPlannedStartTimeFrom(formatter.parseDateTime(plannedStartTimeFrom));
        }
    }

    public void setPlannedStartTimeTo(DateTime plannedStartTimeTo) {
        this.plannedStartTimeTo = plannedStartTimeTo;
    }

    public void setPlannedStartTimeTo(String plannedStartTimeTo) throws ParseException {
        if (plannedStartTimeTo.equals("")) {
            this.plannedStartTimeTo = null;
        } else {
            setPlannedStartTimeTo(formatter.parseDateTime(plannedStartTimeTo));
        }
    }

    public void setStartTimeTo(DateTime startTimeTo) {
        this.startTimeTo = startTimeTo;
    }

    public void setStartTimeTo(String startTimeTo) throws ParseException {
        if (startTimeTo.equals("")) {
            this.startTimeTo = null;
        } else {
            setPlannedStartTimeTo(formatter.parseDateTime(startTimeTo));
        }
    }

    public void setStartTimeFrom(DateTime startTimeFrom) {
        this.startTimeFrom = startTimeFrom;
    }

    public void setStartTimeFrom(String startTimeFrom) throws ParseException {
        if (startTimeFrom.equals("")) {
            this.startTimeFrom = null;
        } else {
            setStartTimeFrom(formatter.parseDateTime(startTimeFrom));
        }
    }

    public String getDateFormat() {
        return dateFormat;
    }

    public void setDateFormat(String dateFormat) {
        this.dateFormat = dateFormat;
        formatter = DateTimeFormat.forPattern(dateFormat);
    }

    public String getSearchField() {
        return searchField;
    }

    public void setSearchFiled(String searchField) {
        this.searchField = searchField;
    }


    @Override
    public String getTitle() {
        return "";
    }

    @Override
    public boolean isFiltered(DbItem h) {
        JobNetPlanDBItem j = (JobNetPlanDBItem) h;
        return !j.isJob();
    }


    public String getNodeType() {
        return nodeType;
    }


    public void setNodeType(String nodeType) {
        this.nodeType = nodeType;
    }


    public Long getTaskId() {
        return taskId;
    }


    public void setTaskId(Long taskId) {
        this.taskId = taskId;
    }

    public JobNetPlanDBItem getJobNetPlanDBItem() {
        return jobNetPlanDBItem;
    }

    public void setJobNetPlanDBItem(JobNetPlanDBItem jobNetPlanDBItem) {
        this.jobNetPlanDBItem = jobNetPlanDBItem;
    }


}
