package com.sos.jobnet.dialog.classes;

import java.io.File;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;

import com.sos.dashboard.globals.SOSDashboardOptions;
import com.sos.dialog.interfaces.ITableView;
import com.sos.jobnet.dataprovider.JobNetPlanDataProvider;
import com.sos.jobnet.db.JobNetPlanDBItem;
import com.sos.jobnet.dialog.SchedulerJobNetDataProvider;



public class JobNetNodeSubMenue extends Menu {
    private JobNetPlanDBItem jobNetPlanDBItem;
    private MenuItem waiterSkipped;
    private MenuItem runnerSkipped;
    private MenuItem dispatcherSkipped;
    private MenuItem startOnDemand;
    private ITableView iTableView;
    private JobNetPlanDataProvider jobNetPlanDataProvider;
    private SchedulerJobNetDataProvider schedulerJobNetDataProvider;

    
    public JobNetNodeSubMenue(SOSDashboardOptions objOptions, Menu parent, ITableView iTableView_) {
        super(parent);
        iTableView = iTableView_;
        createItems();
        jobNetPlanDataProvider = new JobNetPlanDataProvider(new File(objOptions.hibernateConfigurationFile.Value()), "");
     }
    
    protected void checkSubclass() {
        // Disable the check that prevents subclassing of SWT components
        } 
    
    private void createItems() {
        // =============================================================================================
        
        waiterSkipped = new MenuItem(this, SWT.CHECK);
        waiterSkipped.setText("Waiter skipped");
        waiterSkipped.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
            public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
                jobNetPlanDBItem.setIsWaiterSkipped(waiterSkipped.getSelection());
                jobNetPlanDataProvider.save(jobNetPlanDBItem);
                schedulerJobNetDataProvider.actualizeItem(jobNetPlanDBItem);
                
                String cmd = "Unskip waiter";
                if (waiterSkipped.getSelection()) {
                    cmd = "skip waiter";
                }
                schedulerJobNetDataProvider.createJobNetCmdHistory(jobNetPlanDBItem.getNodeId(), jobNetPlanDBItem.getHistoryId(), cmd, cmd);
                
                iTableView.buildTable();
            }

            public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {
            }
        });          

// =============================================================================================

        runnerSkipped = new MenuItem(this, SWT.CHECK);

        runnerSkipped.setText("Runner skipped");
        runnerSkipped.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
            public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
                jobNetPlanDBItem.setIsRunnerSkipped(runnerSkipped.getSelection());
                schedulerJobNetDataProvider.actualizeItem(jobNetPlanDBItem);
                jobNetPlanDataProvider.save(jobNetPlanDBItem);
                
                String cmd = "Unskip runner";
                if (waiterSkipped.getSelection()) {
                    cmd = "Skip runner";
                }
                schedulerJobNetDataProvider.createJobNetCmdHistory(jobNetPlanDBItem.getNodeId(), jobNetPlanDBItem.getHistoryId(), cmd, cmd);

                
                iTableView.buildTable();
             }

            public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {
            }
        });  

// =============================================================================================

        dispatcherSkipped = new MenuItem(this, SWT.CHECK);

        dispatcherSkipped.setText("Dispatcher skipped");
        dispatcherSkipped.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
            public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
                jobNetPlanDBItem.setIsDispatcherSkipped(dispatcherSkipped.getSelection());
                schedulerJobNetDataProvider.actualizeItem(jobNetPlanDBItem);
                jobNetPlanDataProvider.save(jobNetPlanDBItem);
                
                String cmd = "Unskip dispatcher";
                if (waiterSkipped.getSelection()) {
                    cmd = "Skip dispatcher";
                }
                schedulerJobNetDataProvider.createJobNetCmdHistory(jobNetPlanDBItem.getNodeId(), jobNetPlanDBItem.getHistoryId(), cmd, cmd);

                
                iTableView.buildTable();
             }

            public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {
            }
        });
        
     // =============================================================================================

        startOnDemand = new MenuItem(this, SWT.CHECK);

        startOnDemand.setText("Start on Demand");
        startOnDemand.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
            public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
              /*  jobNetPlanDBItem.setIsDispatcherSkipped(startOnDemand.getSelection());
                schedulerJobNetDataProvider.actualizeItem(jobNetPlanDBItem);
                jobNetPlanDataProvider.save(jobNetPlanDBItem);
                
                String cmd = "Unskip dispatcher";
                if (waiterSkipped.getSelection()) {
                    cmd = "Skip dispatcher";
                }
                schedulerJobNetDataProvider.createJobNetCmdHistory(jobNetPlanDBItem.getNodeId(), jobNetPlanDBItem.getHistoryId(), cmd, cmd);

                
                iTableView.buildTable();
                */
             }

            public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {
            }
        });          
    }
    
    
    public void setJobNetPlanDBItem(JobNetPlanDBItem jobNetPlanDBItem) {
        this.jobNetPlanDBItem = jobNetPlanDBItem;
        waiterSkipped.setSelection(jobNetPlanDBItem.getIsWaiterSkipped());
        runnerSkipped.setSelection(jobNetPlanDBItem.getIsRunnerSkipped());
        dispatcherSkipped.setSelection(jobNetPlanDBItem.getIsDispatcherSkipped());
    }
    /**
     * @param args
     */
    public static void main(String[] args) {
        // TODO Auto-generated method stub

    }

    public void setSchedulerJobNetDataProvider(SchedulerJobNetDataProvider schedulerJobNetDataProvider) {
        this.schedulerJobNetDataProvider = schedulerJobNetDataProvider;
    }

}
