package com.sos.jobnet.dialog.classes;


import com.sos.jid.dialog.classes.SOSDashboardTableView;
import com.sos.jid.dialog.classes.SosTabLogItem;
import com.sos.dashboard.globals.DashBoardConstants;
import com.sos.dashboard.globals.SOSDashboardOptions;
import com.sos.dialog.interfaces.ITableView;
import com.sos.jobnet.db.JobNetPlanDBItem;
import com.sos.jobnet.dialog.SchedulerJobNetDataProvider;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Listener;

public class SOSDashboardTableViewJobNetPlan extends SOSDashboardTableView implements ITableView {
    private static final int    RIGHT_MOUSE_BUTTON          = 3;
    private JobNetNodeSubMenue jobNetNodeSubMenue;

    private static final String conTabLOG                   = "Log";
    private SchedulerJobNetDataProvider schedulerJobNetDataProvider;
    
    public SOSDashboardTableViewJobNetPlan(Composite composite_, SOSDashboardOptions objOptions_) {
        super(composite_);
        objOptions = objOptions_;
    }

    private ITableView getThis() {
        return this;
    }

    @Override
    public void createTable() {

        tableList = new SosJobNetPlanTable(mainViewComposite, SWT.FULL_SELECTION);
        tableList.addListener(SWT.MouseDown, new Listener() {
            @Override
            public void handleEvent(final Event event) {
                if (event.button == RIGHT_MOUSE_BUTTON) // rechte maustaste
                {
                    setRightMausclick(true);
                }
                else {
                    setRightMausclick(false);
                }
            }
        });
        tableList.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(final SelectionEvent e) {
                if (!isRightMouseclick()) {
                    showLog(tableList);
                }
            }
        });

        getList();
    }

    @Override
    public void createMenue() {
        final Menu contentMenu = new Menu(tableList);
        tableList.setMenu(contentMenu);
        MenuItem refresh = new MenuItem(contentMenu, SWT.PUSH);
        refresh.setText(Messages.getLabel(DashBoardConstants.conSOSDashB_Refresh));
        refresh.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
            public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
                actualizeList();
            }

            public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {
            }
        });
        // =============================================================================================
        MenuItem showLog = new MenuItem(contentMenu, SWT.PUSH);
        showLog.setText(Messages.getLabel(DashBoardConstants.conSOSDashB_show_log_in_new_tab));
        showLog.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
            public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
                SosTabLogItem tbtmLog = new SosTabLogItem(conTabLOG, logTabFolder, Messages);
                logTabFolder.setSelection(tbtmLog);
                showLog(tableList);
            }

            public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {
            }
        });
      /*  // =============================================================================================
        MenuItem skipUnskip = new MenuItem(contentMenu, SWT.PUSH);
        skipUnskip.setText(Messages.getLabel(DashBoardConstants.conSOSDashB_skipUnskip));
        skipUnskip.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
            public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
                JobNetPlanDBItem j = (JobNetPlanDBItem) tableList.getItem(tableList.getSelectionIndex()).getData();
                JobNetNodeCommandDialog t = new JobNetNodeCommandDialog(getThis(), new Shell(), SWT.DIALOG_TRIM, j, tableDataProvider);
                t.open();

            }

            public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {
            }
        });
*/
        
        new MenuItem(contentMenu, SWT.SEPARATOR);
        MenuItem options = new MenuItem(contentMenu, SWT.CASCADE);
        options.setText("Options");
        final JobNetNodeSubMenue jobNetNodeSubMenue  = new JobNetNodeSubMenue(objOptions,contentMenu,getThis());
        jobNetNodeSubMenue.setSchedulerJobNetDataProvider(schedulerJobNetDataProvider);
        options.setMenu(jobNetNodeSubMenue);
        contentMenu.addListener(SWT.Show, new Listener() {
            public void handleEvent(Event event) {
                jobNetNodeSubMenue.setSchedulerJobNetDataProvider(schedulerJobNetDataProvider);
                if (tableList.getSelectionIndex() >=0 ) {
                    JobNetPlanDBItem item = (JobNetPlanDBItem) tableList.getItem(tableList.getSelectionIndex()).getData();
                    if (item != null) {
                        jobNetNodeSubMenue.setJobNetPlanDBItem(item);
                    }
                
                }
                    
            }
          });
        
    }
    
    public void setSchedulerJobNetDataProvider(SchedulerJobNetDataProvider schedulerJobNetDataProvider) {
        this.schedulerJobNetDataProvider = schedulerJobNetDataProvider;
     }
}
