package com.sos.jobnet.dialog.classes;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.io.File;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Composite;

public class SOSJobNetImageViewer {
    protected Composite parent_composite = null;
    private File        imageFile;
    private Image       image;
    private Composite   composite;
    private Canvas      canvas;

    public SOSJobNetImageViewer(Composite composite_) throws Exception {
        super();
        this.parent_composite = composite_;
        createContent();

    }

    private void createContent() {
        composite = null;
        ScrolledComposite sc = new ScrolledComposite(this.parent_composite, SWT.H_SCROLL | SWT.V_SCROLL | SWT.BORDER);
        composite = new Composite(sc, SWT.NONE);
        composite.setLayout(new FillLayout());
        composite.setSize(400, 400);
        sc.setContent(composite);
        sc.setExpandHorizontal(true);
        sc.setExpandVertical(true);
        sc.setMinSize(composite.computeSize(1000, 1000));

        final int canvasStyle = SWT.H_SCROLL | SWT.V_SCROLL;
        canvas = new Canvas(composite, canvasStyle);

        canvas.addPaintListener(new PaintListener() {
            public void paintControl(PaintEvent e) {
                if (image != null) {
                    final int width = image.getBounds().width;
                    final int height = image.getBounds().height;
                    e.gc.drawImage(image, 0, 0, width, height, 0, 0, (int) (width * 0.4), (int) (height * 0.4));
                }
            }
        });

    }

    public void setImageFile(File imageFile) {
        this.imageFile = imageFile;
        image = new Image(composite.getDisplay(), this.imageFile.getAbsolutePath());
        final int width = image.getBounds().width;
        final int height = image.getBounds().height;
        GC gc = new GC(canvas);
        gc.drawImage(image, 0, 0, width, height, 0, 0, (int) (width * 0.4), (int) (height * 0.4));

    }

}