package com.sos.jobnet.dialog.classes;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.CTabFolder;
import org.eclipse.swt.custom.CTabItem;
import org.eclipse.swt.layout.FillLayout;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;

import com.sos.JSHelper.Exceptions.JSExceptionMandatoryOptionMissing;
import com.sos.dashboard.globals.SOSDashboardOptions;
import com.sos.jobnet.db.JobNetHistoryDBItem;
import com.sos.jobnet.db.JobNetTreeDBItem;
import com.sos.jobnet.frontend.JobnetShowGraph;

@SuppressWarnings("deprecation")
public class SOSTabGraphicalOverview extends CTabItem {
    private final Composite parentComposite;
    private JobnetShowGraph showGraphView;
    SOSDashboardOptions             objOptions;

    public Group            left;

    public SOSTabGraphicalOverview(String caption, CTabFolder parentTabfolder,SOSDashboardOptions objOptions_) {
        super(parentTabfolder, SWT.NONE);
        setText(caption);

        parentComposite = new Composite(parentTabfolder, SWT.NONE);
        objOptions = objOptions_;
        FillLayout layout = new FillLayout();
        parentComposite.setLayout(layout);
        // parentComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
        createContent();

        parentComposite.layout();
        this.setControl(parentComposite);
    }

    private void createContent() {
        try {
            showGraphView = new JobnetShowGraph(parentComposite,objOptions);
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }

    public Composite getParentComposite() {
        return parentComposite;
    }

    public void disableRefresh() {
        showGraphView.disableRefresh();

    }

    public void enableRefresh() {
        showGraphView.resetRefreshTimer();
    }

    public void resetRefresh() {
        showGraphView.resetRefresh();
    }
    
    public void actualize() {
        showGraphView.actualizeGraph();
    }

    public void setJobNetHistoryDBItem(JobNetTreeDBItem jobNetTreeDBItem) throws JSExceptionMandatoryOptionMissing, Exception {

        showGraphView.setJobNetHistoryDBItem(jobNetTreeDBItem);
    }

}
