package com.sos.jobnet.dialog.classes;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.CTabFolder;
import org.eclipse.swt.custom.CTabItem;
import org.eclipse.swt.custom.SashForm;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;

import com.sos.dashboard.globals.SOSDashboardOptions;
import com.sos.jobnet.frontend.JobnetMainWindow;
import com.sos.jobnet.frontend.JobnetShowTree;

public class SOSTabJOBNET extends CTabItem {

    private final Composite         composite;

 //   private SOSTabJobnetMonitor     tbtmJobnetMonitor;
 //   private SOSTabGraphicalOverview tbtmGraphicalOverview;

    private SashForm                mainSashForm;
    private SashForm                treeSashForm;
    JobnetMainWindow jobnetMainWindow;
    JobnetShowTree jobnetShowTree;
    
    SOSDashboardOptions             objOptions;

    public SOSTabJOBNET(SOSDashboardOptions objOptions_, final String caption, final CTabFolder parent) {
        super(parent, SWT.NONE);
        setText(caption);
        composite = new Composite(parent, SWT.NONE);
        GridLayout layout = new GridLayout(1, false);
        composite.setLayout(layout);
        objOptions = objOptions_;

        createFormParts();
        createMainWindow();

        composite.layout();
        this.setControl(composite);

    }

    private void createFormParts() {
        mainSashForm = new SashForm(composite, SWT.HORIZONTAL );
        mainSashForm.setSashWidth(10);

        GridData gd_sashForm = new GridData(GridData.FILL_BOTH);
        gd_sashForm.heightHint = 60;
        mainSashForm.setLayoutData(gd_sashForm);

        treeSashForm = new SashForm(mainSashForm, SWT.HORIZONTAL);
        treeSashForm.setSashWidth(10);

        composite.layout();

    }

    public void disableRefresh() {
      /*  if (tbtmGraphicalOverview != null) {
            tbtmGraphicalOverview.disableRefresh();
            tbtmJobnetMonitor.disableRefresh();
        }
        */

    }

    public void enableRefresh() {
      /*  if (tbtmGraphicalOverview != null) {
            tbtmGraphicalOverview.enableRefresh();
            tbtmJobnetMonitor.enableRefresh();
        }
        */

    }

    protected void createMainWindow() {
        jobnetMainWindow = new JobnetMainWindow(mainSashForm, objOptions);
        jobnetShowTree = new JobnetShowTree(treeSashForm, objOptions,jobnetMainWindow);
     }

    public void refresh() {
        jobnetMainWindow.refresh();
        jobnetShowTree.refresh();
    }

}