package com.sos.jobnet.dialog.classes;

/**
* \class SosTabJOC 
* 
* \brief SosTabJOC - 
* 
* \details
*
* \section SosTabJOC.java_intro_sec Introduction
*
* \section SosTabJOC.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author Uwe Risse
* \version 25.01.2012
* \see reference
*
* Created on 25.01.2012 11:47:41
 */
import java.util.Timer;

import org.apache.log4j.Logger;
import org.eclipse.swt.SWT;

import org.eclipse.swt.custom.CTabFolder;
import org.eclipse.swt.custom.CTabItem;

import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Table;

import com.sos.JSHelper.Exceptions.JSExceptionMandatoryOptionMissing;
import com.sos.dashboard.globals.SOSDashboardOptions;

import com.sos.jobnet.db.JobNetHistoryDBItem;
import com.sos.jobnet.db.JobNetTreeDBItem;
import com.sos.jobnet.frontend.JobnetCmdHistory;
import com.sos.jobnet.frontend.JobnetMonitor;
import com.sos.jobnet.frontend.JobnetShowGraph;

public class SOSTabJobnetCmdHistory extends CTabItem {

    private static Logger       logger     = Logger.getLogger(SOSTabJobnetCmdHistory.class);

    private Composite           parentComposite;
    private GridLayout          layout;
    private Table               table;
    private JobnetCmdHistory    showCmdHistory;
    private SOSDashboardOptions objOptions = null;

    public SOSTabJobnetCmdHistory(String caption, CTabFolder parentTabfolder, SOSDashboardOptions objOptions_) {
        super(parentTabfolder, SWT.NONE);
        objOptions = objOptions_;
        setText(caption);

        parentComposite = new Composite(parentTabfolder, SWT.NONE);
        layout = new GridLayout(1, false);
        parentComposite.setLayout(layout);
        createContent();

        parentComposite.layout();
        this.setControl(parentComposite);
    }

    private void createContent() {
        try {
            showCmdHistory = new JobnetCmdHistory(parentComposite);
        }
        catch (Exception e) {
            e.printStackTrace();
        }

    }

    public void setJobNetTreeDBItem(JobNetTreeDBItem jobNetTreeDBItem) throws JSExceptionMandatoryOptionMissing, Exception {
      if (jobNetTreeDBItem != null) {
        showCmdHistory.getJobNetCmdHistoryDataProvider().getFilter().setHistoryId(jobNetTreeDBItem.getHistoryId());
        showCmdHistory.getTableData();
      }
    }

    public void actualize() {
        showCmdHistory.actualizeList();
    }

    public Composite getParentComposite() {
        return parentComposite;
    }

    public Table getTable() {
        return table;
    }

    public void disableRefresh() {
        showCmdHistory.disableRefresh();
    }

    public void enableRefresh() {
        showCmdHistory.resetRefreshTimer();
    }
}
