package com.sos.jobnet.frontend;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;

import com.sos.jobnet.db.JobNetPlanDBItem;
import org.eclipse.swt.widgets.Label;

public class JobNetNodeCommand extends Composite {

    /**
     * Create the composite.
     * @param parent
     * @param style
     */
    private Button           btnOk;
    private Button           btnCancel;
    private Group            group;
    private Button           btnCheckDispatcherSkipped;
    private Button           btnCheckRunnerSkipped;
    private Button           btnCheckWaiterSkipped;

    private JobNetPlanDBItem jobNetPlanDBItem;

    public JobNetNodeCommand(Composite parent, int style) {
        super(parent, style);
        setLayout(new GridLayout(3, false));

        createContent();

    }

    private void createContent() {
        group = new Group(this, SWT.NONE);
        GridData gd_group = new GridData(SWT.FILL, SWT.CENTER, false, false, 3, 1);
        gd_group.widthHint = 183;
        group.setLayoutData(gd_group);
        group.setLayout(new GridLayout(1, false));
        
                btnCheckWaiterSkipped = new Button(group, SWT.CHECK);
                btnCheckWaiterSkipped.setText("Waiter Skipped");
        
                btnCheckRunnerSkipped = new Button(group, SWT.CHECK);
                btnCheckRunnerSkipped.setText("Runner Skipped");

        btnCheckDispatcherSkipped = new Button(group, SWT.CHECK);
        btnCheckDispatcherSkipped.setText("Dispatcher Skipped");

        btnOk = new Button(this, SWT.NONE);

        GridData gd_btnOk = new GridData(SWT.LEFT, SWT.TOP, false, false, 1, 1);
        gd_btnOk.widthHint = 91;
        gd_btnOk.minimumWidth = 100;
        btnOk.setLayoutData(gd_btnOk);
        btnOk.setText("Ok");

        btnCancel = new Button(this, SWT.NONE);
        GridData gd_btnCancel = new GridData(SWT.LEFT, SWT.TOP, false, false, 1, 1);
        gd_btnCancel.minimumWidth = 100;
        gd_btnCancel.widthHint = 101;
        btnCancel.setLayoutData(gd_btnCancel);
        btnCancel.setText("Cancel");
        new Label(this, SWT.NONE);
    }

    @Override
    protected void checkSubclass() {
        // Disable the check that prevents subclassing of SWT components
    }

    public Button getBtnOk() {
        return btnOk;
    }

    public void setJobNetPlanDBItem(JobNetPlanDBItem jobNetPlanDBItem) {
        this.jobNetPlanDBItem = jobNetPlanDBItem;
        group.setText(jobNetPlanDBItem.getTitle());
        btnCheckDispatcherSkipped.setSelection(jobNetPlanDBItem.getIsDispatcherSkipped());
        btnCheckRunnerSkipped.setSelection(jobNetPlanDBItem.getIsRunnerSkipped());
        btnCheckWaiterSkipped.setSelection(jobNetPlanDBItem.getIsWaiterSkipped());
    }

    public Button getBtnCancel() {
        return btnCancel;
    }

    public void updateDBItem() {
        jobNetPlanDBItem.setIsDispatcherSkipped(btnCheckDispatcherSkipped.getSelection());
        jobNetPlanDBItem.setIsRunnerSkipped(btnCheckRunnerSkipped.getSelection());
        jobNetPlanDBItem.setIsWaiterSkipped(btnCheckWaiterSkipped.getSelection());
    }

    public JobNetPlanDBItem getJobNetPlanDBItem() {
        return jobNetPlanDBItem;
    }

}
