package com.sos.jobnet.frontend;

import java.io.File;
import java.util.Date;
import java.util.Timer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.SashForm;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Shell;

import com.sos.jobnet.dialog.classes.SOSDashboardTableViewJobNetCmdHistory;

import com.sos.dialog.interfaces.ITableView;
import com.sos.jobnet.dataprovider.JobNetCmdHistoryDataProvider;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.Label;

/*
 * Created on 23.06.2008
 *
 * To change the template for this generated file go to
 
 */

public class JobnetCmdHistory implements ITableView {
    protected Composite                           composite                    = null;

    private Timer                                 timer;



    private Group                                 top                          = null;


    private SOSDashboardTableViewJobNetCmdHistory tableViewJobNetCmdHistory;

    private File                                  configurationFile;
    private JobNetCmdHistoryDataProvider          jobNetCmdHistoryDataProvider = null;
    private boolean                               isActive                     = false;

    public JobnetCmdHistory(final Composite composite_) {
        super();
        composite = composite_;
        //createFormParts();
        createContent();
    }

    private void createContent() {
        top = new Group(composite, SWT.NONE);
        top.setLayout(new GridLayout(1, false));
        top.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 9, 1));
        timer = new Timer();
        createTop();
    }

    private void createTop() {
        final GridLayout gridLayout = new GridLayout();
        gridLayout.numColumns = 9;
        composite.setLayout(gridLayout);
        composite.layout();
        createTableJobNetCmdHistory();
        timer = new Timer();
    }

    private void createTableJobNetCmdHistory() {
        jobNetCmdHistoryDataProvider = new JobNetCmdHistoryDataProvider(configurationFile, "");
        tableViewJobNetCmdHistory = new SOSDashboardTableViewJobNetCmdHistory(top);
        //       tableViewJobNet.setObjOptions(objOptions);
        tableViewJobNetCmdHistory.mainViewComposite = top;
        tableViewJobNetCmdHistory.setLeftTabFolder(null);
        //tableViewJobNet.setPrefs(prefs); 
        tableViewJobNetCmdHistory.setRight(null);
        tableViewJobNetCmdHistory.setLeft(top);
        tableViewJobNetCmdHistory.setTableDataProvider(jobNetCmdHistoryDataProvider);
        jobNetCmdHistoryDataProvider.getFilter().setCmdHistoryId((long) -1);
        tableViewJobNetCmdHistory.createTable();
        tableViewJobNetCmdHistory.createMenue();
    }

    public Timer getTimer() {
        return timer;
    }

    public void resetRefreshTimer() {
        timer.cancel();
        timer = new Timer();
        isActive = true;
    }

    public void disableRefresh() {
        timer.cancel();
        isActive = false;
    }

    @Override
    public void getTableData() {
        if (isActive) {
            tableViewJobNetCmdHistory.getTableData();
        }
    }

    @Override
    public void buildTable() {
        tableViewJobNetCmdHistory.buildTable();
    }

    @Override
    public void createMenue() {
        tableViewJobNetCmdHistory.createMenue();
    }

    @Override
    public void getList() {
        tableViewJobNetCmdHistory.getList();
    }

    @Override
    public void actualizeList() {
        tableViewJobNetCmdHistory.actualizeList();
    }

    public void setConfigurationFile(File configurationFile) {
        this.configurationFile = configurationFile;
        tableViewJobNetCmdHistory.getTableData();
    }

    @Override
    public void createTable() {
    }

    public JobNetCmdHistoryDataProvider getJobNetCmdHistoryDataProvider() {
        return jobNetCmdHistoryDataProvider;
    }
}
