package com.sos.jobnet.frontend;


import java.io.File;
import java.util.Timer;

import org.apache.log4j.Logger;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.SashForm;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.TreeItem;
import org.eclipse.swt.widgets.Tree;

import com.sos.JSHelper.Exceptions.JSExceptionMandatoryOptionMissing;
import com.sos.JSHelper.Logging.Log4JHelper;
import com.sos.dashboard.globals.DashBoardConstants;
import com.sos.dashboard.globals.SOSDashboardOptions;
import com.sos.dialog.classes.FormBase;
import com.sos.jobnet.SchedulerJobNetTreeItem;
import com.sos.jobnet.db.JobNetDBItem;
import com.sos.jobnet.db.JobNetHistoryDBItem;
import com.sos.jobnet.db.JobNetNodeDBItem;
import com.sos.jobnet.db.JobNetPlanDBItem;
import com.sos.jobnet.db.JobNetTreeDBItem;
import com.sos.jobnet.dialog.SchedulerJobNetDataProvider;
import com.sos.jobnet.dialog.classes.JobNetNodeSubMenue;
import com.sos.jobnet.options.JobNetCreatorOptions;
import com.sos.jobnet.options.StartBehaviour;
import com.sos.jobnet.options.StartModes;
import com.sos.scheduler.db.SchedulerInstancesDBItem;
import com.sos.scheduler.db.SchedulerInstancesDBLayer;

import org.eclipse.swt.widgets.Label;


/*
 * Created on 23.06.2008
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */

public class JobnetShowTree extends FormBase {

    private static Logger               logger        = Logger.getLogger(JobnetShowGraph.class);

    @SuppressWarnings("unused")
    private static Log4JHelper          objLogger     = null;

    private final static String         conSVNVersion = "$Id: Editor.java 18748 2013-01-09 21:19:21Z kb $";
    protected Composite                 composite     = null;
    private Timer                       timer;
    private SchedulerJobNetDataProvider schedulerJobNetDataProvider;
    private JobnetMainWindow            jobnetMainWindow;
    private JobNetInfo                  jobNetInfo;
    private SashForm                    nodesSashForm;
    private SashForm                    mainSashForm;
   
    private Group top_1;
    private Group bottom_1;
    private Tree                        jobnetNodesTree;
    private                            Menu contentMenu;
    private SOSDashboardOptions objOptions;
    protected SchedulerInstancesDBLayer schedulerInstancesDBLayer;
    private JobNetNodeSubMenue jobNetNodeSubMenue;

    public JobnetShowTree(Composite composite_, SOSDashboardOptions objOptions_,JobnetMainWindow jobnetMainWindow_) {
        super(composite_, DashBoardConstants.conPropertiesFileName);
        this.composite = composite_;
        objOptions = objOptions_;
        jobnetMainWindow = jobnetMainWindow_;
        schedulerInstancesDBLayer = new SchedulerInstancesDBLayer(new File(objOptions_.hibernateConfigurationFile.Value()));
        schedulerJobNetDataProvider = new SchedulerJobNetDataProvider(new File(objOptions_.hibernateConfigurationFile.Value()));
        //   schedulerJobNetDataProvider.setFrom(new Date());
        //    schedulerJobNetDataProvider.setTo(new Date());
        schedulerJobNetDataProvider.getData(0);
        jobnetMainWindow.setSchedulerJobNetDataProvider(schedulerJobNetDataProvider);

        createFormParts();
        createContent();

    }

    private void createFormParts() {

        mainSashForm = new SashForm(composite, SWT.SMOOTH | SWT.VERTICAL);
        mainSashForm.setSashWidth(10);
  
        nodesSashForm = new SashForm(mainSashForm, SWT.HORIZONTAL);
        top_1 = new Group(nodesSashForm, SWT.NONE);

        bottom_1 = new Group(mainSashForm, SWT.NONE);
        final FillLayout fl_bottom = new FillLayout();
        bottom_1.setLayout(fl_bottom);

        final FillLayout fl_top = new FillLayout();
        top_1.setLayout(fl_top);
        mainSashForm.setWeights(new int[] {302, 298});
        composite.layout();

    }

    private void createContent() {
        createTop();
        createBottom();
        createMenue();
    }

    private JobNetCreatorOptions setJobnetCreatorOptions(String command, String behaviour) {
        final JobNetCreatorOptions jobNetCreatorOptions = new JobNetCreatorOptions();
        jobNetCreatorOptions.StartOption.Value(command);
        jobNetCreatorOptions.StartBehaviour.Value(behaviour);
        return jobNetCreatorOptions;
    }
    
    private JobNetCreatorOptions setJobnetCreatorOptions(String command) {
        final JobNetCreatorOptions jobNetCreatorOptions = new JobNetCreatorOptions();
        jobNetCreatorOptions.StartOption.Value(command);
        jobNetCreatorOptions.StartBehaviour.Value(StartBehaviour.immediately.name());
        return jobNetCreatorOptions;
    }
    
    private void executeMenueItem(JobNetCreatorOptions jobNetCreatorOptions) {
        SchedulerJobNetTreeItem item = (SchedulerJobNetTreeItem) jobnetNodesTree.getSelection()[0];
        if (item != null) {

            JobNetTreeDBItem d = item.getData();
            JobNetNodeDBItem n = null;
            if (d.isJobNetHistoryNode()) {
                d = (JobNetHistoryDBItem) item.getData();
                n = d.getJobNetNodeDBItem();
             }
            else {
                if (d.isJobNetPlanNode()) {
                    JobNetPlanDBItem p = (JobNetPlanDBItem) item.getData();
                    n = p.getJobNetNodeDBItem();
                    d = p.getJobNetHistoryDBItem();
                 }else {
                     if (d.isJobNetNode()) {
                         JobNetDBItem nx = (JobNetDBItem) item.getData();
                         jobNetCreatorOptions.OrderId.Value(nx.getJobNetName());
                         jobNetCreatorOptions.JobChainName.Value(nx.getJobNet());

                         start(d,jobNetCreatorOptions);
                     }
                 }
                
            }
            
            
            if (n != null) {
                jobNetCreatorOptions.OrderId.Value(n.getNode());
                jobNetCreatorOptions.JobChainName.Value(n.getJobnet());
 
                start(d,jobNetCreatorOptions);
            }
        }

    }
    private void dynamicalMenu() {// To have different context menues on different items
        contentMenu.addListener(SWT.Show, new Listener() {
            public void handleEvent(Event event) {
                MenuItem[] menuItems = contentMenu.getItems();
                SchedulerJobNetTreeItem item = (SchedulerJobNetTreeItem) jobnetNodesTree.getSelection()[0];
                if (item != null) {
                    
                    JobNetTreeDBItem d = item.getData();
                    if (d.isJobNetPlanNode()) {
                        jobNetNodeSubMenue.setJobNetPlanDBItem((JobNetPlanDBItem)item.getData());
                    }
                    menuItems[5].setEnabled(item.isJobNetNode());
                    menuItems[menuItems.length-1].setEnabled(d.isJobNetPlanNode());
                    for (int i = 6; i < menuItems.length-1; i++) {
                            menuItems[i].setEnabled(item.isHistoryNode());
                    }
                }
            }
          });
    }
    
    public void createMenue() {
        contentMenu = new Menu(jobnetNodesTree);
        Menu startMenu = new Menu(contentMenu);
        jobnetNodesTree.setMenu(contentMenu);

        // =============================================================================================

        new MenuItem(contentMenu, SWT.SEPARATOR);

        /*MenuItem filterButton = new MenuItem(contentMenu, SWT.PUSH);

        filterButton.setText(DashBoardConstants.conSOSJobnet_filter);
        filterButton.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
            public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
                 

            }

            public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {
            }
        });*/
        
        MenuItem collapse = new MenuItem(contentMenu, SWT.PUSH);

        collapse.setText(Messages.getLabel(DashBoardConstants.conSOSJobnet_collapse));
        collapse.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
            public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
                 collapse();

            }

            public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {
            }
        });
        // =============================================================================================
        MenuItem expand = new MenuItem(contentMenu, SWT.PUSH);

        expand.setText(Messages.getLabel(DashBoardConstants.conSOSJobnet_expand));
        expand.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
            public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
                 expand();

            }

            public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {
            }
        });
        // =============================================================================================

        MenuItem refresh = new MenuItem(contentMenu, SWT.PUSH);

        refresh.setText(Messages.getLabel(DashBoardConstants.conSOSJobnet_refresh));
        refresh.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
            public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
               refresh();
            }

            public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {
            }
        });
                
        // =============================================================================================

        new MenuItem(contentMenu, SWT.SEPARATOR);

        MenuItem startJobnet = new MenuItem(contentMenu, SWT.CASCADE);

        startJobnet.setText(Messages.getLabel(DashBoardConstants.conSOSDashB_JobNet));
        startJobnet.setMenu(startMenu);
        
                            // =============================================================================================
       
                            MenuItem startJobnetImmediately = new MenuItem(startMenu, SWT.PUSH);
                    
                            startJobnetImmediately.setText(Messages.getLabel(DashBoardConstants.conSOSDashB_start_now));
                            startJobnetImmediately.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
                                public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
                                    executeMenueItem(setJobnetCreatorOptions(StartModes.start.name(),StartBehaviour.immediately.name()));
                                }
                    
                                public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {
                                }
                            });
        
        // =============================================================================================

                            MenuItem startJobnetOnDemand = new MenuItem(startMenu, SWT.PUSH);
                    
                            startJobnetOnDemand.setText(Messages.getLabel(DashBoardConstants.conSOSDashB_start_on_demand));
                            startJobnetOnDemand.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
                                public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
                                    executeMenueItem(setJobnetCreatorOptions(StartModes.start.name(),StartBehaviour.on_demand.name()));
                                }
                    
                                public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {
                                }
                            });  
        
        // =============================================================================================

                            MenuItem startJobnetAtRuntime = new MenuItem(startMenu, SWT.PUSH);
                    
                            startJobnetAtRuntime.setText(Messages.getLabel(DashBoardConstants.conSOSDashB_start_at_runtime));
                            startJobnetAtRuntime.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
                                public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
                                    executeMenueItem(setJobnetCreatorOptions(StartModes.start.name(),StartBehaviour.at_runtime.name()));
                                }
                    
                                public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {
                                }
                            });  

        // =============================================================================================

        new MenuItem(contentMenu, SWT.SEPARATOR);
        MenuItem startIndependent = new MenuItem(contentMenu, SWT.PUSH);

        startIndependent.setText(Messages.getLabel(DashBoardConstants.conSOSJobnet_Start_Independent));
        startIndependent.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
            public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
                executeMenueItem(setJobnetCreatorOptions(StartModes.start_independent.name()));
            }

            public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {
            }
        });        
        
        
        // =============================================================================================

        MenuItem repeat = new MenuItem(contentMenu, SWT.PUSH);

        repeat.setText(Messages.getLabel(DashBoardConstants.conSOSJobnet_Repeat));
        repeat.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
            public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
                executeMenueItem(setJobnetCreatorOptions(StartModes.repeat.name()));
            }

            public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {
            }
        });        
        
        
        // =============================================================================================

        MenuItem restartError = new MenuItem(contentMenu, SWT.PUSH);

        restartError.setText(Messages.getLabel(DashBoardConstants.conSOSJobnet_Restart_Error));
        restartError.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
            public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
                executeMenueItem(setJobnetCreatorOptions(StartModes.restart_error.name()));
            }

            public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {
            }
        });           
        

        
        // =============================================================================================

//        new MenuItem(contentMenu, SWT.SEPARATOR);
        MenuItem restartIgnoreError = new MenuItem(contentMenu, SWT.PUSH);

        restartIgnoreError.setText(Messages.getLabel(DashBoardConstants.conSOSJobnet_Restart_Ignore_Error));
        restartIgnoreError.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
            public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
                executeMenueItem(setJobnetCreatorOptions(StartModes.restart_ignore_error.name()));
            }

            public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {
            }
        });
        
        // =============================================================================================
        MenuItem startOnDemand = new MenuItem(contentMenu, SWT.PUSH);

        startOnDemand.setText(Messages.getLabel(DashBoardConstants.conSOSJobnet_Start_On_Demand));
        startOnDemand.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
            public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
             }

            public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {
            }
        });
        
        // =============================================================================================

        MenuItem kill = new MenuItem(contentMenu, SWT.PUSH);

        kill.setText(Messages.getLabel(DashBoardConstants.conSOSJobnet_Kill));
        kill.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
            public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
                executeMenueItem(setJobnetCreatorOptions(StartModes.kill.name()));
            }

            public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {
            }
        });  
        
        // =============================================================================================

        MenuItem abort = new MenuItem(contentMenu, SWT.PUSH);

        abort.setText(Messages.getLabel(DashBoardConstants.conSOSJobnet_Abort));
        abort.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
            public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
                executeMenueItem(setJobnetCreatorOptions(StartModes.abort.name()));
            }

            public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {
            }
        });         

        
        // =============================================================================================
        new MenuItem(contentMenu, SWT.SEPARATOR);
        MenuItem options = new MenuItem(contentMenu, SWT.CASCADE);
        options.setText("Options");
        jobNetNodeSubMenue  = new JobNetNodeSubMenue(objOptions,contentMenu,jobnetMainWindow.getTbtmJobnetMonitor().getTableViewJobNet());
        jobNetNodeSubMenue.setSchedulerJobNetDataProvider(schedulerJobNetDataProvider);
        options.setMenu(jobNetNodeSubMenue);
        
        
        
        // =============================================================================================
        dynamicalMenu();
    }

    private void createTop() {

        jobnetNodesTree = new Tree(top_1, SWT.NONE);
        jobnetNodesTree.addListener(SWT.MouseDown, new Listener() {
            @Override
            public void handleEvent(final Event event) {
                if (event.button == DashBoardConstants.conSOSDashB_Right_Mouse_Button) // rechte maustaste
                {
                    setRightMausclick(true);
                } else {
                    setRightMausclick(false);
                }
            }
        });
        
        jobnetNodesTree.addListener(SWT.MouseDown, new Listener() {
            @Override
            public void handleEvent(final Event event) {
                Point point = new Point(event.x, event.y);
                SchedulerJobNetTreeItem item = (SchedulerJobNetTreeItem) jobnetNodesTree.getItem(point);
                if (item != null && !isRightMouseclick()) {
                    try {
                        JobNetTreeDBItem d = item.getData();
                        if (d.isJobNetHistoryNode()) {
                            d = (JobNetHistoryDBItem) item.getData();
                            jobNetInfo.setJobNetHistoryDBItem(d);
                        }
                        else {

                            if (d.isJobNetPlanNode()) {
                                d = (JobNetPlanDBItem) item.getData();
                                JobNetPlanDBItem p = (JobNetPlanDBItem)d;
                                jobNetInfo.setJobNetHistoryDBItem(p.getJobNetHistoryDBItem());
                            }
                             
                        }

                        jobnetMainWindow.getTbtmGraphicalOverview().setJobNetHistoryDBItem(d);
                        jobnetMainWindow.getTbtmJobnetMonitor().setJobNetTreeDBItem(d);
                        jobnetMainWindow.getTbtmJobnetCmdHistory().setJobNetTreeDBItem(d);

                    }

                    catch (JSExceptionMandatoryOptionMissing e) {
                        e.printStackTrace();
                    }
                    catch (Exception e) {
                        e.printStackTrace();
                    }

                }
            }
        });

        schedulerJobNetDataProvider.fillTree(jobnetNodesTree);
    }

    
    public void refresh() {
        schedulerJobNetDataProvider.getData(0);
        schedulerJobNetDataProvider.fillTree(jobnetNodesTree);

    }
    
    public void collapse() {
        TreeItem[] selection = jobnetNodesTree.getSelection();
        if(selection.length > 0){
            schedulerJobNetDataProvider.expand(jobnetNodesTree,selection[0], false);
        } 
 
    }
    public void expand() {
        TreeItem[] selection = jobnetNodesTree.getSelection();
        if(selection.length > 0){
            schedulerJobNetDataProvider.expand(jobnetNodesTree,selection[0], true);
        } 
    }
     
    
    
    protected void start(JobNetTreeDBItem jobNetTreeDBItem,JobNetCreatorOptions jobNetCreatorOptions) {
         
        SchedulerInstancesDBItem schedulerInstanceDBItem = schedulerInstancesDBLayer.getInstanceById(jobNetTreeDBItem.getSchedulerId());
        if (schedulerInstanceDBItem != null) {

        
             setMsg(String.format("Could not open JobScheduler Instanz %s",jobNetTreeDBItem.getSchedulerId()));
        }else {
            JobNetStartOrderDialog t = new JobNetStartOrderDialog(  new Shell(), SWT.DIALOG_TRIM, jobNetCreatorOptions, schedulerInstanceDBItem);
            t.open(this);
        }
    }

    private void createBottom() {
        jobNetInfo = new JobNetInfo(bottom_1, SWT.NO_REDRAW_RESIZE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
        new Label(jobNetInfo, SWT.NONE);
     
        
    }

    public Timer getTimer() {
        return timer;
    }

    public void resetRefreshTimer() {
        timer.cancel();
        timer = new Timer();
    }

    public void disableRefresh() {
        timer.cancel();
    }

   
    
    public void setMsg(String msg) {
        jobNetInfo.setMsg(msg);
        
    }
}