package com.sos.jobnet.graph;

import com.sos.JSHelper.Exceptions.JobSchedulerException;
import com.sos.jobnet.creator.jobs.JobNetJobAdapterLogBackClass;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class JobNetGraphBuilderJSAdapterClass extends JobNetJobAdapterLogBackClass {
	
	private final String					conClassName						= "JobNetCreatorJSAdapterClass";  //$NON-NLS-1$

	private static Logger		logger			= LoggerFactory.getLogger(JobNetGraphBuilderJSAdapterClass.class);
	
	@SuppressWarnings("unused")
	private	final String		conSVNVersion			= "$Id: JobNetPlanCreatorJSAdapterClass.java 16850 2012-03-21 12:14:23Z ss $";

	public void init() {
		doInitialize();
	}

	private void doInitialize() {
	}

	@Override
	public boolean spooler_init() {
		return super.spooler_init();
	}

	@Override
	public boolean spooler_process() throws Exception {
		try {
			super.spooler_process();
			doProcessing();
		}
		catch (Exception e) {
			throw e;
		}
		return (spooler_task.job().order_queue() != null);
	}

	@Override
	public void spooler_exit() {
		super.spooler_exit();
	}

	private void doProcessing() throws Exception {
		
		final String conMethodName = conClassName + "::doProcessing"; //$NON-NLS-1$

		logger.debug(String.format(Messages.getMsg("JSJ-I-110"), conMethodName ) );

		try { 
			JobNetGraphBuilderOptions options = new JobNetGraphBuilderOptions();
			options.setAllOptions(getAllParametersAsProperties());
			options.CheckMandatory();
			logger.debug(options.toString());
			JobNetGraphBuilderJob builder = new JobNetGraphBuilderJob(options);
			builder.run();
			if (!builder.isJobnetStarted()) {
				throw new JobSchedulerException("Error creating the jobnet graph.");
			}
			logger.debug(String.format(Messages.getMsg("JSJ-I-111"), conMethodName ) );
 		} catch (Exception e) {
			String msgText = String.format(Messages.getMsg("JSJ-I-107"), conMethodName );
			logger.error(msgText);
			throw new JobSchedulerException(msgText,e);
		}

	}

}

