package com.sos.jobnet.options;

import com.sos.JSHelper.Options.JSOptionsClass;
import com.sos.JSHelper.Options.SOSOptionString;
import com.sos.jobnet.classes.JobNetException;

public class SOSOptionStartBehaviourJobnet extends SOSOptionString {

	public SOSOptionStartBehaviourJobnet(JSOptionsClass pPobjParent, String pPstrKey, String pPstrDescription, String pPstrValue, String pPstrDefaultValue, boolean pPflgIsMandatory) {
		super(pPobjParent, pPstrKey, pPstrDescription, pPstrValue, pPstrDefaultValue, pPflgIsMandatory);
	}

	public boolean isOnDemand() {
		return (this.Value().equalsIgnoreCase(StartBehaviour.on_demand.name()));
	}

	public boolean isImmediately() {
		return (this.Value().equalsIgnoreCase(StartBehaviour.immediately.name()));
	}

	public boolean isAtRuntime() {
		return (this.Value().equalsIgnoreCase(StartBehaviour.at_runtime.name()));
	}

    public StartBehaviour asEnum() {
    	return StartBehaviour.valueOf(Value());
    }

    public void Value(String value) {
        String testValue = value.toLowerCase();
        try {
            StartBehaviour t = StartBehaviour.valueOf(testValue);
        } catch (Exception e) {
            throw new JobNetException("Value " + testValue + " is not valid for " + strKey + " - valid values are " + StartBehaviour.asString() + ".");
        }
        super.Value(testValue);
    }

}
