package com.sos.jobnet.options;

/**
 * Different possibilities to start a jobnet
 *
 * @uthor ss
 * at 29.10.13 16:15
 */
public enum StartBehaviour {
    no_start,               // the jobnet instance will be placed in the database only, bootstrap order does not start
    on_demand,              // the jobnet starts and waits for user intervention, beside a runtime of the bootstrap order
    immediately,            // the jobnet start immmediately, beside a runtime of the bootstrap order
    at_runtime;             // the jobnet starts at the specified runtime (single_start)

    private final StartBehaviourText text;

    private StartBehaviour() {
        this.text = new StartBehaviourText(this);
    }

    public String getMsg() {
        return text.getMsg();
    }

    public static String asString() {
        StringBuffer result = new StringBuffer();
        result.append("[");
        for(StartBehaviour b : values()) {
            if(result.length() > 1) result.append(", ");
            result.append(b.name());
        }
        result.append("]");
        return result.toString();
    }

}
