package com.sos.jobnetmodel.live;

import com.sos.JSHelper.Exceptions.JobSchedulerException;

import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class ExitCodeList {

	private final static Pattern patternSingle = Pattern.compile("([0-9]*)");
	private final static Pattern patternRange = Pattern.compile("([0-9]*)\\s*-\\s*([0-9]*)");
	
	private ExitCodeList() {
	}
	
	public static List<Integer> getExitCodes(String exitCodesString) {
		List<Integer> result = new ArrayList<Integer>();
		if (exitCodesString != null && !exitCodesString.trim().isEmpty() ) {
			String[] arr = exitCodesString.split(",");
			for(String element : arr) {
				result.addAll(parseElement(exitCodesString,element));
			}
		}
		return result;
	}
	
	private static List<Integer> parseElement(String exitCodesString, String element) {
		List<Integer> result = new ArrayList<Integer>();
		String toParse = element.trim();
		if (!toParse.isEmpty()) {
			while (true) {
				Matcher m = patternSingle.matcher(element.trim());
				if (m.matches()) {
					result.add( Integer.valueOf(m.group(1)) );
					break;
				}
				m = patternRange.matcher(element.trim());
				if (m.matches()) {
					Integer from = Integer.valueOf(m.group(1));
					Integer to = Integer.valueOf(m.group(2));
					for(int i=from; i <= to; i++)
						result.add(i);
					break;
				}
				throw new JobSchedulerException("The element " + element + " of the String " + exitCodesString + " is not valid.");
			}
		}
		return result;
	}
	
}
