package com.sos.jobnetmodel.live;

import com.sos.JSHelper.Annotations.JSOptionClass;
import com.sos.JSHelper.Annotations.JSOptionDefinition;
import com.sos.JSHelper.Exceptions.JSExceptionMandatoryOptionMissing;
import com.sos.JSHelper.Listener.JSListener;
import com.sos.JSHelper.Options.SOSOptionBoolean;
import com.sos.JSHelper.Options.SOSOptionString;
import com.sos.hibernate.options.HibernateOptions;
import com.sos.jobnetmodel.objects.SOSOptionJobnetContext;

import java.util.HashMap;

@JSOptionClass(name = "JobnetOrderOptions", description = "Options for a jobnet order.")
public class JobnetOrderOptions  extends HibernateOptions {

    private static final long serialVersionUID = -9205280855610459964L;


    @SuppressWarnings("unused")
    private	final static String	conSVNVersion = "$Id: JobnetOrderOptions.java 16850 2012-03-21 12:14:23Z ss $";

    private final static String conClassName = JobnetOrderOptions.class.getSimpleName();

    // option nodetype -----------------------------------------------------------------------------------------
    @JSOptionDefinition(
            name = "nodetype",
            description = "Type of the jobnet node (SUBNET, CONNECTOR, NODE).",
            key = "nodetype",
            type = "SOSOptionJobnetContext",
            mandatory = false
    )

    public SOSOptionJobnetContext nodetype = new SOSOptionJobnetContext(
            this,
            conClassName + ".nodetype", // HashMap-Key
            "", // Titel
            "JOB", // InitValue
            "JOB", // DefaultValue
            false // isMandatory
    );

    public void setNodetype(SOSOptionJobnetContext nodetype) {
        this.nodetype = nodetype;
    }

    // option successor -----------------------------------------------------------------------------------------
    @JSOptionDefinition(
            name = "successor",
            description = "The successor nodes of the order.",
            key = "successor",
            type = "SOSOptionString",
            mandatory = false
    )
    public SOSOptionString successor = new SOSOptionString(
            this,
            conClassName + ".successor", // HashMap-Key
            "", // Titel
            "", // InitValue
            "", // DefaultValue
            false // isMandatory
    );

    public void setSuccessor(SOSOptionString successor) {
        this.successor = successor;
    }

    // option predecessor -----------------------------------------------------------------------------------------
    @JSOptionDefinition(
            name = "predecessor",
            description = "The predecessor nodes of the order.",
            key = "predecessor",
            type = "SOSOptionString",
            mandatory = false
    )
    public SOSOptionString predecessor = new SOSOptionString(
            this,
            conClassName + ".predecessor", // HashMap-Key
            "", // Titel
            "", // InitValue
            "", // DefaultValue
            false // isMandatory
    );

    public void setPredecessor(SOSOptionString predecessor) {
        this.predecessor = predecessor;
    }

    // option script_to_execute -----------------------------------------------------------------------------------------
    @JSOptionDefinition(
            name = "script_to_execute",
            description = "The script to execute by this order.",
            key = "script_to_execute",
            type = "SOSOptionString",
            mandatory = false
    )
    public SOSOptionString script_to_execute = new SOSOptionString(
            this,
            conClassName + ".script_to_execute", // HashMap-Key
            "", // Titel
            "", // InitValue
            "", // DefaultValue
            false // isMandatory
    );

    public void setScript_to_execute(SOSOptionString script_to_execute) {
        this.script_to_execute = script_to_execute;
    }

    // option event_on_success -----------------------------------------------------------------------------------------
    @JSOptionDefinition(
            name = "event_on_success",
            description = "The event to throw in case of succesfull execution of the order.",
            key = "event_on_success",
            type = "SOSOptionString",
            mandatory = false
    )
    public SOSOptionString event_on_success = new SOSOptionString(
            this,
            conClassName + ".event_on_success", // HashMap-Key
            "", // Titel
            "", // InitValue
            "", // DefaultValue
            false // isMandatory
    );

    public void setEvent_on_success(SOSOptionString event_on_success) {
        this.event_on_success = event_on_success;
    }

    // option event_on_error -----------------------------------------------------------------------------------------
    @JSOptionDefinition(
            name = "event_on_error",
            description = "The event to throw in case of unsuccesfull execution of the order.",
            key = "event_on_error",
            type = "SOSOptionString",
            mandatory = false
    )
    public SOSOptionString event_on_error = new SOSOptionString(
            this,
            conClassName + ".event_on_error", // HashMap-Key
            "", // Titel
            "", // InitValue
            "", // DefaultValue
            false // isMandatory
    );

    public void setEvent_on_error(SOSOptionString event_on_error) {
        this.event_on_error = event_on_error;
    }

    // option wait_for_events -----------------------------------------------------------------------------------------
    @JSOptionDefinition(
            name = "wait_for_events",
            description = "A list of events required before order will start separated with a semicolon.",
            key = "wait_for_events",
            type = "SOSOptionString",
            mandatory = false
    )
    public SOSOptionString wait_for_events = new SOSOptionString(
            this,
            conClassName + ".wait_for_events", // HashMap-Key
            "", // Titel
            "", // InitValue
            "", // DefaultValue
            false // isMandatory
    );

    public void setWait_for_events(SOSOptionString wait_for_events) {
        this.wait_for_events = wait_for_events;
    }

    // option bootstrap -----------------------------------------------------------------------------------------
    @JSOptionDefinition(
            name = "bootstrap",
            description = "Indicates the bootstrap order.",
            key = "bootstrap",
            type = "SOSOptionBoolean",
            mandatory = false
    )
    public SOSOptionBoolean bootstrap = new SOSOptionBoolean(
            this,
            conClassName + ".bootstrap", // HashMap-Key
            "", // Titel
            "", // InitValue
            "", // DefaultValue
            false // isMandatory
    );

    public void setBootstrap(SOSOptionBoolean bootstrap) {
        this.bootstrap = bootstrap;
    }

    // option on_demand -----------------------------------------------------------------------------------------
    @JSOptionDefinition(
            name = "on_demand",
            description = "Indicates that the order will start on demand only.",
            key = "on_demand",
            type = "SOSOptionBoolean",
            mandatory = false
    )
    public SOSOptionBoolean on_demand = new SOSOptionBoolean(
            this,
            conClassName + ".on_demand", // HashMap-Key
            "", // Titel
            "", // InitValue
            "", // DefaultValue
            false // isMandatory
    );

    public void setOn_demand(SOSOptionBoolean on_demand) {
        this.on_demand = on_demand;
    }


    // option error_handler-------------------------------------------------------------------------------------
    @JSOptionDefinition(
            name = "error_handler",
            description = "Indicates whether a node calls the default error handling in case of error.",
            key = "error_handler",
            type = "SOSOptionBoolean",
            mandatory = false
    )
    public SOSOptionBoolean error_handler = new SOSOptionBoolean(
            this,
            conClassName + ".error_handler", // HashMap-Key
            "", // Titel
            "true", // InitValue
            "true", // DefaultValue
            false // isMandatory
    );

    public void setError_handler(SOSOptionBoolean error_handler) {
        this.error_handler = error_handler;
    }

    // option error_handler-------------------------------------------------------------------------------------
    @JSOptionDefinition(
            name = "error_handler_script",
            description = "Script for error_handling.",
            key = "error_handler_script",
            type = "SOSOptionString",
            mandatory = false
    )
    public SOSOptionString error_handler_script = new SOSOptionString(
            this,
            conClassName + ".error_handler_script", // HashMap-Key
            "", // Titel
            "", // InitValue
            "", // DefaultValue
            false // isMandatory
    );

    public void setError_handler_script(SOSOptionString error_handler_script) {
        this.error_handler_script = error_handler_script;
    }

    // option subnet ---------------------------------------------------------------------------------------------
    @JSOptionDefinition(
            name = "subnet",
            description = "The subnet of the order.",
            key = "subnet",
            type = "SOSOptionString",
            mandatory = false
    )
    public SOSOptionString subnet = new SOSOptionString(
            this,
            conClassName + ".subnet", // HashMap-Key
            "", // Titel
            "", // InitValue
            "", // DefaultValue
            false // isMandatory
    );

    public void setSubnet(SOSOptionString subnet) {
        this.subnet = subnet;
    }

    // option connector--------------------------------------------------------------------------------------------
    @JSOptionDefinition(
            name = "connector",
            description = "The connector of the order.",
            key = "connector",
            type = "SOSOptionString",
            mandatory = false
    )
    public SOSOptionString connector = new SOSOptionString(
            this,
            conClassName + ".connector", // HashMap-Key
            "", // Titel
            "", // InitValue
            "", // DefaultValue
            false // isMandatory
    );

    public void setConnector(SOSOptionString connector) {
        this.connector = connector;
    }

    // --------------------------------------------------------------------------------------------------------------
    /**
     * A list of task comma separated list of task errors that will be ignored. Ranges of errors can be specified with
     * the pattern "from-to", e.g. 2-4 means the errors 2, 3 and 4 will be ignored.
     */
    @JSOptionDefinition(name = "valid_errors", description = "", key = "valid_errors", type = "SOSOptionExitCodeList", mandatory = false)
    public SOSOptionExitCodeList valid_errors = new SOSOptionExitCodeList(this,
            conClassName + ".valid_errors", // HashMap-Key
            "", // Titel
            " ", // InitValue
            " ", // DefaultValue
            false // isMandatory
    );

    public void setvalid_errors(SOSOptionExitCodeList valid_errors) {
        this.valid_errors = valid_errors;
    }

    // ---------------------------------------------------------------------------------------------------------
    public JobnetOrderOptions() {
        objParentClass = this.getClass();
    }

    public JobnetOrderOptions(JSListener pobjListener) {
        this();
        this.registerMessageListener(pobjListener);
    }

    public JobnetOrderOptions (HashMap <String, String> JSSettings) throws Exception {
        this();
        this.setAllOptions(JSSettings);
    }

    public void setAllOptions(HashMap <String, String> pobjJSSettings) {
        flgSetAllOptions = true;
        objSettings = pobjJSSettings;
        super.Settings(objSettings);
        super.setAllOptions(pobjJSSettings);
        flgSetAllOptions = false;
    }

    @Override
    public void CheckMandatory() {
        try {
            super.CheckMandatory();
        }
        catch (Exception e) {
            throw new JSExceptionMandatoryOptionMissing(e.toString());
        }
    }

    @Override
    public void CommandLineArgs(String[] pstrArgs) {
        super.CommandLineArgs(pstrArgs);
        this.setAllOptions(super.objSettings);
    }

}