package com.sos.jobnetmodel.objects;

import com.sos.JSHelper.Exceptions.JobSchedulerException;

import java.util.HashMap;

public class JobnetAdapter {

    private final HashMap<String,ExternalJobnetNodeObject> records = new HashMap<String,ExternalJobnetNodeObject>();
    private ExternalJobnetNodeObject bootstrapNode;
    private boolean allowInvalidNodes = false;

    public void addNode(ExternalJobnetNodeObject node) {
        if(node.isBootstrap()) {
            if (bootstrapNode != null)
                throw new JobSchedulerException("Bootstrap node is already set to " + bootstrapNode.getInternalId());
            bootstrapNode = node;
        }
        if(node.getInternalId() == null)
            throw new JobSchedulerException("node " + node.getName() + " has no ID.");
        records.put(node.getInternalId(), node);
    }

    public ExternalJobnetNodeObject getBootstrapNode() {
        return bootstrapNode;
    }

    public void setAllowInvalidNodes(Boolean allowInvalidNodes) {
        this.allowInvalidNodes = allowInvalidNodes;
    }

    public ExternalJobnetNodeObject getNode(String id) {
        if(!records.containsKey(id) && !allowInvalidNodes)
           throw new JobSchedulerException("A node with id " + id + " is not present in the jobnet - use setAllowInvalidNodes(true) to avoid this exception.");
        return records.get(id);
    }

    public int numberOfNodes() {
        return records.size();
    }

}
