package com.sos.jobnetmodel.tools;

import com.sos.JSHelper.Exceptions.JobSchedulerException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.File;
import java.net.MalformedURLException;
import java.net.URISyntaxException;
import java.net.URL;

public class Utils {

    private final static Logger logger = LoggerFactory.getLogger(Utils.class);

    private Utils() {}

    public static URL fileAsURL(File file) {
        URL result = null;
        try {
            result = file.toURI().toURL();
        } catch (MalformedURLException e) {
            String msg = "Error to convert file object to URL.";
            logger.error(msg,e);
            throw new JobSchedulerException(msg,e);
        }
        return result;
    }

    public static File urlAsFile(URL url) {
        File result = null;
        try {
            result = new File(url.toURI());
        } catch (URISyntaxException e) {
            String msg = "Error to convert URL object to File.";
            logger.error(msg,e);
            throw new JobSchedulerException(msg,e);
        }
        return result;
    }


}
