package com.sos.scheduler.model.commands;

import java.math.BigInteger;

import org.apache.log4j.Logger;

import com.sos.scheduler.model.SchedulerObjectFactory;
import com.sos.scheduler.model.objects.Params;
import com.sos.scheduler.model.objects.RunTime;
import com.sos.scheduler.model.objects.XmlPayload;

/**
* \class JSCmdModifyOrder 
* 
* \brief JSCmdModifyOrder - 
* 
* \details
*
* \section JSCmdModifyOrder.java_intro_sec Introduction
*
* \section JSCmdModifyOrder.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author oh
* @version $Id: JSCmdModifyOrder.java 25135 2014-05-28 07:19:10Z ur $
* \see reference
*
* Created on 08.02.2011 14:46:47
 */

/**
 * @author oh
 *
 */
public class JSCmdModifyOrder extends ModifyOrder {

    @SuppressWarnings("unused")
    private final String        conClassName = "JSCmdModifyOrder";
    @SuppressWarnings("unused")
    private static final Logger logger       = Logger.getLogger(JSCmdModifyOrder.class);

    public JSCmdModifyOrder(SchedulerObjectFactory schedulerObjectFactory) {
        super();
        objFactory = schedulerObjectFactory;
    }

    /**
    * 
    * \brief setParams
    * 
    * \details
    *
    * \return Params
    *
    * @param pstrParamArray
    * @return
    */
    public Params setParams(String[] pstrParamArray) {

        @SuppressWarnings("unused")
        final String conMethodName = conClassName + "::setParams";

        Params objParams = objFactory.setParams(pstrParamArray);
        super.setParams(objParams);

        return objParams;
    } // private Params setParams

  

    /**
     * Sets the value of the xmlPayload property.
     * 
     */
    public void setXmlPayloadIfNotEmpty(XmlPayload value) {
        if (value != null) {
            super.setXmlPayload(value);
        }
    }

   

    /**
     * Sets the value of the jobChain property.
     * 
     */
    public void setJobChainIfNotEmpty(String value) {
        if (!isEmpty(value)) {
            super.setJobChain(value);
        }
    }

    /**
     * Sets the value of the order property.
     * 
     */
    public void setOrderIfNotEmpty(String value) {
        if (!isEmpty(value)) {
            super.setOrder(value);
        }
    }

    /**
     * Sets the value of the priority property.
     * 
     */
    public void setPriorityIfNotEmpty(String value) {
        if (!isEmpty(value)) {
            BigInteger p = new BigInteger(value);
            super.setPriority(p);
        }
    }

    /**
     * Sets the value of the title property.
     * 
     */
    public void setTitleIfNotEmpty(String value) {
        if (!isEmpty(value)) {
            super.setTitle(value);
        }
    }

    /**
     * Sets the value of the state property.
     * 
     */
    public void setStateIfNotEmpty(String value) {
        if (!isEmpty(value)) {
            super.setState(value);
        }
    }

    /**
     * Sets the value of the setback property.
     * 
     */
    public void setSetbackIfNotEmpty(String value) {
        if (!isEmpty(value)) {
            super.setSetback(value);
        }
    }

    /**
     * Sets the value of the suspended property.
     * 
     */
    public void setSuspendedIfNotEmpty(String value) {
        if (!isEmpty(value)) {
            super.setSuspended(value);
        }
    }

    /**
     * Sets the value of the at property.
     * 
     */
    public void setAtIfNotEmpty(String value) {
        if (!isEmpty(value)) {
            super.setAt(value);
        }
    }

    /**
     * Sets the value of the endState property.
     * 
     */
    public void setEndStateIfNotEmpty(String value) {
        if (!isEmpty(value)) {
            super.setEndState(value);
        }
    }

    /**
     * Sets the value of the action property.
     * 
     */
    public void setActionIfNotEmpty(String value) {
        if (!isEmpty(value)) {
            super.setAction(value);
        }
    }

}
