package com.sos.scheduler.model.objects;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

import org.apache.log4j.Logger;
import org.joda.time.DateTime;
import org.joda.time.DateTimeComparator;
import org.joda.time.Interval;
import org.joda.time.format.DateTimeFormat;
import org.joda.time.format.DateTimeFormatter;

import com.sos.scheduler.model.SchedulerObjectFactory;
import com.sos.scheduler.model.tools.JodaTools;

/**
* \class JSObjWeekdaysDays 
* 
* \brief JSObjWeekdaysDays - 
* 
* \details
*
* \section JSObjWeekdaysDays.java_intro_sec Introduction
*
* \section JSObjWeekdaysDays.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author oh
* @version $Id: JSObjHolidaysWeekdaysDay.java 20718 2013-07-18 18:16:10Z kb $
* \see reference
*
* Created on 09.02.2011 15:24:39
 */

/**
 * @author ss
 *
 */
	public class JSObjHolidaysWeekdaysDay extends Holidays.Weekdays.Day {
		
		private static final Logger	logger			= Logger.getLogger(JSObjWeekdays.class);

		public JSObjHolidaysWeekdaysDay (SchedulerObjectFactory schedulerObjectFactory) {
			super();
			objFactory = schedulerObjectFactory;
		}

		public List<DateTime> getDtHolidays(Interval timeRange) {
			List<DateTime> result = new ArrayList<DateTime>();
			List<DateTime> work = getNextSingleStarts(timeRange.getStart());
			for(DateTime date : work) {
				if(timeRange.contains(date)) {
					while(timeRange.contains(date)) {
						result.add(date);
						date = date.plusWeeks(1);
					}
				}
			}
			Collections.sort(result, DateTimeComparator.getInstance());
			return result;
		}

		private List<DateTime> getNextSingleStarts(DateTime baseDate) {
			DateTimeFormatter fmtDate = DateTimeFormat.forPattern("yyyy-MM-dd");
			DateTimeFormatter fmtDateTime = DateTimeFormat.forPattern("yyyy-MM-dd HH:mm:ss");
			List<DateTime> result = new ArrayList<DateTime>();
			logger.debug(getDay().size() + " day elements detected.");
			Iterator<String> it = getDay().iterator();
			while(it.hasNext()) {
				String dayString = it.next();
				logger.debug("parsing day string " + dayString);
				List<Integer> days = JodaTools.getJodaWeekdays(dayString);
				for (int i = 0; i < days.size(); i++) {
					DateTime nextWeekDay = JodaTools.getNextWeekday(baseDate, days.get(i));
					logger.debug("calculated date " + fmtDate.print(nextWeekDay));
					if (nextWeekDay.isBefore(baseDate)) {
						nextWeekDay = nextWeekDay.plusWeeks(1);
						logger.debug("start is corrected to " + fmtDateTime.print(nextWeekDay));
					}
					result.add( nextWeekDay );
				}
				Collections.sort(result, DateTimeComparator.getInstance());
			}
			return result;
		}

	}
